# !/usr/bin/env python
# coding=utf-8
"""
pip install sqlalchemy
pip install pymysql
pip install mysql-connector-python
pip3 install pandas
"""

from ruoka import ruoka
from vaate import vaate
from kodinkone import kodinkone
from datetime import datetime
#import MySQLdb, sys
from mysql_python import MysqlPython
import pymysql.cursors
import os
from mysql.connector import Error
from mysql.connector import errorcode
import mysql.connector
import pandas as pd
import sqlalchemy as db


# specify database configurations
def create_db_connection():
    config = {
        'host': 'localhost',
        'port': 3306,
        'user': 'root',
        'password': 'mypass',
        'database': 'Tuotteet'
    }
    conn = mysql.connector.connect(**config)
    return conn


        
def read_query(query):
    conn = create_db_connection()
    cursor = conn.cursor()
    result = None
    try:
        cursor.execute(query)
        result = cursor.fetchall()
        return result    
    except Error as err:
        print(f"Error: '{err}'") 
    finally:
        conn.close()
        cursor.close()
        print("MySQL yhteys suljettiin")

def execute_query(query):
    conn = create_db_connection()
    cursor = conn.cursor()
    try:
        cursor.execute(query)
        conn.commit()
        print("Query successful")
    except Error as err:
        print(f"Error: '{err}'")
    finally:
        conn.close()
        cursor.close()
        print("MySQL yhteys suljettiin")
    
    
def addRuoka(nimi, hinta, hyllypaikka, koodi, maa, paivays):
    try:
  # Open database connection
        conn = create_db_connection()
        cursor = conn.cursor()
        cursor.execute('''INSERT INTO Tuotteet.ruoka (nimi, hinta, hyllypaikka, koodi, maa, paivays)
                       VALUES (%s, %s, %s, %s, %s, %s);''', (nimi, hinta, hyllypaikka, koodi, maa, paivays))
                   
    # Commit your changes in the database
        conn.commit()
        print("Successfully added entry to database")
    except Error as err:
        print(f"Error: '{err}'")
    finally:
        conn.close()
        cursor.close()
        print("MySQL yhteys suljettiin")
        
def addVaate(nimi, hinta, hyllypaikka, koodi, koko, materiaali):
    try:
  # Open database connection
        conn = create_db_connection()
        cursor = conn.cursor()
        cursor.execute('''INSERT INTO Tuotteet.vaate (nimi, hinta, hyllypaikka, koodi, koko, materiaali)
                       VALUES (%s, %s, %s, %s, %s, %s);''', (nimi, hinta, hyllypaikka, koodi, koko, materiaali))
                   
    # Commit your changes in the database
        conn.commit()
        print("Successfully added entry to database")
    except Error as err:
        print(f"Error: '{err}'")
    finally:
        conn.close()
        cursor.close()
        print("MySQL yhteys suljettiin")
        
def addKodinkone(nimi, hinta, hyllypaikka, koodi, takuu, paino):
    try:
  # Open database connection
        conn = create_db_connection()
        cursor = conn.cursor()
        cursor.execute('''INSERT INTO Tuotteet.kodinkone (nimi, hinta, hyllypaikka, koodi, takuu, paino)
                       VALUES (%s, %s, %s, %s, %s, %s);''', (nimi, hinta, hyllypaikka, koodi, takuu, paino))
                   
    # Commit your changes in the database
        conn.commit()
        print("Successfully added entry to database")
    except Error as err:
        print(f"Error: '{err}'")
    finally:
        conn.close()
        cursor.close()
        print("MySQL yhteys suljettiin")
        
def readAllRuoka():
    query = ("SELECT * FROM ruoka")
    results = read_query(query)
    columns = ["id", "nimi", "hinta", "hyllypaikka", "koodi", "maa", "paivays"]
    df = pd.DataFrame(results, columns=columns)
    print(df)
        
def readAllVaate():
    query = ("SELECT * FROM vaate")
    results = read_query(query)
    columns = ["id", "nimi", "hinta", "hyllypaikka", "koodi", "koko", "materiaali"]
    df = pd.DataFrame(results, columns=columns)
    print(df)
        
def readAllKodinkone():
    query = ("SELECT * FROM kodinkone")
    results = read_query(query)
    columns = ["id", "nimi", "hinta", "hyllypaikka", "koodi", "takuu", "paino"]
    df = pd.DataFrame(results, columns=columns)
    print(df)
    
def deleteRuoka(data):
    try:
        conn = create_db_connection()
        cursor = conn.cursor()      
        deleteQuery = """Delete from ruoka where id = %s"""
        deleteData = (data)
        cursor.execute(deleteQuery, (deleteData,))
        conn.commit()
        print("Poisto onnistui ")

    except mysql.connector.Error as error:
        print("Poisto epäonnistui: {}".format(error))

    finally:
        conn.close()
        cursor.close()
        print("MySQL yhteys suljettiin")

def deleteVaate(data):
    try:
        conn = create_db_connection()
        cursor = conn.cursor()      
        deleteQuery = """Delete from vaate where id = %s"""
        deleteData = data
        cursor.execute(deleteQuery, (deleteData,))
        conn.commit()
        print("Poisto onnistui ")

    except mysql.connector.Error as error:
        print("Poisto epäonnistui: {}".format(error))

    finally:
        conn.close()
        cursor.close()
        print("MySQL yhteys suljettiin")

def deleteKodinkone(data):
    try:
        conn = create_db_connection()
        cursor = conn.cursor()      
        deleteQuery = """Delete from kodinkone where id = %s"""
        deleteData = (data)
        cursor.execute(deleteQuery, (deleteData,))
        conn.commit()
        print("Poisto onnistui ")

    except mysql.connector.Error as error:
        print("Poisto epäonnistui: {}".format(error))

    finally:
        conn.close()
        cursor.close()
        print("MySQL yhteys suljettiin")

def updateRuoka(hinta, id):
    try:
        conn = create_db_connection()
        cursor = conn.cursor()

        # Update single record now
        updateQuery = "UPDATE ruoka SET hinta = %s WHERE id = %s"
        updateData = (hinta, id)
        cursor.execute(updateQuery, updateData)
        conn.commit()
        print("Päivitys onnistui ")

    except mysql.connector.Error as error:
        print("Päivitys epäonnistui: {}".format(error))

    finally:
        conn.close()
        cursor.close()
        print("MySQL yhteys suljettiin")

def updateVaate(hinta, id):
    try:
        conn = create_db_connection()
        cursor = conn.cursor()

        # Update single record now
        updateQuery = "UPDATE vaate SET hinta = %s WHERE id = %s"
        updateData = (hinta, id)
        cursor.execute(updateQuery, updateData)
        conn.commit()
        print("Päivitys onnistui ")
    except mysql.connector.Error as error:
        print("Päivitys epäonnistui: {}".format(error))

    finally:
        conn.close()
        cursor.close()
        print("MySQL yhteys suljettiin")
    

def updateKodinkone(hinta, id):
    try:
        conn = create_db_connection()
        cursor = conn.cursor()

        # Update single record now
        updateQuery = "UPDATE kodinkone SET hinta = %s WHERE id = %s"
        updateData = (hinta, id)
        cursor.execute(updateQuery, updateData)
        conn.commit()
        print("Päivitys onnistui ")

    except mysql.connector.Error as error:
        print("Päivitys epäonnistui: {}".format(error))

    finally:
        conn.close()
        cursor.close()
        print("MySQL yhteys suljettiin")

def listaaVarasto():
    try:
        conn = create_db_connection()
        cursor = conn.cursor()
        query = "SELECT SUM(hinta) FROM ruoka"
        summa1 = read_query(query)
        query = "SELECT SUM(hinta) FROM vaate"
        summa2 = read_query(query)
        query = "SELECT SUM(hinta) FROM kodinkone"
        summa3 = read_query(query)
        varastosaldot = (summa1+summa2+summa3)
        print(varastosaldot)
    except mysql.connector.Error as error:
        print("Päivitys epäonnistui: {}".format(error))

    finally:
        conn.close()
        cursor.close()
        print("MySQL yhteys suljettiin")
    
def tulostaRuokatiedot(koodi):
    try:
        conn = create_db_connection()
        cursor = conn.cursor()
        select_query = """select * from ruoka where koodi = %s"""
        cursor.execute(select_query, (koodi,))
        records = cursor.fetchall()
        print("Tulostetaan tuotetiedot")
        for row in records:
            print("ID:", row[0])
            print("Nimi:", row[1])
            print("Hinta:", row[2])
            print("Hyllypaikka:", row[3])
            print("Koodi:", row[4])
            print("Maa:", row[5])
            print("Päiväys:", row[6])
        
    except mysql.connector.Error as error:
        print("Päivitys epäonnistui: {}".format(error))

    finally:
        conn.close()
        cursor.close()
        print("MySQL yhteys suljettiin")
        
def tulostaVaatetiedot(koodi):
    try:
        conn = create_db_connection()
        cursor = conn.cursor()
        select_query = """select * from vaate where koodi = %s"""
        cursor.execute(select_query, (koodi,))
        records = cursor.fetchall()
        print("Tulostetaan tuotetiedot")
        for row in records:
            print("ID:", row[0])
            print("Nimi:", row[1])
            print("Hinta:", row[2])
            print("Hyllypaikka:", row[3])
            print("Koodi:", row[4])
            print("Koko:", row[5])
            print("Materiaali:", row[6])
        
    except mysql.connector.Error as error:
        print("Päivitys epäonnistui: {}".format(error))

    finally:
        conn.close()
        cursor.close()
        print("MySQL yhteys suljettiin")
        
def tulostaKodinkonetiedot(koodi):
    try:
        conn = create_db_connection()
        cursor = conn.cursor()
        select_query = """select * from kodinkone where koodi = %s"""
        cursor.execute(select_query, (koodi,))
        records = cursor.fetchall()
        print("Tulostetaan tuotetiedot")
        for row in records:
            print("ID:", row[0])
            print("Nimi:", row[1])
            print("Hinta:", row[2])
            print("Hyllypaikka:", row[3])
            print("Koodi:", row[4])
            print("Takuu:", row[5])
            print("Paino:", row[6])
       
    except mysql.connector.Error as error:
        print("Päivitys epäonnistui: {}".format(error))

    finally:
        conn.close()
        cursor.close()
        print("MySQL yhteys suljettiin")
        
def tulostaVanhatRuuat():
    try:
        conn = create_db_connection()
        cursor = conn.cursor()
        select_query = """SELECT * FROM ruoka WHERE paivays BETWEEN DATE_SUB(NOW(), INTERVAL 30 DAY) AND NOW()"""
        cursor.execute(select_query)
        records = cursor.fetchall()
        print("Tulostetaan vanhenemassa olevat tuotetiedot")
        for row in records:
            print("ID:", row[0])
            print("Nimi:", row[1])
            print("Hinta:", row[2])
            print("Hyllypaikka:", row[3])
            print("Koodi:", row[4])
            print("Maa:", row[5])
            print("Paivays:", row[6])
        
    except mysql.connector.Error as error:
        print("Päivitys epäonnistui: {}".format(error))

    finally:
        conn.close()
        cursor.close()
        print("MySQL yhteys suljettiin")




        
#Main program here!

##Testi pääohjelma
if __name__ == "__main__":
    
    #conn = create_db_connection("localhost", "3306", "root", "mypass", "Tuotteet") # Connect to the Database
    #conn = create_db_connection()
    tuote_lista = list()
    valinta = 0
    while True:
        valinta = input("Minkä tehtävän haluat suorittaa (Lisää Ruoka = 1, Lisää vaate = 2, Lisää kodinkone = 3, 4 = Tulosta tuotteet, 5 = Poista tuote, 6 = Hinnan päivitys, 7 = Tulosta varaston arvo, 8 = Tulosta tuotekoodilla, 9 = Haen vanhat tuotteet, muu = Lopetus:")
        try:
            int(valinta)
        except ValueError:
            break
        else:
            
            if int(valinta) == 1:
                conn = create_db_connection() # Connect to the Database               
                nimi = str(input("Anna tuotteen nimi: "))
                hinta = float(input("Anna hinta: "))
                hyllypaikka = str(input("Anna hyllypaikka: "))
                koodi = str(input("Anna koodi: "))
                maa = str(input("Ruuan alkuperämaa: "))
                now = datetime.now()
                #pvm = str(input("Anna parasta ennen päiväys: "))
                paivays = str(now)[:10]
                #print(paivays)
                tuote_lista.append(ruoka(nimi, hinta, hyllypaikka, koodi, maa, paivays))
                addRuoka(nimi, hinta, hyllypaikka, koodi, maa, paivays)
                print(ruoka)
            elif int(valinta) == 2:
                conn = create_db_connection() # Connect to the Database
                nimi = str(input("Anna tuotteen nimi: "))
                hinta = float(input("Anna hinta: "))
                hyllypaikka = str(input("Anna hyllypaikka: "))
                koodi = str(input("Anna koodi: "))
                koko = str(input("Vaatteen koko: "))
                materiaali = str(input("Vaatteen materiaali: "))
                tuote_lista.append(vaate(nimi, hinta, hyllypaikka, koodi, koko, materiaali))
                addVaate(nimi, hinta, hyllypaikka, koodi, koko, materiaali)
            elif int(valinta) == 3:
                conn = create_db_connection() # Connect to the Database
                nimi = str(input("Anna tuotteen nimi: "))
                hinta = float(input("Anna hinta: "))
                hyllypaikka = str(input("Anna hyllypaikka: "))
                koodi = str(input("Anna koodi: "))
                takuu = str(input("Kodinkoneen takuu: "))
                paino = str(input("Kodinkoneen paino: "))
                tuote_lista.append(kodinkone(nimi, hinta, hyllypaikka, koodi,takuu, paino))
                addKodinkone(nimi, hinta, hyllypaikka, koodi, takuu, paino)
            elif int(valinta) == 4:
                readAllRuoka()
                readAllVaate()
                readAllKodinkone()
            elif int(valinta) == 5: 
                 while True:
                    tuote = (input("Valitse poistettava tuote: (1 = Ruoka, 2 = Vaate, 3 = Kodinkone, muu = Lopetus) "))
                    try:
                        int(tuote)
                    except ValueError:
                        break
                    else:
                        if int(tuote) == 1:
                            id = str(input("Anna tuotteen id: "))
                            deleteRuoka(id)
                        elif int(tuote) == 2:
                            id = str(input("Anna tuotteen id: "))
                            deleteVaate(id)
                        elif int(tuote) == 3:
                            id = str(input("Anna tuotteen id: "))
                            deleteKodinkone(id)
                                 
                   
            elif int(valinta) == 6:
                while True:
                    tuote = (input("Valitse päivitettävä tuote: (1 = Ruoka, 2 = Vaate, 3 = Kodinkone, muu = Lopetus) "))
                    try:
                        int(tuote)
                    except ValueError:
                        break
                    else:
                        if int(tuote) == 1:
                            id = str(input("Anna tuotteen id: "))
                            hinta = float(input("Anna uusi hinta: "))
                            updateRuoka(hinta, id)
                        elif int(tuote) == 2:
                            id = str(input("Anna tuotteen id: "))
                            hinta = float(input("Anna uusi hinta: "))
                            updateVaate(hinta, id)
                        elif int(tuote) == 3:
                            id = str(input("Anna tuotteen id: "))
                            hinta = float(input("Anna uusi hinta: "))
                            updateKodinkone(hinta, id)
            elif int(valinta) == 7:                 
                 listaaVarasto()
            elif int(valinta) == 8:
                while True:
                    tuote = (input("Anna tulostettava tuote: (1 = Ruoka, 2 = Vaate, 3 = Kodinkone, muu = Lopetus) "))
                    try:
                        int(tuote)
                    except ValueError:
                        break
                    else:
                        if int(tuote) == 1:
                            koodi = (input("Anna tuotteen koodi: "))
                            tulostaRuokatiedot(koodi)
                        elif int(tuote) == 2:
                            koodi = (input("Anna tuotteen koodi: "))
                            tulostaVaatetiedot(koodi)
                        elif int(tuote) == 3:
                            koodi = (input("Anna tuotteen koodi: "))
                            tulostaKodinkonetiedot(koodi)
            elif int(valinta) == 9:                 
                 tulostaVanhatRuuat()
            
                
                

                

    
        