# 01: Jupyterhub ympäristön käyttöönotto

![alt text](images/01_jhub_banner.PNG "KAMK Jupyterhub")

Jupyterhubin sisäänkirjautuminen tapahtuu https://gitlab.dclabra.fi/ -tunnuksilla. Jos sinulla ei vielä ole tunnusta, niin luo sellainen. Tunnuksen luonti onnistuu @kamk.fi -päätteisestä mailiosoitteesta. Jos olet saanut tämän repon näkyviin, niin sinulla pitäisi olla jo tunnukset!

## Muutama Jupyterlab-ympäristön nyrkkisääntö

- Rivinvaihto solussa tapahtuu Enter-painikkeella
- Solun ajaminen onnistuu Shift+Enter -näppäinyhdistelmällä.
- Jos käytät Notebookin Save and Export Notebook As PDF -toimintoa, niin soluissa ei saa olla virheviestejä (virheviestit estävät export as pdf-toiminnon).
- Solun outputin (ja samalla tulostuneet virheet) saat poistettua, kun klikkaat solua oikealla hiiren näppäimellä ja valitset "Clear Outputs"
- Jos Notebook on liian pitkään käyttämättä, eli et aja yhtää solua pitkään aikaan, niin MariaDB-kernel saattaa sammuttaa itsensä. Tällöin kernelin saa uudelleenkäynnistettyä valikosta: Kernel -> Restart Kernel...
- Jos Notebook-ikkunan näkymä muuttuu yhtäkkiä oudoksi, niin tarkasta "View" -valikosta, että et ole painanut mitään näppäinyhdistelmää, joka muuttaa Notebookin näkymää.
- Settings-valikosta voit vaihtaa Notebookin teemaa itsellesi sopivaksi (esim. Jhub Dark)

## Jupyterlab yhdistäminen ja MariaDB Notebook

KAMK-Jupyterlabista löytyy MariaDB-kernel. Käytännössä se tarkoittaa sitä, että Jupyterhub-alustalla voi käynnistää oman MariaDB-serverin ja käyttää sitä, kuten oikeaa tietokantapalvelinta (pienin rajoituksin).

Yhdistys ja kirjautuminen Jupyterhubiin menee, kuten edellisessä kohdassa:

1. Avaa Jupyter-notebook osoitteesta: https://jupyterhub.dclabra.fi/
  - Kirjautuminen gitlab.dclabra.fi -tunnuksilla.
2. Valitse CPU-kontainer
  - Personal, 4 CPU cores, 16GB RAM & 40GB of HHD storage
3. Käynnistä MariaDB Notebook .

Odota, että kontti käynnistyy. Käynnistyksen jälkeen valitse Launcherista (File -> New Launcher) oranssi MariaDB-ikoni, joka avaa uuden MariaDB-notebookin. Tässä vaiheessa Jupyterlab-ympäristö käynnistää käyttäjälle oman tietokantapalvelimen Notebook-konttiin. Tarkista tässä vaiheessa, että MariaDB-kernel on käynnistynyt viemällä hiiri oikeaan yläkulmaan MariaDB-kernel status ikonin päälle. Jos kernel käynnistyi oikein, niin tilan pitäisi olla "Idle"

![MariaDB kernel idle](images/mariadb_notebook_kernel_idle.PNG)

4. Testaa, että tietokantakomennot menevät perille kirjoittamalla komento soluun. Komennon saa ajettua shift+enter näppäinyhdistelmällä. Esimerkiksi komento SHOW DATABASES; pitäisi näyttää mysql tietokannat. Jos komennon ajaminen ei tulosta mitään, niin siirry troubleshooting-osioon.

## Jupyterlab yhdistäminen Notebookissa käynnissä olevalle MariaDB-palvelimelle Jupyterhub komentoriviltä

Jupyter Notebookin kautta tietokannan käskyjen ajo ei ole täysin autenttista. Jos haluat kokeilla Jupyterlab-kontissasi oikeaa MariaDB-komentorivityökalua, niin noudata tätä ohjetta. Kurssin suorituksen kannalta tämä ei ole välttämätöntä.

1. Valitse ensin Launcherista (File -> New Launcher) Terminal.

**Huom! Seuraava komento toimii vasta, kun MariaDB-kernel on käynnissä ja idle-tilassa. (ks. edellinen kohta)**

```
mysql -u root -p --socket=/tmp/mariadb_kernel/mysqld.sock
```

Salasana: MariaDB-palvelimen oletus-salasana, eli tyhjä (paina siis Enter)

Jos tässä vaiheessa tulee virhe yhdistäessä, niin se johtuu siitä, että MariaDB-palvelin on sammunut. Jupyterhub sammuttaa automaattisesti kernelin (MariaDB-palvelimen), jos sinne ei ajeta komentoja vähään aikaan. Kernelin uudelleenkäynnistys onnistuu avaamalla MariaDB-notebookin (Oranssi M-kuvake) ja sen jälkeen valitsemalla valikosta Kernel -> Restart Kernel...

Alla olevassa kuvassa on yhdistetty Jupyterlabissa pyörivään MariaDB-serveriin terminaalin avulla

![MariaDB from Notebook terminal](images/connect_mariadb_from_jhub_notebook_terminal.PNG)

## Troubleshooting:

Tässä osiossa ratkaisuja yleisimpiin ongelmiin MariaDB-Notebookin käytössä. Tarkasta ennen ongelmien selvitystä, että sinulla on Jupyterhub käynnissä vain yhdessä selainvälilehdessä.

Ongelma: MariaDB-kernel ei käynnisty. Kernelin status jää tilaan "Connecting", "Busy", tai jokin muu virhe.

Ratkaisu 1: Valitse Jupyterlabin valikosta "Kernel" -> "Restart Kernel..." Valitse seuraavaksi näyttöön ilmestyvästä valikosta "Restart". Katso sen jälkeen muuttuiko kernelin tila. Odota tässä vaiheessa hetkinen. Kernelin käynnistys kestää yleensä useita sekunteja. Jos ongelma ei poistunut, niin jatka seuraavaan kohtaan.

Ratkaisu 2: Uudelleenlataa selainikkuna (F5-näppäin) ja kokeile taas käynnistää kernel uudestaan edellisen kohdan tavoin. Jos ongelma ei ratkennut vieläkään, niin Notebook-serveri täytyy uudelleenkäynnistää.

Ratkaisu 3: Käynnistä koko Notebook-server uudestaan valitsemalla valikosta "File" -> "Hub Control Panel". Sammuta Notebook-server avautuvasta painikkeesta. Serverin sammumisessa kestää hetkinen. Kun serveri on sammunut, niin näyttöön pitäisi ilmestyä painike, jossa lukee "Start My Server". Edellä mainitun painikkeen jälkeen näyttöön pitäisi tulla sama serverin valinta ikkuna, kuin ensimmäisellä sisäänkirjautumisella. Valitse taas "Personal, 4 CPU cores, 16GB RAM & 40GB of HHD storage"

![Jupyterhub stop my server](images/jhub_stop_my_server.PNG)

Ongelma: Alla oleva komento tuottaa virheilmoituksen 

"ERROR 2002 (HY000): Can't connect to local server through socket '/tmp/mariadb_kernel/mysqld.sock' (2)
jovyan@jupyter-eerohu:~/Databases$"

```
mysql -u root -p --socket=/tmp/mariadb_kernel/mysqld.sock
```

Ratkaisu: Poistetaan korruptoitunut tietokanta tai toetokannat.
1. Shutdown all kernels
2. Varmista, että mariadb ei ole käynnissä ps aux
3. rm -rf /home/jovyan/work/.db/
4. MariaDB-Notebook käyntiin. Tietokanta tyhjä. 


[Takaisin etusivulle](https://gitlab.dclabra.fi/hulis/tietokantojen_perusteet_ja_tietokantaohjelmointi/) <----------> [02: MariaDB docker asennus](/02_mariadb_docker/)
