# 02: Docker asentaminen ja MariaDB-containerin (kontin) pystytys. (Extra)

### Docker containerin asennus Ubuntuun 

Tämän kurssin tehtäviä voi tehdä myös docker-ympäristössä, johon asennetaan MariaBD-tietokannan hallintaohjelmisto (DBMS).

Kurssin suorituksen kannalta tämä ei ole tarpeellista, mutta jos haluat harjoitella oman tietokannan asennusta ja käyttöä, niin docker-ympäristö on hyvä keino tutustua oikeaan tietokantaan.

Seuraavana ohjeet siihen, kuinka asennetaan Docker Ubuntuun tai johonkin muuhun Debian jakeluversioon tai Windows-käyttöjärjestelmällä varustettuun tietokoneeseen.

**VALITSE SIIS ALLA OLEVISTA VAIHTOEHDOISTA OMAN TIETOKONEESI KÄYTTÖJÄRJESTELMAN MUKAINEN ASENNUS**

## Docker-kontin asennus Ubuntuun

Asennus esimerkiksi Ubuntuun, Linux Mint ja muihin Debian distroihin menee seuraavalla loitsulla:

```shell=
curl -fsSL https://download.docker.com/linux/ubuntu/gpg | sudo apt-key add -
 apt-key fingerprint 0EBFCD88
 add-apt-repository    "deb [arch=amd64] https://download.docker.com/linux/ubuntu \
   $(lsb_release -cs) \
   stable"
 apt-get update
 apt-get upgrade -y
 apt-cache madison docker-ce
 apt-get install docker-ce
 docker --version
 ```
Testaus
```shell=
sudo docker run hello-world
eero@eero-VirtualBox:~$ sudo docker run hello-world

Hello from Docker!
```

Dockerin voi käynnistää komennolla:
```shell=
sudo systemctl start docker
``````
Ja sammutta komennolla:
```shell=
sudo systemctl enable docker
``````
Dockerin statuksen saa selville komennolla:
```shell=
sudo systemctl status docker
``````
Jotta Dockeria voidaan käyttää tavallisen käyttäjän oikeuksin, tulee dockeria käyttävät käyttäjät lisätä docker-ryhmään.

Joissain tapauksissa docker-ryhmä tulee ensin luoda. Muutokset tulevat voimaan uudelleenkirjautumisen jälkeen.

Käyttäjän oikeudet sudo useriksi
```shell=
sudo groupadd docker

sudo usermod -aG docker <käyttäjä>
``````
Testataan toimiiko Docker Hello wordl
```shell=
sudo docker run hello-world
```

# Install Docker on Windows 10

Docker for Windows now requires Microsoft’s Hyper-V. Once enabled, VirtualBox will no longer be able to run virtual machines (your VM images will still remain). You can still use docker-machine to manage remote hosts.

You have the option to import the default VM after installing Docker for Windows from the Settings menu in the System Tray.

Docker for Windows enables Hyper-V if necessary; this requires a reboot.

Requirements
Docker for Windows runs on 64-bit Windows 10 Pro, Enterprise, and Education; 1511 November update, Build 10586 or later. Docker plans to support more versions of Windows 10 in the future.

Installation - Download Docker.
Double-click Double-click InstallDocker.msi to run the installer.
https://www.simplilearn.com/tutorials/docker-tutorial/install-docker-on-windows

Follow the Install Wizard: accept the license, authorize the installer, and proceed with the install.
Click Finish to launch Docker.
Docker starts automatically.
Docker loads a “Welcome” window giving you tips and access to the Docker documentation.

That’s it!

https://www.shaileshjha.com/step-by-step-how-to-install-docker-in-windows/

### Ongelmia Windows asennuksen kanssa

Windows koneelle kannattaa asentaa MinGW: https://sourceforge.net/projects/mingw-w64/files/mingw-w64/mingw-w64-release/
Kannattaa asentaa uusin versio. Linkki Youtube-videoon: https://www.youtube.com/watch?v=FEeFG9OR-QU

Fortran ja Ada tuet voi jättää pois asennuksesta.

Mikäli käytät ohjelmoinnissa Visual Studio Codea (VSCode), kannattaa toimia videon esittämällä tavalla. MinGW mahdollistaa C/C++ koodien kääntäminen Windows-koneella.

https://code.visualstudio.com/docs/cpp/config-mingw

Windowsissa eteen voi tulla ongelmia johtuen Win10 ja Win11 eroavaisuuksista.
Yksi usein esiintyneistä ongelmista on se, että Docker ei pysyny käynnissä.

Ongelma korjaantuu sillä, että asentaa koneella WSL:n. Katso ohjeet linkistä.

https://learn.microsoft.com/fi-fi/windows/wsl/install-manual

Myöskin “Kaspersky” virustorjunta poistaa wsl:n toiminnasta, joten tarkista millaiset asetukset virustorjuntaohjelmaan on asennettu. Kasperskyn voi myös poistaa, jos koneessa on käytössä jonkin muu virustorjuntaohjelma.

Lisäksi kannattaa ajaa komentorivillä seuraava komento
```shell=
sc config LxssManager start=auto
```
# MariaDB 10.5 & 11.2 käyttöönotto


https://mariadb.com/kb/en/installing-and-using-mariadb-via-docker/


>> Esimerkissä isäntäkoneen portti `3307` on mäpätty kontin sisään porttiin `3306` (l. `3307:3306`. Näin toimitaan, koska sinulla voi olla esim. natiivi MariaDB/MysQL kuuntelemassa porttia 3306. MariaDB-versio 11.2 mäpätään porttiin 3308, eli voit ajaa eri tietokantaversioita konteissa samanaikaisesti.

## MariaDB 10.2

Ao. linkissä muutamia ohjeita, alla kuitenkin kattava komentolistaus, millä pärjäätte pitkälle. 

https://mariadb.com/kb/en/installing-and-using-mariadb-via-docker/

## Datan taltiointi

Luo Docker-levykuva (volume), johon taltioit tietokannan datan. 

```shell=
# Levyn luominen
docker volume create vol-mariadb-data

# Levyn tuhoaminen
docker volume rm vol-mariadb-data

# Tuhoaminen ei onnistu, mikäli levyä käyttävä kontti on käynnissä/olemassa. Näin ollen tuhoa ensin kontti joka levyä käyttää
```

Tämä levykuva säilyy koneillanne, kunnes tuhoatte sen itse. Eli data säilyy tallessa, vaikka ajaisitte alas / tuhoaisitte tietokantaa pyörittävän kontin. Voitte myös siirtää datan koneelta toiselle, jos vaikkapa luotte tietokantadumpin kontin sisällä ja siirrätte sen toiselle koneelle importattavaksi.

## Kontin hallinta

```shell=

# Käynnistä MariaDB-kontti
docker run --name mariadb10-kontti -v vol-mariadb-data:/var/lib/mysql -e MARIADB_ROOT_PASSWORD=mypass -p 3307:3306 -d docker.io/library/mariadb:10.5

# Ota komentoriviyhteys konttiin
docker exec -it mariadb10-kontti mysql -u root -pmypass


# Tuhoa kontti
docker rm -f mariadb10-kontti
```

## MariaDB 11.2

Mikäli loit volumen aiemmalle mariadb-versiolle, ongelmia voi olla tiedossa, koska tietokantamoottori päivittyy ison version 10 -> 11. Varmin keino on aloittaa puhtaalta pöydältä, tai määritellä kontti käyttämään eri volumea ja porttia, kuin yllä olevassa MariaDB 10.x esimerkissä.



```shell=
# Levyn luominen
docker volume create vol-mariadb11-data

# Levyn tuhoaminen
docker volume rm vol-mariadb11-data

# Tuhoaminen ei onnistu, mikäli levyä käyttävä kontti on käynnissä/olemassa. Näin ollen tuhoa ensin kontti joka levyä käyttää

# docker rm -f volumea_käyttävän_kontin_nimi
```

Tämä levykuva säilyy koneillanne, kunnes tuhoatte sen itse. Eli data säilyy tallessa, vaikka ajaisitte alas / tuhoaisitte tietokantaa pyörittävän kontin. Voitte myös siirtää datan koneelta toiselle, jos vaikkapa luotte tietokantadumpin kontin sisällä ja siirrätte sen toiselle koneelle importattavaksi.

## Kontin hallinta

Windows 10 -käyttäjät voi joutua käyttämään taikasanaa winpty noiden docker-komentojen edessä

```shell=

# Käynnistä MariaDB-kontti
docker run --name mariadb11-kontti -v vol-mariadb11-data:/var/lib/mysql -e MARIADB_ROOT_PASSWORD=mypass -p 3308:3306 -d docker.io/library/mariadb:11.2

# Ota komentoriviyhteys konttiin ja konffaa pääkäyttäjän salasana yms.
# kts. myös https://computingforgeeks.com/how-to-install-mariadb-11-on-ubuntu/
docker exec -it --user root mariadb11-kontti mariadb-secure-installation

# Ota lopuksi yhteys tietokantaan
# syötä salasanaksi se minkä konffasit yllä
docker exec -it mariadb11-kontti mariadb -u root -pmypass  


# Tuhoa kontti
docker rm -f mariadb11-kontti
```

Windows-koneilla tulee loitsia: 

```shell=
 winpty docker exec -it mariadb-kontti sh -c "mysql -u root -pmypass"

``````

[01: Jupyterhub ympäristön käyttöönotto](/ 01_jupyterhub_ympariston_kayttoonotto) <----------> [03: Johdantoa tietokantoihin](/03_johdantoa_tietokantoihin)
