# 03: Johdantoa tietokantoihin

![alt text](images/03_johdanto_header.png "Databases")

Sisällysluettelo:

[[_TOC_]]

Linkit-osiossa linkkejä ulkoisiin lähteisiin, joissa käydään tunnin asioita läpi englanniksi.

## Johdanto tietokantoihin

### Historiaa

- Sähköisten tietokantojen kehitys alkoi 1960-luvulla. Aluksi tietokannat olivat tiedostopohjaisia, verkkomallisia ja hierarkkisia
- Relaatiotietomalli kehitettiin 1970-luvulla Edgar F. Coddin toimesta ja se on toiminut teoreettisena pohjana nykypäivän relaatiotietokannoille
- Tieto esitetään tauluina (= relaatio)
- Talletettavan tiedon määrä on kasvanut ja kasvaa jatkuvasti, tiedon käsittely ja tallentaminen vaatii enemmän resursseja
- Relaatiotietokannoilla on mahdollista toteuttaa (hyvin) tehokkaita tietokantoja

### Tietokantatoteutuksia

- Toiminnallinen (operatiivinen)
  - Sovelluskohtaisia, jokapäiväistä toimintaa palvelevia
  - Tyypillisesti esim. toiminnanohjausjärjestelmä joka kerää ajankohtaista dataa
- Tietovarasto (data warehouse)
  - Laajempia tietopankkeja joihin tehdään laajempi päivityksiä/ajoja kertaluontoisesti esim. kerran päivässä/viikossa/kuukaudessa
  - Historiatietoa yrityksen toimintaan liittyen
  - Statistiikkakyselyitä, esim. neljännesvuosiraporttia varten
- Hajautetut tietokannat
  - Voivat olla pieniä toiminnallisia tietokantoja, esim. yritysten eri toimipisteissä

### Tietokannan suunnittelusta

- Tietokannan suunnittelu lähtee yleensä tarpeesta tallettaa rajattuun aihepiiriin liittyvää tietoa ”yhteen paikkaan”
- Termillä tiedonhallinta tarkoitetaan kaikkea tallennetun tiedon määrittelemiseen ja käyttämiseen liittyvää toimintaa.

**”Aika, jonka sijoitat vankan tietokantarakenteen suunnitteluun, on hyvin käytettyä aikaa.”**

(Lähde: Hernandez, Tietokannat – suunnittelu käytännössä)

### Miksi tietoa tallennetaan?

- Tiedon tulee olla helposti ja nopeasti saatavilla
- Tiedon keskittäminen helpottaa ylläpitoa ja varmistamista
- Keskitetty tietovarasto on usein
  - Yhteiskäyttöinen
    - Monta yhtaikaista käyttäjää
    - Käyttäjäkohtaisesti rajattu oikeus tietoon
  - Ajantasainen
    - Päivitetty tieto näkyy kaikille käyttäjille samanaikaisesti
  - Ei-toisteinen
    - Tieto on talletettu vain kertaalleen
  - Eheä
    - Tiedot ovat ristiriidattomia ja kuvaavat reaalimaailmaa
- Yritykset investoivat suuria summia rahaa tiedonhallintaan – investoinneille halutaan myös vastinetta

### Mitä tietoa tallennetaan?

- Tallennettava tieto vaihtelee tarpeiden mukaan
- Tyypillisessä yritystietokannassa ylläpidetään liiketoiminnan kannalta olennaista tietoa, esim.
  - Henkilöstö- ja materiaalihallinnointi, asiakassopimukset, tilaukset, toimitukset, kirjanpito ja laskutusasiat

### Mihin tietoa tallennetaan?

- Paperiarkistot, kortistot, yms. perinteiset menetelmät
- Henkilökohtaiset tieto- ja viestintävälineet (PC, matkapuhelin)
- Yrityskäytössä eri laitetoimittajien palvelinratkaisut (keskitetyt, hajautetut, virtualisoidut, ”pilvi”)
- HP, Sun Microsystems, Dell, IBM
- Myös kotitietokoneella pyöritellään monenlaisia tietokantasovelluksia
- Ohjelmistotarjonta monipuolinen: Microsoft SQL Server, MS Access, IBM DB2, Oracle, MySQL, MariaDB, SQLite, PostgreSQL, …
- Tietokantaohjelmistot toimivat muun muassa Windows-, Linux- ja Unix-käyttöjärjestelmissä

## Tietomallit

### Tietomallit

- Tietomalli (data model) on kuvausmenetelmä ja joukko sääntöjä, jolla voidaan kuvata tietorakenteita ja niiden välisiä yhteyksiä
- Tyypillisiä tietomalleja ovat käsitemalli, relaatiomalli ja oliomalli
- Em. kolmea tietomallia voidaan käyttää yhdessä esimerkiksi kuvaamalla kohdealue ensin käsitemallilla tai oliomallilla ja muodostamalla sitten tietokantaan relaatiomallin mukaiset taulurakenteet

### Tiedon abstraktiotasot

- Tietokantoja voidaan kuvata ja tietoa tarkastella kolmella eri tasolla
  - Käsitetaso (conceptual level)
    - Millaista tietoa tietokanta sisältää
    - Kaikki käsitteet (entities), niiden ominaisuudet (attribuutit) ja käsitteiden väliset suhteet (relationships)
    - ”Reaalimaailman asia”, ”ajatustaso”
  - Rakennetaso (structural level)
    - Millaisia käsiteltäviä rakenteita tiedot muodostavat
    - Ohjelmointikielet, esim. SQL (Structured Query Language)
  - Fyysinen taso (physical level)
    - Tietokannan fyysinen rakenne
    - Miten tieto on tallennettu (levyjärjestelmä, keskusmuisti, yms.)
    - Millaisia algoritmeja tiedon tallennuksessa ja hakemisessa käytetään

- Edellinen pähkinänkuoressa:
  - **KÄSITETASO** - Tietokannan sisällön suunnitelu
  - **RAKENNETASO** - SQL-kielen lauseet
  - **FYYSINEN TASO** - Järjestelmän rakenne ja suorituskyky, tietokannanhallintajärjestelmä

### Relaatiomalli

- Erittäin tiukkaan tiivistettynä:
  - E.F. Coddin rakennetason tietomalli 1970-luvulta
  - Malli perustuu näkemykseen, jossa tietokanta mielletään joukoksi tietoalkioiden muodostamia matemaattisia relaatioita
  - Yksinkertainen käsitteistö
  - Ymmärrettävissä taulukkomuotoisena esityksenä

### ER-malli

- Tietomalli kertoo
  - Mitä asioita (tietoja) tietokanta sisältää.
  - Miten asiat (tiedon osat) liittyvät toisiinsa.
- ER-malli
  - Kohde (käsite), attribuutti, yhteys
- Esitystekniikoissa eroja
  - Chenin notaatio vuodelta 1976
  - UML-notaatio on nykyaikainen tapa toteuttaa ER-malli
- Tietomalli on tarkoitettu ihmisille, ei koneille.

### ER-esimerkki

![alt text](images/03_er_esimerkki.png "ER-esimerkki"){width=50% height=50%}

### Kohde / Käsite

- Asia josta halutaan tallentaa tietoa.
  - Konkreetti: opiskelija, kurssi.
  - Abstrakti: opintosuoritus, ilmoittautuminen.
- Kuvaa ja jäsentää reaalimaailman ongelma-aluetta ja/tai kohdetta.

### Attribuutti (ominaisuus)

- Kohteen ominaisuus
- Havainnollinen nimi
- Arvo määriteltävissä (esim. lukuarvo, merkkijono)
- Pakollinen vai valinnainen
- Onko tyhjä arvo sallittu
- Attribuutin arvo voi olla myös yksilöivä tieto (esim. henkilötunnus tai opiskelijanumero)

### Yhteys

- Kertoo, mitkä tiedot ovat yhteydessä toisiinsa
- Esimerkiksi mille kursseille opiskelija on ilmoittautunut
- Viiva kohteiden/käsitteiden välillä
- Yhteydet voidaan nimetä
- Yhteystyyppi (kardinaliteetti)
- 1:1, yksi-yhteen
- 1:M, yksi-moneen
- N:M, moni-moneen

## Käsiteanalyysi

### Käsiteanalyysimenetelmä

![alt text](images/03_kasiteanalyysimenetelma.png "Kasiteanalyysimenetelma"){width=50% height=50%}


### Käsiteanalyysi

- Tarkastelee rajattua reaalimaailman kohdetta ja pyrkii jäsentämään sen kohderyhmää kiinnostaviin käsitteisiin, niiden välisiin riippuvuuksiin ja ominaisuuksiin
- Selvitetään mitä tietoa tietokantaan halutaan tallentaa – ei välitetä suorituskykyasioista
- Tietokannan suunnittelu voidaan aloittaa käsiteanalyysilla

### Käsitemalli

- Syntyy käsiteanalyysin ensimmäisessä vaiheessa: pyrkii mallintamaan todellisuutta yksilöimällä, luokittelemalla ja nimeämällä kiinnostuksen kohteita ja niiden sisältämää tietoa
- Luodaan yhtenäinen käsitemalli, jossa asiat kuvataan yhteisesti ymmärretyllä kielellä
  - Työn tuloksena syntyy käsitekaavio(ita)

### Käsitekaavio

- Lyhyesti: Määrittelee käsitteet ja niiden väliset yhteydet
- Syvällisemmin: Käsitekaavio on graafinen malli kohdealueen yksilö-, ominaisuus-, arvo- ja yhteystyyppien määrityksistä
- Kaavioissa käytetään yhteisesti sovittua kuvaustekniikkaa, notaatiota
  - Martinin notaatio / ”Harakanvarvas” (crow’s feet)
  - Chenin notaatio
  - UML / Luokkakaavio
- Käsitekaaviot ovat tietokantasuunnittelun tärkeä työväline - erityisesti relaatiotietokantojen
- Joissakin lähteissä käsitemallilla ja käsitekaaviolla tarkoitetaan samaa asiaa

### Käsitteen tunnistaminen

- Tarkasteltavan kohteen konkreettinen asia, kuten
  - Asiakas
  - Tuote
  - Tilaus
- Abstrakti asia, kuten
  - Budjetti
  - Tulosyksikkö
- Yhteistä käsitteille on, että ne ovat/sisältävät tietoa jota halutaan tallettaa tietokantaan
- Käsite löytyy usein lauseen substantiivista:
  - **Asiakas** tekee **tilauksen**.
  - **Asiakas** ostaa **tuotteen**.

### Yhteydet, riippuvuudet

- Kun kaksi käsitettä ovat jollain tapaa riippuvaisia toisistaan, kutsutaan niiden välistä riippuvuussuhdetta yhteydeksi
- Yhteys on usein lauseen verbi:
  - Asiakas **ostaa** tuotteen.
    - ![alt text](images/03_asiakas_ostaa_tuote.png "Asiakas ostaa tuote"){width=50% height=50%}
  - Myyjä **myy** tuotteen.
    -  ![alt text](images/03_myyja_myy_tuote.png "Myyjä myy tuote"){width=50% height=50%}

### Käsitteitä

- Tilausjärjestelmän käsitemalli (UML-notaatio):
  - ![alt text](images/03_tilausjarjestelman_kasitemalli.png "Asiakas ostaa tuote"){width=50% height=50%}
- Käsitteiden väliset yhteydet jätetään usein nimeämättä (ei kuitenkaan piirtämättä!)

## Tarveanalyysi

![alt text](images/03_tarveanalyysi.png "Tarveanalyysi"){width=50% height=50%}

### Tarveanalyysi lyhyesti

- Reaalimaailman kohteesta muodostettuja käsitteitä täydennetään ja tarkistetaan luodun käsitemallin toimivuus
- Käydään läpi tietotarpeet eri näkökulmista: käyttäjät, käyttöliittymät, eräajot, raportit, yms. ja analysoidaan tarpeet talletettavan tiedon suhteen
- Tarkennetaan käsitteiden välisiä yhteyksiä ja luodaan tarvittaessa ”apukäsitteitä”, jotta tieto saadaan ryhmiteltyä loogisesti.

### Käsitteiden tarkentaminen

- Käsitteitä tarkennetaan lisäämällä niihin kuuluvat ominaisuudet (attribuutit)
- Jokaiselle käsitteelle määritellään yksilöivä ominaisuus, **pääavain** (perusavain, primary key, PK)
  - Pakollinen
  - Voi koostua useammasta sarakkeesta
  - Voi olla luonnollinen tai johdettu (surrogaatti)
  - Ei voi olla määrittelemätön/tyhjä (NULL)!!
- Pääavain merkitään notaatiosta riippuen yleensä alleviivaamalla tai lihavoinnilla
- Pääavain lisäksi käsite voi sisältää myös **viiteavaimen** (foreign key, FK)

### Yhteystyypit

- Yksi yhteen –yhteys (1:1)
  - Ensimmäisen taulun yksittäinen tietue liittyy yhteen ja vain yhteen toisen taulun tietueeseen
- Yksi moneen –yhteys (1:N)
  - Ensimmäisen taulun pääavaimesta luodaan viiteavain toiseen tauluun
  - Ensimmäisen taulun yksittäinen tietue liittyy yhteen tai useampaan toisen taulun tietueeseen, mutta toisen taulun yksittäinen tietue liittyy vain yhteen ensimmäisen taulun tietueeseen
- Monta moneen –yhteys (N:M)
  - Ensimmäisen taulun yksittäinen tietue voi liittyä yhteen tai useampaan toisen taulun tietueeseen ja toisen taulun yksittäinen tietue puolestaan ensimmäisen taulun yhteen tai useampaan tietueeseen
  - Monesta moneen –yhteydet ovat usein suunnittelun ongelmakohtia (helposti ratkaistavissa ns. liitostaulun avulla)

### Tarkennettu käsitemalli

![alt text](images/03_tarkennettu_kasitemalli.png "Tarkennettu käsitemalli"){width=50% height=50%}

∗ Miten menetellä monesta-moneen–yhteyden kanssa (=TILAUS-TUOTE yhteys)?

## Normalisointi

![alt text](images/03_normalisointi.png "Tarveanalyysi"){width=50% height=50%}

- Normalisoinnista puhutaan tarkemmin seuraavassa materiaalipaketissa


# Harjoitukset - Orientoivat

Harjoitusten esimerkkiratkaisut ilmestyvät 03_harjoitukset_malliratkaisut -hakemistoon

## Orientoiva harjoitus 1: ATK-PUTIIKKI VERKKOON

Kurssin aiemmissa toteutuksissa on huomattu, että on parempi hypätä tämän tehtävän ohi ja palata siihen vähän myöhemmin.

- Tehtävänäsi on suunnitella verkkokauppa, joka tarjoaa ATK-laitteita asiakkaille
- Mieti järjestelmän taustalla olevan tietokannan rakennetta ja mallinna se kaavioksi esimm.draw.io :ta käyttäen
- Mitä tietoa järjestelmään tulee kyetä tallentamaan
- Missä muodossa tieto täytyy tallentaa
- Miten voidaan palvella useita yhtaikaisia käyttäjiä
- Voit kasata heränneitä ajatuksia tekemääsi kaavioon

# Lähteet

- Hovi, A. Huotari, J. Lahdenmäki, T. Tietokantojen suunnittelu & indeksointi. WS Bookwell, 2005.
- Hernandez, M. Tietokannat – suunnittelu käytännössä. Gummerus, 2000.
- Polvinen, T. Tietokannat käytännön työssä. WSOY, 1999.
- Esimerkki käsitemallista: http://tietomalli.csc.fi/

# Linkit

- ER Diagrams Intro: https://www.youtube.com/watch?v=HXV3zeQKqGY&t=13332s

[02: MariaDB docker asennus](/02_mariadb_docker) <----------> [04: Normalisointi ja ER suunnittelu](/04_normalisointi_ja_er_suunnittelu)
