# 04: Normalisointi ja ER suunnittelu

![alt text](images/04_normalisointi_header.png "Databases")

Sisällysluettelo:

[[_TOC_]]

Linkit-osiossa linkkejä ulkoisiin lähteisiin, joissa käydään tunnin asioita läpi englanniksi.

## Normalisointi

![alt text](images/03_normalisointi.png "Tarveanalyysi"){width=50% height=50%}

- Normalisoinnilla pyritään järjestelemään talletettava tieto ”parempaan tallennusmuotoon”
- Yksinkertaistetaan taulurakenteita
- Eliminoidaan / minimoidaan päällekkäinen tieto
- Pyritään tehokkaisiin ratkaisuihin
- Normaalimuotoja alun perin kolme, nykyisellään viisi (lisäksi Boyce-Codd) 

”Äärimmilleen vietynä normalisoidussa taulussa olevan datan tulisi olla riippuvainen vain ja ainoastaan pääavaimesta.”  
(Lähde: Polvinen, T. Tietokannat käytännön työssä)

- Normalisointi voi aiheuttaa myös ongelmia -> denormalisointi palauttaa tietokannan aiempaan muotoon

## Normaalimuodot

- 1. Normaalimuoto
  - Erota toistuvat ryhmät ja moniarvoiset sarakkeet omiksi käsitteikseen.
- 2. Normaalimuoto
  - Ei-avaintiedon tulee olla riippuvainen koko pääavaimesta.
- 3. Normaalimuoto
  - Poista kentät jotka eivät ole riippuvaisia pääavaimesta
- Neljäs ja viides normaalimuoto ovat enemmän teoreettisia, eikä niitä juurikaan sovelleta käytännön työssä

”…normaalimuodot voivat olla hämmentäviä jokaiselle, joka ei ole käyttänyt aikaa muodollisen relaatiotietokantateorian opiskeluun.”  
(Lähde: Hernandez, M. Tietokannat - suunnittelu käytännössä)

## Termien vertailua

| Käsitemalli | Oliomalli | Relaatiomalli | Relaatio-tietokanta | Vanha termi |
|-------------|-----------|---------------|---------------------|-------------|
| Käsite | Luokka | Relaatio | Taulu ||
| Tieto (attribuutti) | Attribuutti | Attribuutti | Sarake | Kenttä |
| Esiintymä | Esiintymä | Monikko (tuple) | Rivi | Tietue |
| Yhteys | Suhde | Viiteavain | Viiteavain |
| Perusavain | Object ID | Perusavain | Perusavain ||

Lähde: Hovi, Huotari, Lähdenmäki. Tietokantojen suunnittelu & indeksointi

## 1. Normaalimuoto (1NF)

- Pilko tietokannan taulujen ominaisuudet mahdollisimman pieniin osiin (atomisuus)

![alt text](images/04_1_normaalimuoto.png "1. Normaalimuoto"){width=50% height=50%}

## 2. Normaalimuoto (2NF)

- Valitse jokaiseen tauluun perusavain
  - Taulun tietueet (rivit) ovat yksilöitävissä perusavaimen perusteella

![alt text](images/04_2_normaalimuoto.png "2. Normaalimuoto"){width=50% height=50%}

## 3. Normaalimuoto (3NF)

- Poista tauluun kuulumattomat tiedot taulusta tai siirrä ne toiseen tauluun - kaikkien taulun ominaisuuksien tulee olla riippuvaisia vain pääavaimesta
- Huomataan, että alla olevassa esimerkissä Postitoimipaikka on riippuvainen postinumerosta

![alt text](images/04_3_normaalimuoto.png "3. Normaalimuoto"){width=50% height=50%}

- Siirretään postitoimipaikka omaan tauluunsa.

![alt text](images/04_3_normaalimuoto2.png "3. Normaalimuoto"){width=50% height=50%}

## Funktionaalinen riippuvuus (X->Y)

- F(X)=Y
- Luetaan: X määrää Y:n
- X määrää siis yksiselitteisesti Y:n arvot tietyllä ajanhetkellä. Tällöin Y on funktionaalisesti riippuvainen X:stä.
  - HENKILÖ (htun, nimi, kotikunta)

![alt text](images/04_funktionaalinen_riippuvuus.png "3. Normaalimuoto"){width=50% height=50%}

## Normalisointi käytännössä

- Normalisointi on määritelty eri lähteissä mitä vaikeaselkoisimmilla tavoilla. Vaikeaselkoisen määrittelyn taustalla on kuitenkin sangen yksinkertainen asia.
- ”Yritys ja erehdys” on toimiva tapa oppia tietokannan normalisointi. Tätä sykliä kannattaa toistaa riittävän usein jo suunnitteluvaiheessa. On kuitenkin hyvä ymmärtää asia myös teoreettisemmalla tasolla.

## ER-diagrammin suunnittelu

**Yrityksen datan tallennusvaatimukset**

Yritys on järjestetty toimipisteisiin. Jokaisella toimipisteellä on yksilöllinen numero, nimi ja tietty työntekijä, joka johtaa sitä.

Yritys tekee rahaa myymällä asiakkaille. Jokaisella asiakkaalla on nimi ja yksilöllinen numero, jolla heidät voidaan tunnistaa.

Yrityksen perusta on sen työntekijät. Jokaisella työntekijällä on nimi, syntymäpäivä, sukupuoli, palkka ja yksilöllinen numero.

Työntekijä voi työskennellä kerralla vain yhdessä toimipisteessä, ja jokaista toimipistettä johtaa yksi siellä työskentelevistä työntekijöistä. Haluamme myös seurata, milloin nykyinen johtaja aloitti johtajana.

Työntekijä voi toimia esimiehenä muille työntekijöille toimipisteessä, työntekijä voi toimia myös esimiehenä työntekijöille muissa toimipisteissä. Työntekijällä voi olla enintään yksi esimies.

Toimipiste voi hoitaa useita asiakkaita, joilla kullakin on nimi ja yksilöllinen numero, jolla heidät voidaan tunnistaa. Yhtä asiakasta voi hoitaa kerralla vain yksi toimipiste.

Työntekijät voivat työskennellä toimipisteensä valvomien asiakkaiden kanssa myydäkseen heille tavaroita. Tarvittaessa useat työntekijät voivat työskennellä saman asiakkaan kanssa. Haluamme seurata, kuinka monen dollarin arvosta tavaroita kukin työntekijä myy kullekin asiakkaalle, jonka kanssa he työskentelevät.

Monien toimipisteiden on tehtävä yhteistyötä toimittajien kanssa ostaakseen varastoja. Seuraamme kunkin toimittajan nimeä ja tuotteen tyyppiä, jota he myyvät toimipisteelle. Yksi toimittaja voi toimittaa tuotteita useille toimipisteille.

![alt text](images/04_company_database_er.png "3. Normaalimuoto"){width=50% height=50%}

Data source: https://www.mikedane.com/databases/sql/designing-an-er-diagram/

# Harjoitukset - ER - suunnittelu

## ER - suunnittelu harjoitus 1: Opintorekisterin suunnittelu

Suunnittele relaatiotietokanta, joka sisältää
- opiskelijoiden tiedot,
- oppilaitoksen järjestämät kurssit ja
- tietoa kurssin suorittamisesta per opiskelija.

Muodosta ER-kaavio https://dbdiagram.io -palvelussa ja tallenna se kuvana reposi palautushakemistoon. Kerro myös Readme.MD-tiedostoon tehtävän suoritukseen liittyvistä yksityiskohdista:
- tehtävään käytetty aika,
- keskeiset oppimasi asiat ja
- oletko tyytyväinen lopputulokseen?

Vinkki: ER Diagrams Intro -videosta löytyy esimerkki opiskelijatietokannan suunnittelusta.

## ER - suunnittelu harjoitus 2: Verkkokaupan suunnittelu

Suunnittele relaatiotietokanta, joka sisältää
- asiakastiedot,
- tuotetiedot,
- tavarantoimittajan tiedot,
- henkilökunnan tiedot ja
- asiakkaiden tekemät tilaukset.

Muodosta ER-kaavio https://dbdiagram.io -palvelussa ja tallenna se kuvana reposi palautushakemistoon. Kerro myös Readme.MD-tiedostoon tehtävän suoritukseen liittyvistä yksityiskohdista:

Liitä vastaukseen myös tietokannan taulujen luontiscriptit.
- tehtävään käytetty aika,
- keskeiset oppimasi asiat ja
- oletko tyytyväinen lopputulokseen? 

## ER - suunnittelu harjoitus 3: Sensoritietokannan suunnittelu

Suunnittele MySQL tietokanta, johon voidaan tallentaa sensoridataa kolmesta eri tilasta (esim. keittiö, olohuone, pesuhuone). Käytettävät sensorit mittaavat lämpötilaa, ilman kosteutta, hiilidioksidi ja häkäpitoisuutta. 

Suunnittele tietokantaratkaisu relaatiomallin mukaisesti. Tallenna jokaisesta lukemasta myös aikaleima tietokantaan. Tallenna huone ja sensoritiedot tietokantaan käyttäen mysql-istuntoa. Pidä tietokannat yksinkertaisina, dublikaatit eivät vähäisessä määrin haittaa. Suunnittele tietokanta siten, että tiedon tallennus tietokantahaut ovat syntaksiltaan mahdollisimman yksinkertaisia. 

# Lähteet
- Hovi, A. Huotari, J. Lahdenmäki, T. Tietokantojen suunnittelu & indeksointi. WS Bookwell, 2005.
- Hernandez, M. Tietokannat – suunnittelu käytännössä. Gummerus, 2000.
- Polvinen, T. Tietokannat käytännön työssä. WSOY, 1999.
- https://www.mikedane.com/databases/sql/designing-an-er-diagram/

# Linkit
- ER Diagrams Intro: https://www.youtube.com/watch?v=HXV3zeQKqGY&t=13332s
- Designing an ER Diagram: https://www.youtube.com/watch?v=HXV3zeQKqGY&t=14153s
- Converting ER Diagrams to Schemas: https://www.youtube.com/watch?v=HXV3zeQKqGY&t=14914s
- dbdiagram.io: Ilmainen työkalu ER-diagrammien tekoon: https://dbdiagram.io/

[03: Johdantoa tietokantoihin](/03_johdantoa_tietokantoihin) <----------> [05: Tietokannan hallinta](/05_tietokannan_hallinta)
