Tehtävä 2: verkkokaupan suunnittelu
=== 
Juha Vartiainen

Loin aluksi jokaisen pyydetyn taulun ja sen jälkeen lähdin miettimään, mitä attribuutteja taulut voisivat pitää sisällään. 
![](harjoitus_02_verkkokauppa_01.png)
Ensimmäinen suunnitelma MYSQL-Workbenchillä. HUOM! Taulujen välisiä relaatiota kuvaavat viivat eivät osoita atrribuutteihin, joihin liitos on osoitettu.

Relaatiotoita lähdin miettimään:
* Asiakkaalla voi olla useita tilauksia, mutta tilauksella vain yksi asiakas.
* Tilauksessa voi olla useita tuotteita, ja tuotteella voi olla useita tilauksia! 
    * Eli tähän tauluun voisikin lisätä liitostaulun.
* Totteella on yksi valmistaja, mutta valmistajalla voi olla useita tuotteita.
* Tuote kuuluu johonkin vastuuosastoon. Henkilökunnan henkilöllä on yksi vastuuosasto, mutta osastolla voi olla useita vastuumyyjiä.
    * Ehkä hieman kaupasta riippuen, että onko tälläisiä osastoja edes, ja voiko henkilöllä olla useampia vastuualueita jne.. mutta tässä toteutuksessa päädyin tälläiseen ratkaisuun.
    * Väliin voisi ehkä vielä lisätä vastuuosastot-taulun, mutta en nyt lähde sitä miettimään.

Eli muokataan hieman alkuperäistä hahmottelua.

![](harjoitus_02_verkkokauppa_02.png)

Nyt tilauksessa voi olla useita tuotteita, ja tuotteella useita tilauksia.


Harjoitus oli melko nopea tehtä MYSQL-Workbenchilla. Lopputulos ei ehkä ihan tuotantoon saakka tämänlaisena päätyisi, mutta mielestäni tämä on melko realistinen toteutus. Taulujen attribuutteja voisi varmaan vielä miettiä tarkemmin, sekä lisätä lapsitauluja ainakin valmistajalle, vastuuosastolle ja osoitteille. Henkilökunta ja asiakastilaus taulujen välille voisi ehkä myös lisätä relaation, sillä tilauksella usein on myyjä(1kpl) ja myyjällä voi olla useita tilauksia. Tämäkin toki riippuu siitä onko kyseessä esimerkiksi Prisma vai verkkokauppa. 

Tehtävä auttoi konkretisoimaan mitä käsite- ja tarveanalyysiin kuuluu
* Käsiteanalyysi
    * Taulujen väliset suhteet
        * Asiakas tekee tilauksen
        * Tilaus sisältää tuotteen. 
    * Tauluthan meille oli jo valmiiksi määritelty, eli käsitteisiin ei itse tarvinut jakaa.
* Tarveanalyysi
    * Attribuuttien luominen
        * Tämä tulisi tottakai tehtyä paremmin, jos tietokanta tehtäisiin oikeaan tarpeeseen.
    * Liitostyypit
    * 1:1
        * Ei käytetty
    * 1:n
        * Taitaa olla yleisin liitostyyppi. Aina kun suhde :n, luodaan viiteavain.
    * n:m
        * Tälle liitostyypille aina liitostaulu 

Sama dbdiagrammilla tehtynä.
Tässä vaihdoin hieman taulujen nimiä, jotta sain hahmoteltua toimivuuden paremmin. Muokkasin myös tauluja hieman lisäämälä niihin attribuutteja. Tärkein muutos varmaan tilatut_tuotteet taulun kpl_määrä, sillä täytyyhän sitä tietää montako kappaletta tuotetta on myyty.
Käydään vielä läpi:

* Asiakas tekee tilauksia(monta)
* Tilauksella on ostaja(1 asiakas)
* Tilauksella on myyjä(1)
* Myyjällä on tilauksia(monta)
* Tilaus sisältää tuotteita (monta)
* Tuote on tilauksissa(monta)
* Tilaus sisältää tuotteita (monta)
* Tuote sisältyy tilaukseen
    * Vähennetään redundanssia lisäämällä tuote vain kerran tilaukseen, mutta annetaan sille atrribuutiksi kpl_määrä
* Tuotteella on toimittaja (yksi)
* Toimittaja toimittaa tuotteen (Mahdollisesti monta)  
![](harjoitus_02_verkkokauppa_03.png)

Aikaa tehtävän tekemiseen meni vajaa 3 tuntia.
Tehtävän aikana taulujen välisten relaatioiden miettiminen/hahmottaminen nopeutui. Myös taulujen attribuuttien järjestystä(tai "muotoa") oikean tietokannan sisällä tuli mietittyä, joka puolestaan auttoi jakamaan atrribuutteja oikeisiin tauluihin.
Aikaa tehtävän tekemiseen kului noin 3 tuntia.

Alla luontilauseet.

```sql=
CREATE TABLE `asiakas` (
  `id` int PRIMARY KEY,
  `etunimi` varchar(255),
  `sukunimi` varchar(255),
  `osoite` varchar(255),
  `postinumero` varchar(255),
  `kaupunki` varchar(255),
  `sahkoposti` varchar(255),
  `salasana` varchar(255)
);

CREATE TABLE `tilaus` (
  `tilausnumero` int PRIMARY KEY,
  `asiakas_id` int,
  `myyja` varchar(255),
  `tilauspvm` datetime
);

CREATE TABLE `tuote` (
  `tuote_id` int PRIMARY KEY,
  `nimi` varchar(255),
  `osasto` int,
  `kuvaus` varchar(255),
  `kpl_varastossa` int,
  `valmistaja` varchar(255),
  `toimittaja` varchar(255)
);

CREATE TABLE `tilatut_tuotteet` (
  `tilausnumero` int,
  `tuote_id` int,
  `kpl_maara` itn
);

CREATE TABLE `myyja` (
  `henkilo_id` int PRIMARY KEY,
  `etunimi` varchar(255),
  `sukunimi` varchar(255),
  `osoite` varchar(255),
  `vastuuosasto` int
);

CREATE TABLE `toimittaja` (
  `toimittaja_id` int PRIMARY KEY,
  `nimi` varchar(255),
  `osoite` varchar(255),
  `maa` varchar(255),
  `yhteyshenkilo` varchar(255)
);

ALTER TABLE `tilaus` ADD FOREIGN KEY (`asiakas_id`) REFERENCES `asiakas` (`id`);

ALTER TABLE `tilaus` ADD FOREIGN KEY (`myyja`) REFERENCES `myyja` (`henkilo_id`);

ALTER TABLE `tuote` ADD FOREIGN KEY (`toimittaja`) REFERENCES `toimittaja` (`toimittaja_id`);

ALTER TABLE `tilatut_tuotteet` ADD FOREIGN KEY (`tilausnumero`) REFERENCES `tilaus` (`tilausnumero`);

ALTER TABLE `tilatut_tuotteet` ADD FOREIGN KEY (`tuote_id`) REFERENCES `tuote` (`tuote_id`);
```
