# 05: Tietokannan hallinta

![alt text](images/05_tietokannan_hallinta_header.png "Tietokannan hallinta")

Sisällysluettelo:

[[_TOC_]]

Linkit-osiossa linkkejä ulkoisiin lähteisiin, joissa käydään tunnin asioita läpi englanniksi.

**HOX! Tällä kurssilla käytämme Jupyterlabin MariaDB-tietokantaa tai paikallisesti Docker containeriin asennutta MariDB tietokannan hallintajärjestelmää.**

**Älä asenna palveliversiota, joiden asennusohjeet ovat kuitenkin tässä materiaalissa.**

# MySQL - Osa 1 - Tietokannan hallinta

## MySQL-tietokannanhallintajärjestelmästä

MySQL on MySQL AB:n kehittämä suosittu avoimen lähdekoodin tietokannanhallintajärjestelmä. MySQL AB:n perustivat suomalainen Michael Widenius ja ruotsalaiset David Axmark ja Allan Larsson vuonna 1995.
Vuonna 2008 yhdysvaltalainen Sun Microsystems osti yrityksen. Sun Microsystems on vuodesta 2009 lähtien ollut tietokannanhallintajärjestelmiä kehittävän Oraclen tytäryhtiö. Monty Widenius on kommentoinut, että MySQL on “aivokuollut”, koska siinä on sellaisia bugeja, joita Oracle ei pysty korjaamaan.

### MariaDb (Mysql)

MariaDB on yhteisön kehittämä MySQL:ään pohjautuva relaatiotietokantajärjestelmä, joka on lisensoitu GNU GPL -lisenssillä. Sitä kehittää sama yhteisö kuin alkuperäistä MySQL:ää. Sitä myös kehitetään niin, että yhteensopivuus MySQL:än kanssa on mahdollisimman hyvä.
Pääkehittäjänä toimii Michael ”Monty” Widenius, MySQL:n yksi kehittäjistä. Yhteisön täytyy jakaa tekijänoikeus Wideniuksen Monty Program AB -yhtiön kanssa. Järjestelmä on nimetty Wideniuksen nuoremman tyttären, Marian mukaan.
Tällä hetkellä MariaDB on luultavasti suosituin avoimen lähdekoodin tietokanta. MariaDB:tä käyttää mm. Google.
### MariaDB asennus - Ohjeet MariaDB-tietokannan asentamiseksi docker-ympäristöön.

MariaDB voidaan asentaa **PC:lle paikallisesti, serverille tai Docker containeriin**. Asennus palvelimelle ja paikallisesti PC:lle noudattaa suurin piirtein samaa kaavaa.
Ainoa oleellinen ero liittyy palomuurin asetuksiin.
Mikäli MariaDB asennetaan palvelimelle, täytyy palomuuri olla ehdottomasti olemassa. Tämä tarkoittaa sitä, että ssh -liikennettä varten tulee olla ns. “reikä” palomuurissa.
### Firewall asetukset

Mikäli palvelimelle on tarve saada ns Remote-yhteys, tulee palomuuriin avata portti ssh -liikenteelle. Seuraavilla käskyillä saadaan portti 22 ssh:lle avattua.

```
sudo ufw allow 22/tcp
sudo ufw enable
```

MariaDB ja MySQL periytyvät samasta koodipohjasta. Ubuntu 18.04 ja uusimmissa kannattaa asentaa MariaDB eikä MySQL:ää.

Seuraavilla asennuscripteillä asennuksen tulisi onnistua:
```
sudo apt-get update
sudo apt-get -y install mariadb-client mariadb-server

sudo mysql_secure_installation   # you still need a firewall
Set root password? [Y/n]
New password: <password>
Re-enter new password: <password>
Remove anonymous users? [Y/n] y
Disallow root login remotely? [Y/n] y
Remove test database and access to it? [Y/n] y or n
Reload privilege tables now? [Y/n] y
```

### Mysql serverin asennus Dockeriin - Esimerkki "Älä asenna"

Mysql-kannan ja phpmyadminin saa ylös näillä loitsuilla:

Ensin luodaan siltaus, jota käytetään dockerissa ajettavien palvelujen (konttien) välisessä kommunikoinnissa sekä bash -terminaalin komentojen ohjaamisessa kontissa ajettavaan mysql -serveriin.
```
sudo docker network create database-network
```
Käynnistetään serveri seuraavasti
```=
sudo docker run --name mysql-server \
--net=database-network \
-p 3306:3306 \
-e MYSQL_ROOT_PASSWORD=password \
-v ~/mysql-data:/var/lib/mysql \
-d mysql:5.7.24
```

phpMyqdmin lähtee tulille näin Dockerissa.
```=
sudo docker run --name phpmyadmin \
--net=database-network \
-e MYSQL_ROOT_PASSWORD=password \
-e PMA_HOST="mysql-server" \
-e PMA_PORT=3306 \
-p 8080:80 \
-d phpmyadmin/phpmyadmin
```
Dockerissa Mysql serverin komentorivinäkymän ja yhteyden Mysql -serverille saa komennolla:
```
docker exec -it mysql-server bash
```
Komento avaa mysql istunnon Linuxissa bash terminaaliin.



## MySQL:n hallintatyökalut

Suurin osa MySQL-tietokannan hallinnasta tapahtuu mysqld (MySQL server daemon) - prosessille annettavien komentojen avulla.
Näitä komentoja voidaan antaa komentoriviltä, joka on erittäin nopeaa ja tehokasta mutta vaatii käyttäjältä MySQL:n omentojen ja SQL-syntaksin hyvää tuntemusta. Toinen vaihtoehto MySQL:n hallitsemiseksi on graafisen käyttöliittymän sisältävä hallintatyökalu (MySQL Workbench ja PHPMyadmin).


### MySQL-järjestelmänvalvojan toimet

**Tärkeimmät tehtävät**:

1. Luo käyttäjät ja määrittää käyttäjille salasanat.

    Ei saa olla salasanattomia tunnuksia
    root-tunnuksella ei saa tehdä muuta kuin välttämättömiä ylläpitohommia.

1. Luo tietokannat
CREATE DATABASE foobar;

1. Määritä käyttöoikeudet tietokantoihin

    Tavallisella käyttäjällä ei ole yleensä täysiä oikeuksia kuin tiettyihin kantoihin
    Oikeuksien määritykseen voi käyttää phpmysqladmin-sivua tai MySQL Workbench ohjelmaa.
    Käyttöoikeudet voi määrittää myös MySQL:n komentorivin kautta GRANT-komennolla

### MySQL:n perusylläpitokomentoja:

Näitä voit turvallisesti harjoitella omalla ympäristöllä paikallisesti Docker containerissa olevalla MariaDB DNMS (Data Base Management System) ohjelmalla.

Luodaan uusi käyttäjä
```CREATE USER ‘monty’@‘localhost’ IDENTIFIED BY ‘some_pass’;```

Annetaan oikeudet valittuihin tietokantoihin
```GRANT ALL PRIVILEGES ON foo.* TO ‘monty’@‘localhost’ WITH GRANT OPTION;```

Salasanan vaihtaminen
```SET PASSWORD FOR ‘monty’@‘localhost’ = PASSWORD(‘uusisalasana’);```

Tietokannan luonti
```CREATE DATABASE jokutietokanta;```

Mitä tietokantoja on olemassa palvelimella?
```SHOW DATABASES;```

Poistetaan käyttäjä
```DROP USER ‘monty’@‘localhost’;```

Tai yksinkertaisemmin, jos edellinen ei toimi.
```DROP USER monty;```

Toinen tapa oikeuksien antamisesta tiettyyn tietokantaan.

```CREATE USER 'TestUser'@'%' IDENTIFIED BY 'test_paswd';```

```CREATE DATABASETestDB;
GRANT ALL PRIVILEGES ON TestUser.* to 'test_paswd'@'%';
```
On kylläkin muistettava, että ns murre-eroja voi olla erityyppisten mysql -tietokantojen välillä.

Tarkempaa tietoa täältä:
http://www.mysqltutorial.org/mysql-administration.aspx
### Järjestelmätietokannat

Kokeile komentoja omalla käyttäen omaa DNMS ympäristöä.

Information_schema sisältää yleistä tietoa järjestelmästä. Katsotaan vähän mitä siellä on. Valitaan ensin tietokanta:
```
MariaDB [(none)]> use information_schema;
Reading table information for completion of table and column names
You can turn off this feature to get a quicker startup with -A

Database changed
MariaDB [information_schema]> 

```
Listataan taulut:
```
mysql> show tables;
```
Komento DESCRIBE tai DESC näyttää yhden taulun rakenteen, eli mitä kenttiä (Field) se sisältää ja mikä kentän tietotyyppi on. Esimerkiksi tietokanta information_schema sisältää taulun ENGINES (jonka sisältönä on käytössä olevat tietokantamoottorit, siitä myöhemmin), jonka rakenne näyttää tältä:
```
mysql> desc Engines;
+--------------+-------------+------+-----+---------+-------+
| Field        | Type        | Null | Key | Default | Extra |
+--------------+-------------+------+-----+---------+-------+
| ENGINE       | varchar(64) | NO   |     |         |       |
| SUPPORT      | varchar(8)  | NO   |     |         |       |
| COMMENT      | varchar(80) | NO   |     |         |       |
| TRANSACTIONS | varchar(3)  | YES  |     | NULL    |       |
| XA           | varchar(3)  | YES  |     | NULL    |       |
| SAVEPOINTS   | varchar(3)  | YES  |     | NULL    |       |
+--------------+-------------+------+-----+---------+-------+
6 rows in set (0.00 sec)
```
Katsotaan ENGINES taulun sisältö:
```
mysql> SELECT * from ENGINES;
+--------------------+---------+----------------------------------------------------------------+--------------+------+------------+
| ENGINE             | SUPPORT | COMMENT                                                        | TRANSACTIONS | XA   | SAVEPOINTS |
+--------------------+---------+----------------------------------------------------------------+--------------+------+------------+
| PERFORMANCE_SCHEMA | YES     | Performance Schema                                             | NO           | NO   | NO         |
| CSV                | YES     | CSV storage engine                                             | NO           | NO   | NO         |
| MRG_MYISAM         | YES     | Collection of identical MyISAM tables                          | NO           | NO   | NO         |
| BLACKHOLE          | YES     | /dev/null storage engine (anything you write to it disappears) | NO           | NO   | NO         |
| MyISAM             | YES     | MyISAM storage engine                                          | NO           | NO   | NO         |
| MEMORY             | YES     | Hash based, stored in memory, useful for temporary tables      | NO           | NO   | NO         |
| ARCHIVE            | YES     | Archive storage engine                                         | NO           | NO   | NO         |
| FEDERATED          | NO      | Federated MySQL storage engine                                 | NULL         | NULL | NULL       |
| InnoDB             | DEFAULT | Supports transactions, row-level locking, and foreign keys     | YES          | YES  | YES        |
+--------------------+---------+----------------------------------------------------------------+--------------+------+------------+
9 rows in set (0.00 sec)
```
### Puolipiste komennon lopussa

Jos komennon lopusta puuttuu puolipiste, jää MySQL:n komentotulkki odottamaan, mitä käyttäjä seuraavaksi syöttää. Tämä on itse asiassa erittäin käyttökelpoinen ominaisuus, joka mahdollistaa pitempien lauseiden jakamisen useammalle riville, mutta on ensikertalaiselle todella hämmentävä:
```
mysql> SELECT * from ENGINES
    -> 
```
Takaisin komentotulkin perustilaan pääsee kirjoittamalla puolipisteen tyhjälle riville.

Ohjelman lopetus tapahtuu kirjoittamalla komentoriville exit. 
Poistutaan siis Mysql -palvelimelta.
```
mysql> exit
Bye
oppilas21@debian:~$ 
```
### MySQL:n eri tietokantamoottorit (Storage engines)

MySQL:n arkkitehtuurissa tietokannan ydin on erotettu koodista, jolla käsitellään tauluja eri tyyppisillä transaktioilla. Koska tietokantamoottori voidaan määritellä jokaiselle taululle erikseen, sitä on joskus kutsuttu myös nimellä taulun tyyppi (table type). MySQL:ään on tarjolla lukuisia tietokantamoottoreita, joista suurin osa on ulkopuolisen yrityksen kehittämiä ja lisenssimaksujen piirissä.
Suosituimmat ilmaiset tietokantamoottorit ovat MyISAM ja suomalaisen Innobase Oy:n kehittämä InnoDB.

MySQL:n järjestelmänvalvoja voi vaihtaa oletustietokantamoottoria muuttamalla default-storage-engine –muuttujaa my.cnf konfiguraatiotiedostossa.

### MyISAM tietokantamoottori

MyISAM on riisuttu, kevyt tietokantamoottori joka ei tue transaktioita. Se on suorituskyvyltään tehokas erityisesti tietoa luettaessa; tietoa kirjoitettaessa suorituskyky saattaa kärsiä sillä toisin kuin esim. InnoDB:ssä, lukitukset koskevat koko taulua eivätkä yksittäisiä rivejä. MyISAM-taulut varastoidaan kovalevylle kolmena eri tiedostona. Nämä tiedostot sisältävät koko taulun ja kaikki sen tiedot joten tiedostopohjainen varmuuskopiointi onnistuu helposti
InnoDB tietokantamoottori

InnoDB on MySQL:n versiosta 5.5.5. lähtien ollut MySQL:n oletustietokantamoottori. InnoDB on suunniteltu erityisesti suurille datamäärille jolloin sen suorituskyky on optimaalisin. InnoDB tukee viiteavaimia ja transaktioita.

### NDB tietokantamoottori

NDB on tietokantamoottori, jonka avulla on mahdollista luoda useasta MySQL Serveristä koostuva ”rypäs” nimeltään MySQL Cluster. Kaikki MySQL Clusterin tieto jaetaan usealle eri palvelimelle, jolloin pystytään estämään koko tietokannan kaatuminen tai tietojen katoaminen yhden palvelimen kaatuessa.

Tieto replikoituu välittömästi kaikille MySQL Clusterin palvelimille; näin se eroaa tavallisesta asynkronisesta varmuuskopioiden ottamisesta.

Jakamalla palvelu usealle palvelimelle voidaan saavuttaa tehokas suorituskyky myös edullisilla, suhteellisen
tehottomilla palvelimilla. Järjestelmä on samasta syystä myös hyvin skaalautuva. NDB tukee transaktioita ja rivitason lukituksia.

### Uuden tietokannan ja käyttäjän luominen Docker containerissa olevaan MariaDB kantaan

Uuden käyttäjän luominen kannattaa tehdä root -käyttäjänä. Kannattaa muistaa, että Linux -käyttäjän “root” on täysin eri asia kuin MariaDB:n “root”.

Seuraavalla käskyllä saadaan luotua uusi käyttäjä ja sensors -niminen tietokanta. Esimerkissä on myös poistettu drop database -komennolla typosta johtuva virheellinen tietokanta.
Yleensä Mysql -syntaksin mukaiset komennot kirjoitetaan ISOLLA ja taulujen nimet yms. pienellä. Toki yrityksissä on oma coding convention -käytäntö, jota tulee noudattaa nimeämisessä.

#### MariaDB hallintasovellus docker-ympäristössä

**Ensin käynnistetään Dockerissa oleva MariaDB hallintasovellus.**
```
eero@Kamk-eero:~$ docker exec -it mariadbtest bash
root@24af408abc30:/# 
```
**Ja sitten kirjaudutaan tietokantaan.**
```
root@24af408abc30:/# mysql -u root -p
Enter password: <mypass>
Welcome to the MariaDB monitor.  Commands end with ; or \g.
Your MariaDB connection id is 12
Server version: 10.3.14-MariaDB-1:10.3.14+maria~bionic mariadb.org binary distribution

Copyright (c) 2000, 2018, Oracle, MariaDB Corporation Ab and others.

Type 'help;' or '\h' for help. Type '\c' to clear the current input statement.

MariaDB [(none)]>
```

#### MariaDB hallintasovellus Jupyterlab-ympäristössä

Jupyterlab tarjoaa Notebookin MariaDB:tä varten. Tällöin komentoja kirjoitetaan soluihin ja solut ajetaan käyttäjän toimesta.

MariaDB hallintasovelluksen käyttö on mahdollista myös Jupyterlab-ympäristössä. Ensin on käynnistettävä MariaDB-notebook (File -> New Launcher -> MariaDB(Notebook)).

Kun MariaDB Notebook on käynnissä ja "Kernel status: Idle", niin käynnistä terminaali (File -> New Launcher -> Terminal(Other))

**Yhdistetään ja kirjaudutaan Notebook-ympäristössä omaan tietokantapalvelimeen**

```
jovyan@jupyter-hulis:~$ mysql -u root -p --socket=/tmp/mariadb_kernel/mysqld.sock
Enter password:<empty>
Welcome to the MariaDB monitor.  Commands end with ; or \g.
Your MariaDB connection id is 10
Server version: 10.3.37-MariaDB-0ubuntu0.20.04.1 Ubuntu 20.04

Copyright (c) 2000, 2018, Oracle, MariaDB Corporation Ab and others.

Type 'help;' or '\h' for help. Type '\c' to clear the current input statement.

MariaDB [(none)]> show databases;
+--------------------+
| Database           |
+--------------------+
| information_schema |
| mysql              |
| test               |
| test_db            |
+--------------------+
4 rows in set (0.013 sec)

MariaDB [(none)]>
```

**Seuraavaksi luodaan sensors niminen tietokanta.**
```
MariaDB [(none)]> create database seǹsor;
MariaDB [(none)]> drop database sensor;
MariaDB [(none)]> CREATE DATABASE sensors;
MariaDB [(none)]> SHOW DATABASES;
+--------------------+
| Database           |
+--------------------+
| sensors              |
| information_schema |
| mysql              |
| performance_schema |
+--------------------+
```
**Annetaan hiukan oikeuksia:**
```

MariaDB [(none)]> GRANT ALL ON sensors.* TO eero@localhost IDENTIFIED BY 'some_pass';

Query OK, 0 rows affected (0.00 sec)
```
**Poistutaan tietokannasta:**
```
MariaDB [(none)]> <quit tai exit>
Bye
```
**Seuraavaksi lisätään käyttäjä tietokannalle:**
```
create user 'eero'@'%' identified by 'pass';
```
**Annetaan kaikki oikeudet kaikkeen:**
```
grant all privileges on *.* to 'eero'@'%' with grant option;
```
**Tai annetaan vain kaikki oikeudet sensors tietokantaan:**
```
use sensors;
grant all privileges on sensors to 'eero'@'%' with grant option;
```
### Opetellaan vielä lisää MySQL syntaksia

Kirjadutaan sisälle tietokantaan, kuten edellisessä kohdassa, tai aja komennot MariaDB-notebookissa.

**Luodaan uusi tietokanta nimeltään test_db**
```
MariaDB [(none)]> CREATE DATABASE test_db;
Query OK, 1 row affected (0.000 sec)

MariaDB [(none)]> 
```
**Tsekataan tietokannat**
```
MariaDB [(none)]> SHOW DATABASES;
+--------------------+
| Database           |
+--------------------+
| information_schema |
| mysql              |
| performance_schema |
| sensors            |
| test_db            |
+--------------------+
5 rows in set (0.001 sec)

MariaDB [(none)]> 
```
**Otetaan test_db käyttöön ja lisätään tietokantaan uusi taulu HOX!!! komento use test_db;**

```
CREATE TABLE pet (
    name VARCHAR(20), 
    owner VARCHAR(20),
    species VARCHAR(20), 
    sex CHAR(1), 
    birth DATE, 
    death DATE
    ) ENGINE=InnoDB DEFAULT CHARSET=latin1;
    
Query OK, 0 rows affected (0.062 sec)
```
**Ja heti jäi pois yksi oleellinen column, eli id, joka toimii yksilöllisenä avaimena kaikille tietokannassa oleville lemmikeille. Lisätään siis **id** tauluun pet.**
```
MariaDB [test_db]> ALTER TABLE pet ADD COLUMN id INT NOT NULL PRIMARY KEY AUTO_INCREMENT;
Query OK, 0 rows affected (0.106 sec)
Records: 0  Duplicates: 0  Warnings: 0

MariaDB [test_db]> 
```
**Katsotaan tietokannan test_db taulut **SHOW TABLES** -komennolla.**
```
MariaDB [test_db]> SHOW TABLES;
+-------------------+
| Tables_in_test_db |
+-------------------+
| pet               |
| t1                |
+-------------------+
2 rows in set (0.001 sec)

MariaDB [test_db]> 
```
**Katsotaan millainen on juuri äsken luomamme pet taulu **DESCRIB**E pet -komennolla.**
```
MariaDB [test_db]> DESCRIBE pet;
+---------+-------------+------+-----+---------+----------------+
| Field   | Type        | Null | Key | Default | Extra          |
+---------+-------------+------+-----+---------+----------------+
| name    | varchar(20) | YES  |     | NULL    |                |
| owner   | varchar(20) | YES  |     | NULL    |                |
| species | varchar(20) | YES  |     | NULL    |                |
| sex     | char(1)     | YES  |     | NULL    |                |
| birth   | date        | YES  |     | NULL    |                |
| death   | date        | YES  |     | NULL    |                |
| id      | int(11)     | NO   | PRI | NULL    | auto_increment |
+---------+-------------+------+-----+---------+----------------+
7 rows in set (0.002 sec)

MariaDB [test_db]> 
```

# Harjoitukset - Tietokannan hallinta

## Tietokannan hallinta harjoitus 1

Tee uusi MariaDB Notebook, luo tietokanta ja aja MYSQL tutoriaalissa olevat komennot luomaasi tietokantaan.

https://dev.mysql.com/doc/refman/8.0/en/creating-tables.html

Nimeä notebook seuraavasti: tietokannan_hallinta_harj1

Lisää harjoitus Git-repoosi.


# Linkit
- Introduction to SQL: https://www.youtube.com/watch?v=HXV3zeQKqGY&t=0s
- What is a Database?: https://www.youtube.com/watch?v=HXV3zeQKqGY&t=156s
- Tables & Keys: https://www.youtube.com/watch?v=HXV3zeQKqGY&t=1390s


[04: Normalisointi ja ER suunnittelu](/04_normalisointi_ja_er_suunnittelu) <----------> [06: Relaatiotietokantojen perusteita](/06_relaatiotietokantojen_perusteita)
