# 06: Relaatiotietokantojen perusteita

![alt text](images/06_relaatioteitokantojen_perusteita_header.png "Relaatiotietokantojen perusteita")

Sisällysluettelo:

[[_TOC_]]

Linkit-osiossa linkkejä ulkoisiin lähteisiin, joissa käydään tunnin asioita läpi englanniksi.

# MySQL - Osa 2 - Relaatiotietokantojen perusteita

## Johdanto
Nyt meillä on tietokanta olemassa, perehdytään lyhyesti Relaatiotietokantojen ominaisuuksiin.

Relaatiotietokanta koostuu useista tauluista (engl. table). Tauluissa tiedot esitetään riveissä (tietue, record) ja sarakkeissa (kenttä, field). Tietokannassa tarvittavat tiedot pyritään jakamaan tauluihin siten, että yksi tieto tallennetaan vain yhteen paikkaan. Relaatiotietokantaan tallennetaan myös tieto siitä, miten eri taulut liittyvät toisiinsa (pää- ja viiteavaimet, primary key, foreign key).

Taulujen välille luodaan yhteydet, jotka nopeuttavat ja tarkentavat käsiteltäviin tietoihin kohdistuvia operaatiooita. Relaatiotietokannan huolellinen suunnitteluu kannattaa, sillä hyvin suunnitellusta tietokannasta voi helposti tyydyttää monimutkaiset tietotarpeet.
## Tietokannan taulut

Relaatiotietokannassa tiedot esitetään siis tauluina. Yhtä tietokantataulun riviä kutsutaan tietueeksi (engl. record).
Taulun jokaisella rivillä on yhtä monta tietoa eli kenttää (engl. field).
Jokaisella rivillä täytyy olla yksikäsitteinen perusavain (engl. primary key), joka vastaa jotakin reaalimaailman kohdetta (esim. jokaisella työntekijällä on yksilöllinen tunniste).
Kuhunkin kohteeseen liitetään vain siihen välittömästi liittyvät ominaisuudet.
Kukin yksittäinen tieto relaatiotietokannassa voidaan hakea ainakin ilmoittamalla taulun nimi, perusavaimen kentän nimi ja avaimen arvo sekä haettavan tiedon kentän nimi.
Relaatiotietokannasta tietoa haetaan vain tiedon nimien ja arvojen perusteella, ei siis koskaan tiedon sijainnin tai järjestyksen mukaan.

Tietokannan kentällä on koko joukko ominaisuuksia, jotka täytyy tuntea ja osata määritellä tietokantaa luodessa. Tärkeimmät näistä ominaisuuksista ovat kentän nimi (field name) ja tietotyyppi (datatype).

Mahdollisimman moni kenttä kannattaa määritellä pakolliseksi tai käyttää oletusarvoa. Tällöin vältetään NULL-ongelmia.
NULL on erityinen merkintätapa puuttuvalle arvolle. NULL ei tarkoita välilyöntiä tai nollaa. Jos kentälle ei syöttövaiheessa anneta mitään arvoa, niin sen sisällöksi tulee NULL.

Se tarkoittaa lähinnä tuntematonta arvoa eli sen arvo voisi periaatteessa olla mikä tahansa tai ei mikään.

Taulussa tulee olla määritetty seuraavat ominaisuudet:

    Kentän nimi (engl. fieldname).
    Tietotyyppi (engl. datatype), joka voi olla numeerinen, alfanumeerinen (teksti), päivämäärä * ja/tai kellonaika, looginen tai bittijono.
    Maksimipituus ja mahdollinen tarkkuus (engl. maximum length, precision).
    Onko tieto pakollinen (engl. required).
    Tarkistukset syötettävän tiedon oikeellisuudelle tai sallittujen arvojoukkojen joukko (engl.validity checks).
    Oletusarvo (engl. default value), jota käytetään jätettäessä kenttä tietoja syötettäessä tyhjäksi.
    Syöttömaski (engl. Input Mask), jolla kuvataan kenttään kelpuutettavat merkit ja niiden muoto.

## Taulujen yhteydet

Tietokanta sisältää yleensä useamman kuin yhden taulun. Yhtä tärkeää kuin tietojen ryhmittely omiin tauluihinsa on se, miten taulut (käsitteet) liitetään toisiinsa. Käsitteiden välillä on looginen yhteys, joka on luotava myös taulujen välille. Tällöin eri tauluissa olevia tietoja voidaan käsitellä samanaikaisesti. Kun tietoja päivitetään yhdessä taulussa, muutokset tallentuvat samalla myös muihin tauluihin.

Suuri osa tietokantatyöstä onkin käsitteellistä suunnittelua erilaisia malleja käyttäen (tähän palataan Mysql Workbench osiossa).

**Yhteys kahden taulun välille muodostetaan viiteavaimen avulla**. Ns. **ensisijaisen tauluko**n
**perusavain eli pääavain kopioidaan toiseen taulukkoon viiteavaimeksi**.
Käsitteiden välillä on kolmenlaisia riippuvuuksia: yhden suhde yhteen (käytetään harvoin), yhden suhde moneen (yleisin) ja monen suhde moneen (yleensä puretaan liitostauluun)

Jotta taulujen tiedot pysyisivät yhtenäisinä, voidaan yhteyksiä määriteltäessä määrätä taulujen välille **viite-eheys.**
**Viite-eheys varmistaa, että taulujen sisältämät tiedot pysyvät ajan tasalla siinä tilanteessa, että jokin tietue poistetaan.**

Esimerkki monesta-moneen yhteyden purkamisesta.  
![](images/06_monesta_moneen_yhteyden_purkaminen.png)


## Tietokannan mallintaminen: ER-diagrammi

Vaatimusmäärittelyn pohjalta tietokannan suunnittelija muodostaan tarvittavat taulut, taulujen sisältämät tiedot ja taulujen väliset yhteydet.

Tietokantojen yhteydessä käytetään tavallisimmin ns. ER-mallia (Entity-Relationship-Diagram).
ER-malli on yksi osa UML-“kieltä” (notaatiota).

    Entity = entiteetti, jokin asia, jota mallinnetaan. Käytännössä tietokannan yksi taulu
    Relationship = entiteettien (taulujen) välinen yhteys

Usein tietokannan suunnittelu on melkeinpä vaikein asia mihin tietokantojen yhteydessä törmää. Alla olevassa kuvassa on esimerkkitietokannan Employees rakenne. Se on
esimerkki hieman monimutkaisemmasta tietokannasta. Kuvaaja on piirretty MySQL Workbench- ohjelmalla.Kuva. Mysql Workbench ER-malli
![](images/06_mysql_workbench_er_malli.png)  
Kuva. Mysql Workbench ER-malli
## Tietokannan kenttien tietotyypit

Tietokanna kenttien nimeämisessä ja kenttiin tallettavien tietojen tietotyyppien määrittämisessä kannattaa muistaa se, että ns. varattuja sanoja ei saa käyttää ja tietyyppien valinnalla tiedon tallennuksen oikeellisuus.

Varatut sanat ja tietotyypit voi tsekata helpoiten konsultoimalla Googlea:
https://dev.mysql.com/doc/refman/8.0/en/data-types.html

# MySQL - Osa 3 - Tietokantakyselyt

Sisältö:
- MySQL-tietokanta, taulut, taulujen luominen, relaatiot
- Tilavaraukset
- Relaatioiden suunnittelu: indeksit, eheyssäännöt, näkymät
- Tietokannan merkistöt
- Tietokannan suojaus

## Tietokannan luonti ja tietojen syöttö, poisto, muuttaminen

Tietokantataulu (pet) pitää kirjaa lemmikkien nimistä, omistajista, lajista, sukupuolesta sekä syntymä- ja kuolinajoista.
Valitaan ensin tietokanta, johon taulut halutaan luoda. Vaihtoehtoina teillä on tietokanta test_db tai voitte myös luoda oman tietokannan. Esimerkissä käytetään test_db kantaa.
    
Harjoitukset kannattaa tehdä Jupyterlab MariaDB Notebookkiin.

**HOX! Muista, että Jypyter Notebookissa solu ajetaan SHIFT+ENTER -yhdistelmällä.**

Voit ajaa komentoja myös MySQL hallintaohjelman avulla Jupyterlab-ympäristössä. Tässä pieni muistin virkistys, miten se tapahtuu.

MariaDB hallintasovelluksen käyttö on mahdollista myös Jupyterlab-ympäristössä. Ensin on käynnistettävä MariaDB-notebook (File -> New Launcher -> MariaDB(Notebook)).

Kun MariaDB Notebook on käynnissä ja "Kernel status: Idle", niin käynnistä terminaali (File -> New Launcher -> Terminal(Other))

**Yhdistetään ja kirjaudutaan Notebook-ympäristössä omaan tietokantapalvelimeen**

```
jovyan@jupyter-hulis:~$ mysql -u root -p --socket=/tmp/mariadb_kernel/mysqld.sock
Enter password:<empty>
Welcome to the MariaDB monitor.  Commands end with ; or \g.
Your MariaDB connection id is 10
Server version: 10.3.37-MariaDB-0ubuntu0.20.04.1 Ubuntu 20.04

Copyright (c) 2000, 2018, Oracle, MariaDB Corporation Ab and others.

Type 'help;' or '\h' for help. Type '\c' to clear the current input statement.

MariaDB [(none)]> show databases;
+--------------------+
| Database           |
+--------------------+
| information_schema |
| mysql              |
| test               |
| test_db            |
+--------------------+
4 rows in set (0.013 sec)

MariaDB [(none)]>
```

Tai Docker -kontissa pyörivään MariaDB -kantaan.

Muistin virkistykseksi Dockerissa ajettan MariaDB:n starttaaminen:
```=
eero@Kamk-eero:~$ docker start mariadbtest
mariadbtest
eero@Kamk-eero:~$ docker exec -it mariadbtest bash
root@24af408abc30:/# mysql -u root -p
Enter password: 
```


    
Edellisellä kerralla loimme jo taulun pet root oikeuksilla test_db tietokantaan, joten käytämme nyt sitä tässä harjoituksessa.
```
MariaDB [(none)]> use test_db
Reading table information for completion of table and column names
You can turn off this feature to get a quicker startup with -A

Database changed


show tables;
+-------------------+
| Tables_in_test_db |
+-------------------+
| pet               |
+-------------------+
1 row in set (0.001 sec)

MariaDB [test_db]> 
```
Katsotaan taulun sisältö:
```

MariaDB [test_db]> desc pet;
+---------+-------------+------+-----+---------+-------+
| Field   | Type        | Null | Key | Default | Extra |
+---------+-------------+------+-----+---------+-------+
| name    | varchar(20) | YES  |     | NULL    |       |
| owner   | varchar(20) | YES  |     | NULL    |       |
| species | varchar(20) | YES  |     | NULL    |       |
| sex     | char(1)     | YES  |     | NULL    |       |
| birth   | date        | YES  |     | NULL    |       |
| death   | date        | YES  |     | NULL    |       |
+---------+-------------+------+-----+---------+-------+
6 rows in set (0.001 sec)

```
Lisäsimme myös yhden oleellien columnin, eli id, joka toimii yksilöllisenä avaimena kaikille tietokannassa oleville lemmikeille. Lisätään siis id tauluun pet. Tee tämä, mikäli et ole aiemmin ajanut tätä lausetta.
```
ALTER TABLE pet ADD COLUMN id INT NOT NULL PRIMARY KEY AUTO_INCREMENT;
```


### Tietueen syöttö: INSERT INTO

INSERT (lisää)
INSERT INTO taulun_nimi [(sarake_lista)] VALUES (arvo_lista)
* molemmissa listoissa tulee olla sama määrä alkioita
* listojen täytyy vastata alkioiden järjestyksen suhteen toisiaan
* listojen tietotyyppien tulee vastata toisiaan
**INSERT INTO scripti** löytyy Moodlen kansiosta. 
Katsotaan yhdessä syntaksia:

Arvojen täytyy vastata taulun luonnissa määräämiä tietotyyppejä. 
Koska id on automaattisesti juokseva numero, sille voidaan antaa arvo NULL, sillä tietokantamoottori pitää huolta sen arvosta.
```
INSERT INTO pet VALUES('Claws','Gwen','cat','m','1994-03-17',NULL, NULL);
INSERT INTO pet VALUES('Buffy','Harold','dog','f','1989-05-13',NULL, NULL);
INSERT INTO pet VALUES('Fang','Benny','dog','m','1990-08-27',NULL, NULL);
INSERT INTO pet VALUES('Bowser','Diane','dog','m','1979-08-31','1995-07-29', NULL);
INSERT INTO pet VALUES('Whistler','Gwen','bird','','1997-12-09',NULL, NULL);
INSERT INTO pet VALUES('Chirpy','Gwen','bird','f','1998-09-11',NULL, NULL);
INSERT INTO pet VALUES('Slim','Benny','snake','m','1996-04-29',NULL, NULL);
INSERT INTO pet VALUES('Puffball','Diane','hamster','f','1999-03-30',NULL, NULL);

MariaDB [test_db]> select * from pet WHERE id = 1
    -> ;
+--------+--------+---------+------+------------+-------+----+
| name   | owner  | species | sex  | birth      | death | id |
+--------+--------+---------+------+------------+-------+----+
| Fluffy | Harold | cat     | f    | 1993-02-04 | NULL  |  1 |
+--------+--------+---------+------+------------+-------+----+
1 row in set (0.000 sec)


```
Katsotaan mitä tulikaan tehtyä;

![](06_select_from_pet.png)

### Tietueen poistaminen: DELETE FROM

Tiedon poistaminen tapahtuu DELETE komennolla, jossa poistaminen kohdistetaan jonkun kentän arvon mukaisesti oikeaan kohteeseen.

DELETE FROM taulun_nimi [WHERE ehto]
* vain ne rivit poistetaan, joihin WHERE -kohdassa oleva ehto pätee

```
MariaDB [test_db]> DELETE FROM pet WHERE name='Puffball';
Query OK, 1 row affected (0.036 sec)

MariaDB [test_db]> 
```

### Tietueen tietojen muuttaminen: UPDATE
UPDATE taulun_nimi SET sarake_nimi = arvo [, ...] [WHERE ehto]
* vain ne rivit päivitetään, joihin WHERE -kohdassa oleva ehto pätee
```
MariaDB [test_db]> UPDATE pet SET birth = '1989-08-31' WHERE name = 'Bowser';
Query OK, 1 row affected (0.036 sec)
Rows matched: 1  Changed: 1  Warnings: 0
```
### Tiedonhaku: SELECT
SELECT [DISTINCT | ALL] {* | [sarakemäärittely[AS uusi_nimi]] [, ...]} FROM taulun_nimi [synonyymi] [, ...] [WHERE ehto]
[GROUP BY sarake_lista] [HAVING ehto] [ORDER BY sarake_lista]

* **DISTINCT** -määreellä poistetaan hakutuloksesta duplikaatit (samanlaiset rivit)
* **ALL** -määreellä saadaan haettua duplikaatit liitoksissa
* ** * (tähti)  **määreellä saadaan haettua kaikkien sarakkeiden arvot
* **sarakemäärittelyssä kerrotaan, mitä sarakkeita hakuun sisällytetään**
* **AS** -määreellä saadaan haetuille sarakkeille määriteltyä uusi otsikko
* **FROM**-osassa määritellään taulut, joista haetaan
* **synonyymi** tarkoittaa taululle annettua synonyymiä, jota voidaan käyttää sarakkeiden yksilöintiin
* **WHERE** -osassa kerrotaan hakua rajaavat hakuehdot
* **GROUP BY** -osassa kerrotaan, miten haetut tiedot ryhmitellään
* **HAVING**-osassa kerrotaan, mitä ehtoja ryhmiteltyjen tietojen tulee täyttää, jotta ne tulisivat hakutulokseen
* **ORDER BY** -osassa kerrotaan, miten hakutulos lajitellaan
    
Katsotaan muutama esimerkki, miten taulusta voidaan hakea haluttuja tietoja käyttäen SELECT- lausetta. Käytössä on siis SQL-kyselykieli (Structured Query Language).

```
MariaDB [test_db]> SELECT * FROM pet WHERE name = 'Bowser';
+--------+-------+---------+------+------------+------------+----+
| name   | owner | species | sex  | birth      | death      | id |
+--------+-------+---------+------+------------+------------+----+
| Bowser | Diane | dog     | m    | 1989-08-31 | 1995-07-29 |  5 |
+--------+-------+---------+------+------------+------------+----+
1 row in set (0.001 sec)
```
Haku päivämäärän mukaisesti:
```
MariaDB [test_db]> SELECT * FROM pet WHERE birth >= '1998-01-01'; 
+--------+-------+---------+------+------------+-------+----+
| name   | owner | species | sex  | birth      | death | id |
+--------+-------+---------+------+------------+-------+----+
| Chirpy | Gwen  | bird    | f    | 1998-09-11 | NULL  |  7 |
+--------+-------+---------+------+------------+-------+----+
1 row in set (0.001 sec)
```
Haku OR (Tai)valintaehdon mukaisesti:
```
SELECT * FROM pet WHERE species = 'snake' OR species = 'bird';
```

Haku, jossa suoritetaan kaksi hakuehtoa:
```
SELECT * FROM pet WHERE (species = 'cat' AND sex = 'm') OR (species = 'dog' AND sex = 'f');
```
Haku. jossa haetaan tiedot vain valitut tiedot:

```
SELECT name, birth FROM pet;
```

### Duplikaattien poistaminen

* Kun kysely tuottaa useita samanlaisia rivejä, puhutaan duplikaateista.
* Duplikaatti syntyy siitä, että taulusta haetaan vain projektio, jolloin hakutuloksessa on samanlaisia rivejä, vaikka taulussa itsessään ei olisikaan samanlaisia rivejä.

**Seuraavilla keinoilla päästään eroon dublikaateista:**

* UNION –määreellä linkitetään useampi SELECT –lause ja samalla päästään eroon duplikaateista.
* Mikäli halutaan UNION –määreen tapauksessa tulokseen duplikaatit, tarvitaan SELECT –lauseessa ALL –määre
* DISTINCT –määreellä poistetaan yksinkertaisesta SELECT –lauseesta duplikaatit

**Harjoitus**: Tee haku, jossa haet vain omistajat pet taulusta ja poistat mahdolliset dublikaatit?

### Lajittelu: ORDER BY
Lajitellaan syntymäajan mukaan kasvavaan järjestykseen. 
```
MariaDB [test_db]> SELECT name, birth FROM pet ORDER BY birth;
+----------+------------+
| name     | birth      |
+----------+------------+
| Buffy    | 1989-05-13 |
| Bowser   | 1989-08-31 |
| Fang     | 1990-08-27 |
| Fluffy   | 1993-02-04 |
| Claws    | 1994-03-17 |
| Slim     | 1996-04-29 |
| Whistler | 1997-12-09 |
| Chirpy   | 1998-09-11 |
+----------+------------+
8 rows in set (0.000 sec)
```

Alenevaan järjestykseen lajittelu saadaan lisäämällä määre DESC (engl. descending).
```
MariaDB [test_db]> SELECT name, birth FROM pet ORDER BY birth DESC;
+----------+------------+
| name     | birth      |
+----------+------------+
| Chirpy   | 1998-09-11 |
| Whistler | 1997-12-09 |
| Slim     | 1996-04-29 |
| Claws    | 1994-03-17 |
| Fluffy   | 1993-02-04 |
| Fang     | 1990-08-27 |
| Bowser   | 1989-08-31 |
| Buffy    | 1989-05-13 |
+----------+------------+
8 rows in set (0.000 sec)

```
### Päivämäärän avulla laskeminen: TIMESTAMPDIFF, YEAR(), MONTH(), ja DAYOFMONTH().MONTH()

Lasketaan esimerkiksi lemmikkien ikä vuosina. 
CURDATE() on MySQL:n valmisfunktio, joka palauttaa tämän
päivän päivämäärän:

```
MariaDB [test_db]> SELECT CURDATE();
+------------+
| CURDATE()  |
+------------+
| 2019-04-15 |
+------------+
1 row in set (0.031 sec)
```
Ja sitten hyödynnetään tätä tietämystä laskennassa:
```
MariaDB [test_db]>  SELECT name, birth, CURDATE(),TIMESTAMPDIFF(YEAR,birth,CURDATE()) AS age FROM pet ORDER BY age;
+----------+------------+------------+------+
| name     | birth      | CURDATE()  | age  |
+----------+------------+------------+------+
| Chirpy   | 1998-09-11 | 2019-04-15 |   20 |
| Whistler | 1997-12-09 | 2019-04-15 |   21 |
| Slim     | 1996-04-29 | 2019-04-15 |   22 |
| Claws    | 1994-03-17 | 2019-04-15 |   25 |
| Fluffy   | 1993-02-04 | 2019-04-15 |   26 |
| Fang     | 1990-08-27 | 2019-04-15 |   28 |
| Buffy    | 1989-05-13 | 2019-04-15 |   29 |
| Bowser   | 1989-08-31 | 2019-04-15 |   29 |
+----------+------------+------------+------+
8 rows in set (0.001 sec)
```
Edellisessä lauseessa on toinen uusi avainsana **AS**. Sen avulla voidaan luoda uusi kenttä tulostukseen (tässä age). Toisin sanoen funktio **TIMESTAMPDIFF** ottaa syötteekseen tiedon siitä, missä muodossa tulos lasketaan (tässä vuosina, YEAR), sitten päivämäärät joiden välinen erotus lasketaan (vuosina). Tulos tallenttuu uuteen väliaikaiseen kenttään age. Tietokannan rakenteeseen sillä ei ole vaikutusta (pet-tauluun ei synny uutta age-kenttää).
Pari esimerkkiä, jossa edellinen lause on yhdistetty lajitteluun ORDER BY:
Ensimmäinen lajittelu aakkostaa nimen mukaan.
```
MariaDB [test_db]>  SELECT name, birth, CURDATE(),TIMESTAMPDIFF(YEAR,birth,CURDATE()) AS age FROM pet ORDER BY name;
+----------+------------+------------+------+
| name     | birth      | CURDATE()  | age  |
+----------+------------+------------+------+
| Bowser   | 1989-08-31 | 2019-04-15 |   29 |
| Buffy    | 1989-05-13 | 2019-04-15 |   29 |
| Chirpy   | 1998-09-11 | 2019-04-15 |   20 |
| Claws    | 1994-03-17 | 2019-04-15 |   25 |
| Fang     | 1990-08-27 | 2019-04-15 |   28 |
| Fluffy   | 1993-02-04 | 2019-04-15 |   26 |
| Slim     | 1996-04-29 | 2019-04-15 |   22 |
| Whistler | 1997-12-09 | 2019-04-15 |   21 |
+----------+------------+------------+------+
8 rows in set (0.001 sec)
```
Tässä esimerkissä lajitellaan hakutulos iän mukaan - nuorin ensin.
```
MariaDB [test_db]> SELECT name, birth, CURDATE(),TIMESTAMPDIFF(YEAR,birth,CURDATE()) AS age FROM pet ORDER BY age;
+----------+------------+------------+------+
| name     | birth      | CURDATE()  | age  |
+----------+------------+------------+------+
| Chirpy   | 1998-09-11 | 2019-04-15 |   20 |
| Whistler | 1997-12-09 | 2019-04-15 |   21 |
| Slim     | 1996-04-29 | 2019-04-15 |   22 |
| Claws    | 1994-03-17 | 2019-04-15 |   25 |
| Fluffy   | 1993-02-04 | 2019-04-15 |   26 |
| Fang     | 1990-08-27 | 2019-04-15 |   28 |
| Buffy    | 1989-05-13 | 2019-04-15 |   29 |
| Bowser   | 1989-08-31 | 2019-04-15 |   29 |
+----------+------------+------------+------+
8 rows in set (0.001 sec)
```

**Harjoitus:** Miten muuttaisit hakua, jotta loputulos olisi sellainen, jossa vanhin eläin on ensimmäisenä?

Joskus on hyödyllistä laskea kuukaisia kokonaislukuina. Funktio **MONTH** kaivaa päivämäärästä kuukauden kokonaislukuna:
```
MariaDB [test_db]> SELECT name, birth, MONTH(birth) FROM pet;
+----------+------------+--------------+
| name     | birth      | MONTH(birth) |
+----------+------------+--------------+
| Fluffy   | 1993-02-04 |            2 |
| Claws    | 1994-03-17 |            3 |
| Buffy    | 1989-05-13 |            5 |
| Fang     | 1990-08-27 |            8 |
| Bowser   | 1989-08-31 |            8 |
| Whistler | 1997-12-09 |           12 |
| Chirpy   | 1998-09-11 |            9 |
| Slim     | 1996-04-29 |            4 |
+----------+------------+--------------+
8 rows in set (0.001 sec)
```
**Harjoitus:** Millaisella hakulauseella saadaan selville se, millä elukalla on synttärit tulevan kuukauden aikana?

**Ratkaisu:**
Haetaan **MONTH**-funktiolla CURDATE:sta tämän hetkinen kuukausi kokonaislukuna. Asetetaan (**SET**) se oman itse määritellyn muuttujan (user-defined variable)
**@kuu** arvoksi. User-defined-muuttuja tunnistetaan **@** -merkillä.
```
MariaDB [test_db]> SET @kuu=MONTH(CURDATE());
Query OK, 0 rows affected (0.000 sec)
```
Tsekataan tallentuuko oikea kuukausi.
```
MariaDB [test_db]> select @kuu;
+------+
| @kuu |
+------+
|    4 |
+------+
1 row in set (0.000 sec)
```
Muuttujan @ -arvoa voi käyttää laskennassa tai hakuehtona SQL-lauseessa. Esimerkiksi näin:
```
MariaDB [test_db]> SELECT name, birth FROM pet WHERE MONTH(birth) = @kuu + 1;
+-------+------------+
| name  | birth      |
+-------+------------+
| Buffy | 1989-05-13 |
+-------+------------+
1 row in set (0.001 sec)
```

### NULL-arvo ja sen testaaminen

NULL on tyhjä tieto. Se ei ole numeroarvo 0. Tässä esimerkissä niillä lemmikeillä, jotka ovat hengissä, ei ole kuolinaikaa. Seuraava lause etsii kuolleet lemmikit ja ilmoittaa niiden iän vuosina kuolinhetkellä.
```
MariaDB [test_db]> SELECT name, birth, death, TIMESTAMPDIFF(YEAR,birth,death) AS age FROM pet WHERE death IS NOT NULL ORDER BY age;

+--------+------------+------------+------+
| name   | birth      | death      | age  |
+--------+------------+------------+------+
| Bowser | 1989-08-31 | 1995-07-29 |    5 |
+--------+------------+------------+------+
1 row in set (0.001 sec)
```
Edellä olleessa kyselyssä on käytetty avainsanaa **NOT NULL**. Toisin sanoen tulostetaan niiden tietueiden tiedot, joissa kenttä death ei ole tyhjä (eli kuolinaika on olemassa).

**Take a coffee breake now ;)**

No niin...Vaihdetaan seuraaviin kyselyihin hiukan monimutkaisempi tietokantarakenne.

Kopioi reposta **db.sql** -tiedoston sisältö ja liitä se MariaDB Notebookin soluun ja aja.

Vaihtoehtoisesti voit viedä komennot MariaDB:n hallintatyökaluun. Liitä (Paste) koko rimpsu kerralla ja paina <ENTER>
    
Tämä luo tietokannan sql_kyselyt, jonka taulut ovat:
```

MariaDB [sql_kyselyt]> show tables;
+-----------------------+
| Tables_in_sql_kyselyt |
+-----------------------+
| countries             |
| departments           |
| employees             |
| job_history           |
| jobs                  |
| locations             |
| regions               |
+-----------------------+
7 rows in set (0.001 sec)
```
Otetaan seuraaksi lyhyt oppimäärä Aggregate functions eli koontifunktioihin.
Osoitteesta https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html saa oivallista lisätietoa koontifuntioista. 
Koostefunktioita käytetään SELECT-lauseen sarakeluettelossa. Koostefunktioiden käytössä on muistettava joitakin asioita: 
* Koostefunktioita ei saa käyttää WHERE-lauseessa
* HAVING-lauseessa taas käytetään käytännössä aina koostefunktioita. 
* Koostefunktioita ja ”tavallisia” sarakkeita voi olla samassa SELECT-listassa vain, jos käytetään ryhmittelyä GROUP BY. 

Ei tässä lähetä kaikkia käymään läpi. Muutama esimerkki.

COUNT laskee lukumääriä. 
AVG laskee keskiarvon numeerisesta tietotyyppiä olevasta sarakkeesta.
COUNT(*) laskee kaikki tietueet (rivit).

```
MariaDB [sql_kyselyt]> SELECT COUNT(*) FROM employees;
+----------+
| COUNT(*) |
+----------+
|      107 |
+----------+
1 row in set (0.000 sec)
```
COUNT(last_name) laskee montako sukunimeä tietokannassa esiintyy.
```
MariaDB [sql_kyselyt]> SELECT COUNT(last_name) FROM employees;
+------------------+
| COUNT(last_name) |
+------------------+
|              107 |
+------------------+
1 row in set (0.000 sec)
```
Määre DISTINCT laskee kunkin sukunimen vain kerran.
```
MariaDB [sql_kyselyt]> SELECT COUNT(DISTINCT last_name) FROM employees;
+---------------------------+
| COUNT(DISTINCT last_name) |
+---------------------------+
|                       102 |
+---------------------------+
1 row in set (0.001 sec)
```
Palkkojen keskiarvo voidaan laskea AVG -funktiolla.
```
MariaDB [sql_kyselyt]> SELECT AVG(salary) FROM employees;
+-------------+
| AVG(salary) |
+-------------+
| 6461.682243 |
+-------------+
1 row in set (0.001 sec)
```
### Luokittelu GROUP BY

Tähän mennessä olemme käsitelleet SELECT –lauseen SELECT, FROM ja WHERE –osia. Täydellinen SELECT -lauseen muoto on kuitenkin monipuolisempi. 
 
SELECT [DISTINCT] attribuuttilista 
 	FROM relaatiolista 
 	[WHERE valintaehto] 
 	[GROUP BY] 
 	[HAVING] 
 	[ORDER BY] 
    
GROUP BY –määreellä voidaan valita, miten haun tulos ryhmitellään. GROUP BY ryhmittelee haetut rivit siten, että yhdessä ryhmässä kaikilla riveillä on sama arvo GROUP BY –sarakkeessa. 
Haun tuloksessa GROUP BY –sarakkeet esiintyvät kertaalleen ja lisäksi yleensä yksi tai useampi ryhmään kohdistuva koostefunktio. 
 
GROUP BY –määreen yleinen muoto on: 
 
***GROUP BY [attribuuttilista]***
 
missä attribuuttilistassa ilmaistaan pilkuilla toisistaan eroteltuina ne attribuutit, joiden arvojen mukaan ryhmittelyn on määrä tapahtua. 

Esimerkissä haetaan tieto siitä miten palkat jakaantuvat eri ammattiryhmien kesken (TITTLE).
```
MariaDB [sql_kyselyt]> SELECT JOB_TITLE, count(*) FROM jobs GROUP BY MAX_SALARY DESC;
+---------------------------------+----------+
| JOB_TITLE                       | count(*) |
+---------------------------------+----------+
| President                       |        1 |
| Administration Vice President   |        1 |
| Sales Manager                   |        1 |
| Finance Manager                 |        2 |
| Purchasing Manager              |        2 |
| Sales Representative            |        1 |
| Public Relations Representative |        1 |
| Programmer                      |        1 |
| Accountant                      |        4 |
| Stock Manager                   |        1 |
| Administration Assistant        |        1 |
| Purchasing Clerk                |        2 |
| Stock Clerk                     |        1 |
+---------------------------------+----------+
13 rows in set (0.001 sec)
```
Noh....ei kovin informatiivinen, joten koetetaanpa petrata hakua.

```
MariaDB [sql_kyselyt]> SELECT JOB_TITLE, MAX_SALARY, count(*) FROM jobs GROUP BY MAX_SALARY DESC;
+---------------------------------+------------+----------+
| JOB_TITLE                       | MAX_SALARY | count(*) |
+---------------------------------+------------+----------+
| President                       |      40000 |        1 |
| Administration Vice President   |      30000 |        1 |
| Sales Manager                   |      20000 |        1 |
| Finance Manager                 |      16000 |        2 |
| Purchasing Manager              |      15000 |        2 |
| Sales Representative            |      12000 |        1 |
| Public Relations Representative |      10500 |        1 |
| Programmer                      |      10000 |        1 |
| Accountant                      |       9000 |        4 |
| Stock Manager                   |       8500 |        1 |
| Administration Assistant        |       6000 |        1 |
| Purchasing Clerk                |       5500 |        2 |
| Stock Clerk                     |       5000 |        1 |
+---------------------------------+------------+----------+
13 rows in set (0.001 sec)
```
Nyt saatiin isopalkkaisimmat haettua titteleittäin, mutta miten saadaan haettua ns. palkkahaitari titteleittäin?

Kokeillaanpa ihan perinteistä vähennyslaskua, jotta saadaan isoimman ja pienimmän palkan erotus:
```
MariaDB [sql_kyselyt]> SELECT JOB_TITLE, (MAX_SALARY-MIN_SALARY), count(*) FROM jobs GROUP BY MAX_SALARY DESC;
+---------------------------------+-------------------------+----------+
| JOB_TITLE                       | (MAX_SALARY-MIN_SALARY) | count(*) |
+---------------------------------+-------------------------+----------+
| President                       |                   20000 |        1 |
| Administration Vice President   |                   15000 |        1 |
| Sales Manager                   |                   10000 |        1 |
| Finance Manager                 |                    7800 |        2 |
| Purchasing Manager              |                    7000 |        2 |
| Sales Representative            |                    6000 |        1 |
| Public Relations Representative |                    6000 |        1 |
| Programmer                      |                    6000 |        1 |
| Accountant                      |                    4800 |        4 |
| Stock Manager                   |                    3000 |        1 |
| Administration Assistant        |                    3000 |        1 |
| Purchasing Clerk                |                    3000 |        2 |
| Stock Clerk                     |                    3000 |        1 |
+---------------------------------+-------------------------+----------+
13 rows in set (0.001 sec)
```
### HAVING

Jos GROUP BY:llä tehdyn luokittelun tulosta joudutaan rajaamaan jollain ehdolla, käytetään HAVING-lausetta. Se on hyvin pitkälle sama asia kuin WHERE. 
Nyrkkisääntö on, että WHERE tulee ennen GROUP BY-ta ja HAVING GROUP BY:n jälkeen.
HAVING-lauseen syntaksi on sama kuin WHERE -lauseenkin sillä erotuksella, että myös koostefunktiot ovat sallittuja. 
On siis muistettava, että HAVING –valintaehto liittyy aina GROUP BY – määritteen käyttöön.

Tässä haetaan employees-kannasta sellaiset managerit (MANAGER_ID), joilla on enemmän kuin 1 alaista.
```
MariaDB [sql_kyselyt]> SELECT MANAGER_ID,count(*) AS lkm FROM employees GROUP BY MANAGER_ID HAVING lkm >1;
+------------+-----+
| MANAGER_ID | lkm |
+------------+-----+
|        100 |  14 |
|        101 |   5 |
|        103 |   4 |
|        108 |   5 |
|        114 |   5 |
|        120 |   8 |
|        121 |   8 |
|        122 |   8 |
|        123 |   8 |
|        124 |   8 |
|        145 |   6 |
|        146 |   6 |
|        147 |   6 |
|        148 |   6 |
|        149 |   6 |
+------------+-----+
15 rows in set (0.001 sec)
```
Kannattaa huomata, että count-funktion tulos on talletettu AS-lauseella lkm-nimiseen muuttujaan. Sitä käytetään sitten myöhemmin HAVING-ehdon kanssa.

## Rajoitteet 

CONSTRAINT-määritteellä voidaan CREATE TABLE –lauseen yhteyteen lisätä kenttien sisältöä rajoittavia ehtoja. Määrite voidaan lisätä myös jälkikäteen. 
CONSTRAINT –määritettä käytetään usein myös perusavaimen määrityksen yhteydessä. Tällöin voidaan antaa kaikille rajoituksille ja avaimille omat yksilölliset nimet, joiden perusteella näitä voidaan myöhemmin poistaa tai muuttaa.

### Tietokannan taulujen käsittely
Seuraavassa esimerkeissä opetellaan tietokannan taulujen muutoksia ja olemassa olevien taulujen käsittelyyn liittyviä asioita

HOX!!! Ensin vaihdetaan tietokantaa talujen luontia varten.
```=
use test_db;
```
Esimerkki:
```
CREATE TABLE Tyontekija ( 
tyontekijaID INTEGER NOT NULL, 
etunimi 	VARCHAR(32)	NOT NULL, 
sukunimi 	VARCHAR (64) NOT NULL, 
hetu 	 	CHAR (11) NOT NULL, 
palkka  	DOUBLE PRECISION NOT NULL DEFAULT 1500,
syntymaaika DATE NOT NULL DEFAULT CURRENT_DATE, 
osasto  	INTEGER NOT NULL DEFAULT 1, 
CONSTRAINT PrimaryKeyTyontekija 
 	PRIMARY KEY (TyontekijaID) 
); 
```
CONSTRAINT -määritteen perään annetaan jokaiselle rajoitteelle yksilöllinen nimi.
PRIMARY KEY –määritteen jälkeen luetellaan sulkeissa kenttä tai kentät, jotka muodostavat perusavaimen. 
Määritteen käyttäminen on valinnaista, kaikki rajoitteet voidaan luoda ilman CONSTRAINT -määritettä. 
Tällöin kuitenkin rajoitteiden poistaminen myöhemmin hankaloituu. 

**Oletusarvot** 
**DEFAULT**-määritteellä voidaan kentille antaa oletusarvot (muuten automaattisesti NULL). 

Oletusarvona voidaan käyttää myös joitakin funktioita, jotka saavat arvonsa ajonaikaisesti tietoja lisättäessä tai muutettaessa. SQL syntakseissa:ssa tällaisia funktioita ovat:
* USER 
* CURRENT_USER 
* SESSION_USER 
* SYSTEM_USER 
* CURRENT_DATE 
* CURRENT_TIME 
* CURRENT_TIMESTAMP

Esimerkiksi työntekijän työsopimuksen sopimispäiväksi voidaan määritellä syöttöhetkellä oleva päivämäärä:
```
CREATE TABLE Tyontekija ( 
tyontekijaID INTEGER PRIMARY KEY NOT NULL AUTOINCREMENT, 
etunimi      VARCHAR(32) NOT NULL, 
sukunimi     VARCHAR (64) NOT NULL,
hetu 	     CHAR (11) NOT NULL, 
palkka       DOUBLE PRECISION NOT NULL DEFAULT 1500, syntymaaika  DATE NOT NULL DEFAULT CURRENT_DATE, 
osasto       INTEGER  NOT NULL DEFAULT 1 
);
```
### Kaksoisarvojen poisto 

**UNIQUE**-määritteellä voidaan estää kaksoisarvojen esiintyminen jossakin kentässä.
UNIQUE – määritettä voidaan käyttää samalla tavalla CONSTRAINT –määritteen yhteydessä kuin PRIMARY KEY –määritettäkin. Tällöin määritteen yksilöllinen nimeäminen onnistuu.
```
CREATE TABLE Tyontekija ( 
tyontekijaID INTEGER NOT NULL, 
etunimi 	VARCHAR(32) NOT NULL, 
sukunimi 	VARCHAR (64) NOT NULL,
hetu 	 	CHAR (11) NOT NULL, 
palkka  	DOUBLE PRECISION NOT NULL DEFAULT 1500, syntymaaika DATE NOT NULL DEFAULT CURRENT_DATE, 
osasto  	INTEGER NOT NULL DEFAULT 1, 
CONSTRAINT PrimaryKeyTyontekija 
 	PRIMARY KEY (tyontekijaID), 
CONSTRAINT UniqueTyontekijaHetu 
 	UNIQUE (hetu) 
); 
```
UNIQUE-määritteen voi laittaa myös heti kentän määrittelyn jälkeen, mutta tällaisessa tapauksessa määritykselle ei pysty antamaan nimeä eikä pysty yhdistämään useampaa saraketta 
```
hetu 	 	CHAR (11) NOT NULL UNIQUE, 
```
### Viiteavaimet 

Viiteavaimien (FOREIGN KEY) määrittely edellyttää, että viitattava taulu on oltava myös olemassa Työntekijämme osastokentästä on viittaus Osasto-tauluun, joka on siis luotava ennenkuin viittauksia voidaan toteuttaa. 
```
CREATE TABLE Osasto ( 
osastoID INTEGER  NOT NULL, 
osastonimi VARCHAR (64)  NOT NULL, 
CONSTRAINT PrimaryKeyOsasto 
 	PRIMARY KEY (osastoID) 
); 
```
Viiteavain voidaan nyt luoda. Viiteavaimet luodaan FOREIGN KEY ja REFERENCES-määritteillä 
```
CREATE TABLE Tyontekija ( 
tyontekijaID INTEGER NOT NULL, 
etunimi 	VARCHAR(32) NOT NULL, 
sukunimi 	VARCHAR (64) NOT NULL,
hetu 	 	CHAR (11) NOT NULL, 
palkka  	DOUBLE PRECISION NOT NULL DEFAULT 1500, syntymaaika DATE NOT NULL DEFAULT CURRENT_DATE, 
osasto  	INTEGER NOT NULL DEFAULT 1,
CONSTRAINT PrimaryKeyTyontekija 
 	PRIMARY KEY (TyontekijaID), 
CONSTRAINT UniqueTyontekijaHetu 
 	UNIQUE (Hetu), 
CONSTRAINT ForeignKeyTyontekijaOsasto 
 	FOREIGN KEY (osasto) 
 	REFERENCES Osasto (osastoID) 
); 
```
FOREIGN KEY –määritteen perässä luetellaan suluissa kenttä tai kentät, joista luodaan viite-eheys. 
Heti tämän jälkeen tulee REFERENCES -määrite, jonka perään kirjoitetaan viitattavan taulun nimi ja suluissa kenttä, johon viitataan. 
Jos viitattava kenttä on taulun perusavain, niin kenttää ei ole pakko mainita. Lisäksi voidaan kertoa, mitan pitää toimia jos eheyttä yritetään rikkoa poistamalla tai päivittämällä äiti-taulun kenttiä määrittämällä viite-eheysrajoitteiden voimassa pitämisen säännöt. 

### Viite-eheysrajoitteet 
**NO ACTION **
Oletus, jos mitään ei ole määritelty. Tietokannan hallintajärjestelmä huomaa tehtyään vaaditun päivityksen tai poiston, että tapahtuma rikkookin viite-eheyden, ja peruuttaa tekemänsä muutoksen . Tämä rajoite toimii siis siten, että käytännössä ei sallita muuttaa tai poistaa viittauksen kohteena olevia arvoja äiti-taulusta. 
 
**SET NULL** 
Tämä rajoite ei estä päivityksen tai poistojen tekemistä. Rajoite aiheuttaa poistuvaan tai muuttuvaan äiti-taulun tietueeseen viittaavien lapsi-taulun kenttien arvon muuttumisen NULL-arvoksi. Tämän rajoitteen edellytyksenä on, että viittaavalle kentälle pitää olla sallittu NULL-arvot. 
 
**SET DEFAULT**
Rajoite toimii kuten SET NULL, mutta asettaa viittaaviin kenttiin arvoiksi niiden oletusarvon. Edellyttää, että äiti-taulusta löytyy oletusarvoa vastaava tietue 
 
**CASCADE**
CASCADE on rajoite, joka vyöryttää äiti-tauluun kohdistuvan operaation lapsi-tauluun. Rajoitteen avulla voidaan määrittää sekä tietueiden poistot että tietojen päivitykset. 
 
**RESTRICT (SQL99)** 
SQL99-standardin tuoma lisäys, joka toimii kuten NO ACTION, mutta varsinaista päivitystä tai poistoa ei koskaan pääse tapahtumaan vaan tietokannan hallintajärjestelmä huomaa jo ennen tapahtumaa, että viite-eheyttä ollaan rikkomassa. 

Lisätään Tyontekija-taulun osasto-kentän viite-eheysmäärittelyn säännöt, jotka sallivat päivityksen vyörymisen, mutta kieltävät poistot. Näin ollen: jos osastoID vaihtuu joskus, se päivittyy automaattisesti työntekijän tietoihin. Osastoa ei voida poistaa niin kauan kuin siellä työskentelee yksikin työntekijä 
```
CREATE TABLE Tyontekija ( 
tyontekijaID INTEGER NOT NULL, 
etunimi 	VARCHAR(32) NOT NULL, 
sukunimi 	VARCHAR (64) NOT NULL,
hetu 	 	CHAR (11) NOT NULL, 
palkka  	DOUBLE PRECISION NOT NULL DEFAULT 1500, syntymaaika DATE NOT NULL DEFAULT CURRENT_DATE, 
osasto  	INTEGER NOT NULL DEFAULT 1,
CONSTRAINT PrimaryKeyTyontekija 
 	PRIMARY KEY (TyontekijaID), 
CONSTRAINT UniqueTyontekijaHetu 
 	UNIQUE (hetu), 
CONSTRAINT ForeignKeyTyontekijaOsasto 
 	FOREIGN KEY (osasto) 
 	REFERENCES Osasto (osastoID) 
 	 	ON UPDATE CASCADE 
 	 	ON DELETE NO ACTION 
); 
```
### Tarkistukset 
CHECK-lauseella voidaan luoda monimutkaisia tarkistussääntöjä, jotka kohdistuvat yhteen tai useampaan kenttään samanaikaisesti. Yleisimmin käytetty NOT NULL -määritys on oikeasti vain lyhennetty versio CHECK –määrityksestä. 

CHECK-lause voi sisältää hyvinkin monimutkaisia ehtoja esitettynä monimutkaisilla SELECTlauseilla ja alikyselyillä. Määritellään palkan alarajaksi 0 ja ylärajaksi 10 000 sekä rajat syntymäajalle.
```
CREATE TABLE Tyontekija ( 
tyontekijaID INTEGER NOT NULL, 
etunimi 	VARCHAR(32) NOT NULL, 
sukunimi 	VARCHAR (64) NOT NULL,
hetu 	 	CHAR (11) NOT NULL, 
palkka  	DOUBLE PRECISION NOT NULL DEFAULT 1500, syntymaaika DATE NOT NULL DEFAULT CURRENT_DATE, 
osasto  	INTEGER NOT NULL DEFAULT 1,
CONSTRAINT PrimaryKeyTyontekija 
 	PRIMARY KEY (TyontekijaID), 
CONSTRAINT UniqueTyontekijaHetu 
 	UNIQUE (hetu), 
CONSTRAINT ForeignKeyTyontekijaOsasto 
 	FOREIGN KEY (osasto) 
 	REFERENCES Osasto (osastoID) 
 	 	ON UPDATE CASCADE 
 	 	ON DELETE NO ACTION 
CONSTRAINT CheckTyontekijaPalkka 
 	CHECK ( Palkka > 0 AND Palkka < 10000 ), 
CONSTRAINT CheckTyontekijaSyntymaaika 
 	CHECK ( Syntymaaika > ’1940.1.1’ AND Syntymaaika < CURRENT_DATE )
);
```
### ALTER TABLE 
ALTER TABLE –komennolla voidaan muuttaa jo olemassa olevien taulujen rakennetta. Ohjelmistosta riippuen on mahdollista mm. lisätä uusia sarakkeita, muuttaa vanhojen sarakkeiden määrityksiä sekä poistaa sarakkeita. 
 
Sarakkeiden, viiteavainten ja oletusarvojen lisääminen voidaan tehdä jo olemassa oleviin tietokannan tauluihin käyttämällä ALTER TABLE komentoa. 
Lisäykset ja niiden vaikutukset ja riippuvuudet muihin tietokannan tauluihin kannattaa suunnitella huolellisesti ennen taulujen rakenteen muutoksia. 

Lisätään esimerkiksi Tyontekija-tauluun kenttä, johon tulee työntekijällä olevan kulkuluvan tiedot: 
``` 
ALTER TABLE Tyontekija 
ADD COLUMN kulkuLupa CHAR (11);
```
COLUMN-sanan voi tarvittaessa jättää pois. Uutta saraketta ei voi määritellä pakolliseksi, koska sille ei ole olemassa tietoa aikaisemmin taulussa olevissa monikoissa. 
Myös viiteavainten lisääminen olemassa olevaan tauluun on mahdollista. On kuitenkin otettava huomioon, että viitattavan taulun on oltava olemassa viiteavainta lisättäessä. 
Esimerkin tapauksessa olisi järkevin tehdä oma taulu kulkuluville ja lisätä vain viiteavain kulkulupaID -arvoon Työntekijä-tauluun.

# MySQL - Osa 4 - Tietokantakyselyt

Sisältö:
- Ryhmittely
- Case -lause
- Liitokset
- Alikyselyt

## Koostefunktioiden käyttö kyselyissä

Seuraavien esimerkkien tietokanta on hukassa, mutta ei hätää: koostefunktioita käytetään seuraavassa osiossa Opiskelija-tietokannan kanssa.

Koostefunktioita käytetään SELECT-lauseen sarakeluettelossa ja HAVING-lauseessa

SELECT MAX(hinta), MIN(hinta)
FROM tuote
-- suurin ja pienin hinta

WHERE-lauseessa koostefunktioita ei voi käyttää (vaan ne on laitettava HAVING-lauseeseen), esim. Haetaan myyjät, joiden myymien tuotteiden hinta yhteensä on yli 5000:

SELECT myyja, SUM(hinta)
FROM tuote
GROUP BY myyja
HAVING SUM(hinta) > 5000

-- tuotteiden hintojen summa
-- ryhmittely myyjän mukaan

**DISTINCT-rajaus**
SELECT COUNT(DISTINCT city)
FROM authors

-- monestako kaupungista
-- kirjailijoita

### Ryhmittely - GROUP BY
GROUP BY -ehdolla tiedot ryhmitellään jonkin sarakkeen
tai sarakkeiden mukaan ryhmiin
– GROUP BY -ehdon ryhmiin kohdistetaan yleensä jokin
summafunktio
– kaikki SELECT-listan lauseet, joissa ei ole funktiota, on lueteltava GROUP BY –lauseessa!
Esim 1. kunkin myyjän tuotteiden hintojen keskiarvo:

*SELECT myyja, AVG(hinta)
FROM tuote
GROUP BY myyja*

Esim 2.Kunkin myyjän myymien tuotteiden määrä:

*SELECT myyja, COUNT(myyja)
FROM tuote
GROUP BY myyja*

### Ryhmittely - HAVING
Sekä HAVING- että WHERE-lauseella voidaan ryhmittelyn
tulosta rajata:

SELECT myyja, COUNT(*)
FROM tuote
WHERE tuoteHinta > 100
GROUP BY myyja
HAVING COUNT(*) >2

-- myös NULL kelpaa
-- hae myyjät joilla
-- vähintään 3 tuotetta

**Tulosjoukkoa voidaan siis rajata eri tasoilla:**
– rajataan ensiksi ryhmiteltävä joukko WHERE-lausekkeella
– tästä syntynyt tulos ryhmitellään GROUP BY -määrittelyllä
– lopuksi ryhmiteltyä joukkoa voidaan vielä rajata HAVING-lauseella

### MUITA FUNKTIOITA
Numerofunktioita ovat mm. desimaalien
pyöristysfunktiot **ROUND ja FLOO**R; 

ROUND- funktiolla saadaan luku pyöristettyä kokonaisluvuksi:

*SELECT ROUND(palkka*1.1,0) AS palkankorotus
FROM henkilo*

NULL-arvon muuttamiseen voidaan käyttää esim. COALESCE-funktiota, jolla NULL muutetaan esim.
nollaksi: 

*COALESCE(sarake, 0)*

Päivämääräfunktioiden osalla tuotekohtaiset maa-asetukset huomioitava
– ANSI-standardissa CURRENT_DATE: tämä päivä

### CASE-LAUSE
Tarvitaan kun sarakkeen otsikko riippuu sarakkeen arvosta

Kaksi syntaksia (sarakenimen kanssa tai ilman)

Esimerkiksi haetaan tuotteita ja luokituksia:

*SELECT tuote_nimi,
CASE
WHEN hinta < 100 THEN 'edullinen'
ELSE 'laatutavara'
END AS luokitus
FROM tuote*

### Alikyselyt
Alikyselyillä voidaan useampia kyselyjä ”ketjuttaa” ja 
kyselyn osia korvata toisen kyselyn tuloksilla

Esimerkki:

*SELECT Etunimi, Sukunimi FROM Opiskelija WHERE 
Opintopisteet = (SELECT MAX(Opintopisteet) FROM 
Opiskelija)*

**Alikyselyistä lisää Monimutkaisten SQL-kyselyiden alla!**

# Harjoitukset - Relaatiotietokantojen perusteita

## Relaatiotietokantojen perusteita harjoitus

Tässä vaiheessa viimeistään on hyvä aloittaa kurssin pakollisten palautettavien harjoitusten teko

# Linkit

- SQL Basics: https://www.youtube.com/watch?v=HXV3zeQKqGY&t=2611s
- Creating Tables: https://www.youtube.com/watch?v=HXV3zeQKqGY&t=4549s
- Inserting Data: https://www.youtube.com/watch?v=HXV3zeQKqGY&t=5465s
- Constraints: https://www.youtube.com/watch?v=HXV3zeQKqGY&t=5897s
- Update & Delete: https://www.youtube.com/watch?v=HXV3zeQKqGY&t=6491s
- Basic Queries: https://www.youtube.com/watch?v=HXV3zeQKqGY&t=6971s
- More Basic Queries: https://www.youtube.com/watch?v=HXV3zeQKqGY&t=9027s
- Functions: https://www.youtube.com/watch?v=HXV3zeQKqGY&t=8784s
- Wildcards: https://www.youtube.com/watch?v=HXV3zeQKqGY&t=9913s

[05: Tietokannan hallinta](/05_tietokannan_hallinta) <----------> [07: Vaativammat tietokantakyselyt](/07_vaativammat_tietokantakyselyt)
