# 09: Indeksit jatkoa ja tietokannan optimointi

![alt text](images/09_indeksit_ja_tietokannan_optimointi_header.png "Indeksit ja tietokanna optimointi")

Sisällysluettelo:

[[_TOC_]]

Linkit-osiossa linkkejä ulkoisiin lähteisiin, joissa käydään tunnin asioita läpi englanniksi.

# MySQL - Osa 9 - Indeksit ja Tietokannan optimointi

Sisältö:
1. Tietokannan suunnittelun periaatteet - hyvät käytänteet?
2. Tietokantojen muutokset - sudenkuoppien välttäminen
3. Tietokannan normalisointi ja indeksoinnin perusteita
4. Triggerit
5. Indeksit

## Tietokannan suunnittelu

Tietotarpeet ovat lähtökohta
* Käsitekaaviolle
* Tietokannan tietosisällölle ja rakenteelle
![](images/09_01_kasitekaavio.png)
Käsitekaaviota voidaan lähteä rakentamaan myös ilman
tarkkaa tietotarpeiden määrittelyä
* Nopeaa
* Virheet ja puutteet jäävät helposti huomaamatta

## Looginen suunnittelu
Tietokannan käsitteellinen malli sovitetaan käytettävän tietomallin mukaiseksi (esim. relaatiotietokannan malliksi)

Looginen suunnittelu on riippumaton käytettävästä´tietokantatuotteesta ja laitealustasta

1. Laadi relaatiokaavio käsitekaavion pohjalta
2. Johda relaatiokaavat
3. Normalisoi
4. Tarkista relaatiot suhteessa tietotarpeisiin
5. Korjaa relaatiokaaviota tarvittaessa
6. Määrittele eheyssäännöt

## Luokkakaaviosta relaatiokaavoiksi
1. Olioluokka kuvataan omana relaationaan
2. Yksiarvoinen ominaisuus liitetään sen relaation attribuutiksi, johon se liittyy
5. Moniarvoinen ominaisuus kuvataan omana relaationaan
3. Itsenäisen olioluokan pääavaimeksi luodaan juokseva numero
4. Alityyppi kuvataan omana relaationaan.
   1. **pääavain on sama kuin emotyypin pääavain**
   2. **pääavain myös viiteavaimeksi viittaamaan emotyyppiin.**
5. Aggregaattiluokan pääavaimeksi luodaan juokseva numero, viiteavain viittaamaan koostuvaan luokkaan
6. Yhteysluokan pääavain muodostuu kunkin osallistuvan luokan pääavaimesta. Kukin näistä määritellään erikseen myös viiteavaimeksi
7. 1:n –yhteys kuvataan liittämällä viiteavain yhteyden n- päässä olevaan olioon
7. m:n –yhteys kuvataan omana relaationaan
8. Yhteys, johon liittyy attribuutteja kuvataan omana relaationaan

### Relaatiokaavat
Malli, jonka mukaan tietokannan tiedot organisoidaan. Tietomalli koostuu joukosta peruskäsitteitä, -sääntöjä ja operaatioita
![](images/09_02_relaatiokaava.png){width=50% height=50%}

Perusajatuksiltaan tulee olla:
* yksinkertainen
* yksiselitteinen
* selkeä 
* SQL hakuehtojen mukaisesti tulee pohjautua joukko-opin käsitteisiin.
* nimeämiskäytänteet kuvaavia

### Mietittäviä asioita

1. Mikä on datan käytön tarkoitus?
2. Kuinka usein päivityksiä tulee tietokantaan?
3. Onko tiedot oltava järjestyksessä jonkun kentän mukaan järjestettynä, esim aakkosjärjestys, aikaleima jne?
4. Mihin kenttiin = tietoihin haluehdot useimmiten kohdistusvat? - > tulee välttää kahden tai useamman taulun liitoksia tällaisissa kyselyissä.
5. Onko tallennettu data jotenkin esikästeltyä vai tuleeko hakuehdoissa poistaa virheelliset tiedot?
6. Kuinka monesta lähteestä dataa tulee - > Samanaikaisuuden vaatimukset?
7. Kuinka usein tallennuksia tapahtuu esim. n kertaa/sekunti -> Mikä on reaaliaikaisuuden vaatimus?
8. Mikä on hakuehdon minimivasteaika?
9. Käyttäjäautentikointi
10. M-to-M -> Onko tietokantaan tallentava aktori laite? Miten ehkäistään virhetilanteet?

### Fyysisen tietokannan suunnittelun vaiheet

**Käännä looginen tietomalli DBMS:lle sopivaksi**
- Suunnittele taulut
- Suunnittele liiketoiminnalliset säännöt

**Suunnittele fyysinen esitysmuoto**
- Analysoi tapahtumia
- Valitse tiedostojen organisaatio
- Valitse indeksit

**Arvioi kontrolloidun redundanssin lisäämistä**
- Arvioi johdettua tietoa
- Arvioi sarakkeiden kahdennusta tai taulujen liittämistä

**Suunnittele turvallisuusmekanismit**
- Suunnittele käyttäjille näkymät
- Suunnittele saantisäännöt

**Valvo ja viritä toimivaa järjestelmää**

## Indeksointi - syventävää osaamista


Tietokantatauluun kohdistuvissa kyselyissä hakua rajataan ehdoilla. 

Esimerkiksi kysely:
SELECT * FROM Tenttii WHERE Arvosana = '2', hakee kaikki taulussa olevat rivit, joissa annetun sarakkeen 'Arvosana' arvo on '1'. Oletuksena tietokantamoottori käy läpi kaikki rivit, ja valitsee niistä vain ne rivin, joissa sarakkeen arvo on haluttu. Jos rivejä on vaikkapa 100 miljoonaa, käydään niistä jokainen yksitellen läpi.

Tietokantakyselyiden tehostamista on tutkittu paljon, ja tietokantamoottorit tarjoavat tyypillisesti erilaisia välineitä kyselyiden tehostamiseksi. Yksi väline on usein toistuvien hakujen tehostamiseen tarkoitettu indeksi, eli hakurakenne.

Tauluille voidaan perustaa sarakekohtaisia hakemistoja eli indeksejä, esim.
```
CREATE INDEX i_postinro ON henkilo(postinro)
```

Indeksien käytön tarkoituksena on mm. nopeuttaa tietokantaan tapahtuvia hakuja.

Yksilöivä (unique) indeksi voi toimia myös perusavaimena
```
CREATE UNIQUE INDEX i_sarake ON taulu(sarake)
```

### Indeksien käyttö

**Indeksoinnin etuja:**
* hakujen, liitosten, ryhmittelyjen ja lajittelujen nopeutuminen
* pakottaa yksilöimään rivit

**Kannattaa indeksoida:**
* perusavaimet ja viiteavaimet (jokainen viiteavain erikseen!)
* sarakkeet, joita haetaan tai järjestetään usein (ja joissa on paljon tietoa eli rivejä on tuhansia tai miljoonia)

Kannattaa huomioida, että indeksointi vie levytilaa ja aikaa luotaessa ja muutoksissa.

**Ei kannata indeksoida:**
* harvoin haussa käytettäviä sarakkeita
* sarakkeita, joiden selektiivisyys (erottelukyky) on huono (esim henkilo-taulun ostun-kenttä on huono koska henkilöitä kuuluu vain muutamaan osastoon)


Peukalosääntö indeksin luomiselle (nk. 3 tähden indeksi)

* Ota kaikki WHERE-kohdassa mainitut sarakkeet
* Lisää ORDER BY –kohdassa mainitut sarakkeet
* Laita loppuun SELECT-lauseessa olevat sarakenimet


Esimerkiksi kyselylle:
```
SELECT yksi, kaksi, kolme FROM taulu WHERE nelja = ’x’ ORDER BY kaksi;
```
paras mahdollinen indeksi olisi
```
CREATE INDEX i_esimerkki_indeksi ON taulu(nelja,kaksi,yksi,kolme)
```

Jos kaikki SELECTissä mainitut sarakkeet on mukana indeksissä, kyse on paksusta indeksistä.

Indeksi poistetaan DROP INDEX -käskyllä

### Indeksoinnin taustaa

Indeksien tarkoituksena on nopeuttaa hakuja tietokannasta. Indeksiä voisi kuvata kirjan
aakkosjärjestyksessä olevaan hakemistoon. Kirjan joka sivua eikä taulun jokaista riviä tarvitse käydä läpi, jotta pääsisi käsiksi haluttuun kohtaan. Fyysisesti indeksit tallennetaan indeksitiedostoon.
Indeksien suunnittelu alkoi 60-luvulla. Silloin yritettiin matriisien avulla arvioida, kuinka usein tietokannan taulun kutakin kenttää luettiin, lisättiin ja poistettiin. Matriiseista saatiin indeksoitavat sarakkeet. Indeksien oletettiin olevan yksikenttäisiä kenttiä ja tavoitteena oli järjestelmän kokonaiskuormituksen minimointi.
80-luvulla alettiin yleisesti ymmärtää, että indeksien suunnittelun tavoite on saada kaikki haut mahdollisimman nopeiksi. Sovellusten mutkistuessa ja tietokantojen kasvaessa indeksoinnin suunnittelun tärkeys ja vaikeus tiedostettiin. Tiedonhallintasovelluksiin alettiin kehittää optimointiohjelmaan perustuvaa järjestelmää, joka ehdottaa indeksejä tuotanto-otoksen perusteella.

Indeksoinnin systemaattinen suunnittelu koostuu kahdesta osasta. 
1. Ensin etsitään hakulause, joka on, ainakin pahimmassa tapauksessa, puutteellisen indeksoinnin vuoksi liian hidas. 
2. Tämän jälkeen suunnitellaan indeksi, joka on riittävän hyvä kyseiselle hakulauseelle, mutta joka ei hidasta tuntuvasti muita lauseita.

## Indeksi ja Normalisointi - syventävää osaamista

Tietokannan normalisointi on askeleittainen lähestymistapa tiedon jakamiseen loogisiksi tietokantatauluiksi ja niiden sarakkeiksi. Pääpiirteittäin lopputavoite on sama kuin käsiteanalyysissä -- jokaisen taulun pitäisi liittyä tiettyyn aiheeseen, ja tauluun määritellään vain sarakkeita jotka liittyvät samaan aiheeseen.

Lähestymistapa on kuitenkin toisenlainen: 

Tietokannan normalisoinnissa tutkitaan tiedon välisiä riippuvuuksia ja suhteita, ja etsitään epäkohtia. Epäkohdat tyypillisesti jaetaan useampaan osaan -> tauluiksi. Normalisointia tehdään yleensä ER -suunnittelun kanssa samanaikaisesti.

**Lähtökohtana tietokannan normalisoinnille ovat seuraavat relaatiomalliin liittyvät oletukset:**

* Jokaisen tietokantataulun sarakkeen nimen tulee olla uniikki. Tietokantataulussa ei siis saa olla kahta saman nimistä saraketta.
* Jokaisen tietokantataulun sarakkeen tulee olla sellainen, että se sisältää korkeintaan yhden arvon. Yksittäisessä sarakkeen rivissä ei siis esimerkiksi saa säilöä listaa asioita.
* Jokaisen tietyssä tietokantataulun sarakkeessa olevan arvon tulee olla saman tyyppinen. Eri riveillä, mutta samassa sarakkeessa ei siis saa olla esimerkiksi kokonaislukutyyppisiä arvoja ja merkkijonotyyppisiä arvoja.
* Tietokantataulun sarakkeiden järjestyksen ei tule vaikuttaa tietoon. Sarakkeiden paikkaa tulee siis voida vaihtaa tarvittaessa.
* Tietokantataulussa ei tule olla kahta tai useampaa täsmälleen samat arvot sisältävää riviä. Jos rivi esiintyy kerran, ei sen toistamisesta ole hyötyä.
* Tietokantataulussa olevien rivien järjestyksellä ei tule olla merkitystä.

Tietokannan normalisointiin liittyy useampia tavoitteita; 
1. tiedon kopioiden minimointi, 
2. tiedon muuttamiseen liittyvien ongelmien vähentäminen,
3. tietokantaan tehtävien kyselyiden yksinkertaistaminen.


### Tietokannan toteutus - syventävää osaamista
Tietokannan toteutuksessa muunnetaan käsitemalli (ER-malli) tiettyjen sääntöjen mukaan tauluiksi ja määritellään perusindeksointi. 
Tässä fyysiseen suunnittelun vaiheessa määritellään taulujen tilavaraukset, sijoittelut ja osiointi. 
Lopuksi viritetään suorituskyky eli suunnitellaan indeksointi.

Indeksointidokumentti on käytännössä matriisi, jossa on taulun sarakkeiden nimet ja neljä saraketta.

Ensimmäiseen laitetaan rasti niiden sarakkeiden kohdalle, jotka esiintyvät hakulauseessa.

Toiseen sarakkeeseen pannan rasti niille, joihin liittyy yhtäsuuruus-ehto.

Kolmanteen sarakkeeseen laitetaan rasti niille, joihin liittyy arvoväli-ehto. 

Neljänteen sarakkeeseen merkitään lajitteluvaatimus. 

Esim. jos on lajittelu sukunimen ja etunimen mukaan nousevasti, tulisi sukunimen kohdalle 1a ja etunimen kohdalle 2a. Tämä menettely antaa riittävän tiedon yksinkertaisten indeksien suunnittelulle.

Käytetään esimerkkinä seuraavaa yhden taulun avulla määriteltyä Asiakas -tietokantaa, joka kertoo asiakkaan tiedot, laskutusosoitteen, ja kuljetusosoitteen.
Yhteen tauluun kohdistuvien hakujen kohdalla voidaan myös laatia erillinen taulukohtainen indeksidokumentti pohjaksi indeksien suunnittelulle.  

![](images/09_03_tk_toteutus_01_pohja.png)

### Ensimmäinen normaalimuoto
Ensimmäisessä normaalimuodossa olevien tietokantataulujen sarakkeiden arvot eivät saa olla listoja, eivätkä sarakkeet saa sisältää toistuvia ryhmiä. Jos tietokantataulun sarake olisi esimerkiksi "puhelinnumerot", mikä voisi sisältää useamman puhelinnumeron, tulisi se pilkkoa osiin, aivan kuten toistuvat arvot. Sama juttu on osoitteen kohdalla.  

![](images/09_04_tk_toteutus_02_1n.png)

### Toinen normaalimuoto

Ensimmäisessä normaalimuodossa kyse on ensiaskeleista tietokannan rakenteen järkevöittämiseen. Muissa normaalimuodoissa käsite funktionaalinen riippuvuus sarakkeiden välillä on oleellinen.

#### Funktionaalinen riippuvuus

Sarake B on funktionaalisesti riippuvainen sarakkeesta A, jos sarakkeen A arvon perusteella voidaan yksikäsitteisesti selvittää sarakkeen B arvo. Tällöin kirjoitetaan A -> B, ja sanotaan, että "sarake B on funktionaalisesti riippuvainen sarakkeesta A". 

Esimerkiksi taulun Henkilo sarakkeet "etunimi" ja  "sukunimi" ovat funktionaalisesti riippuvaisia sarakkeesta henkilötunnus, sillä henkilötunnuksen perusteella voidaan yksikäsitteisesti selvittää nimi.

Selvittäminen voi tapahtua kyselyllä "SELECT DISTINCT b FROM Taulu WHERE a=tiedetty_arvo". Jos attribuutti b on funktionaalisesti riippuva a:sta, tuottaa ylläoleva kysely joko yhden tai ei yhtään tulosriviä, mutta ei koskaan enempää. Tämän ehdon on oltava voimassa aina, ei vain hetkellisesti.

Tietokanta on **toisessa normaalimuodossa** jos
1. se on ensimmäisessä normaalimuodossa.
2. tietokantataulun sarakkeet (poislukien avaimet) ovat funktionaalisesti riippuvaisia tietokantataulun pääavaimesta.

Jos tietokantataulun pääavain on määritelty yhden sarakkeen avulla, ovat kaikki sen sen sarakkeet automaattisesti funktionaalisesti riippuvaisia pääavaimesta. Käytännössä siis, jos taulu on ensimmäisessä normaalimuodossa ja sillä on yhden tai useamman sarakkeen kautta määritelty pääavain, on se automaattisesti toisessa normaalimuodossa.

#### Kolmas normaalimuoto
Määritelmän mukaan tietokantataulu on kolmannessa normaalimuodossa jos:
1. se on toisessa normaalimuodossa
2. siinä on vain sarakkeita, jotka eivät ole transitiivisesti riippuvaisia taulun pääavaimesta. 

#### Transitiivinen riippuvuus

Transitiivisella riippuvuudella tarkoitetaan sitä, että sarake A on riippuvainen sarakkeesta B jonkun toisen sarakkeen kautta. Käytännössä sarake A on transitiivisesti riippuvainen sarakkeesta B, jos sarake A on riippuvainen sarakkeesta C, joka on riippuvainen sarakkeesta B. Tässä A, B ja C voivat sisältää myös useampia sarakkeita.

Kaikkien tietokantataulun sarakkeiden tulee olla itsenäisiä ja riippumattomia muista pääavaimeen kuulumattomista kentistä. Jos tietokantataulusta tunnistetaan sarakkeita, jotka ovat transitiivisesti riippuvaisia pääavaimesta, eriytetään ne omaksi taulukseen.

Esimerkiksi Osoite-taulussa oleva sarake kaupunki on transitiivisesti riippuvainen asiakkaasta postinumeron kautta. Voimme tällöin luoda uuden tietokantataulun Postinumero, joka sisältää jokaiseen postinumeroon liittyvät kaupungit.

MariaDB:n ohjetta https://mariadb.com/kb/en/library/getting-started-with-indexes/

## Indeksoinnin Peruskäsitteitä

**Perusindeksit**  
Perusindeksi perustuu järjestetyn tiedoston järjestysavainkenttään. Siten perusindeksikentän arvolla ei tietueessa saa esiintyä samaa arvoa kahdesti tai useammin, eli dublikaatteja.  

![](images/09_05_perusindeksit.png)

Perusindeksiä (primary index) kutsutaan myös nimellä päähakemisto. Tämä siksi, että perusindeksi perustuu järjestetyn tiedoston fyysiseen tallennusrakenteeseen.

Perusindeksi on järjestetty taulu, joka sisältää kaksi kiinteämittaista kenttää.
Ensimmäiseen kenttään on tallennettu taulun järjestysavaimen arvo, joka toimii samalla taulun perusavaimena (primary key). Toinen kenttä sisältää osoittimen levylohkoon, jossa perusavaimen arvoa vastaava tietue sijaitsee. Jokaista levylohkoa kohti on tarkalleen yksi tietue perusindeksitaulussa, mutta kaikkia taulun tietueita kohti ei välttämättä ole olemassa tietuetta perusindeksitaulussa.

Pääindeksi on siten toteutukseltaan harva. 


**Ryvästävät indeksit**  
Datatiedoston tietueet on järjestetty fyysisesti muun kuin avainkentän mukaan. Ryvästävän indeksin käyttötarkoitus on kuitenkin sama kuin perusindeksinkin eli tietueiden nopeutunut haku tiedoston fyysisen lajittelukentän arvon mukaisesti. Ryvästävä indeksi sallii indeksikentälle myös dublikaatteja.  

![](images/09_06_ryvastavat_indeksit.png)

* Ryvästävä indeksi (clustering index) on indeksityyppi, joka vaikuttaa myös taulun rivien järjestykseen. 
* Taulun rivit ovat siis samassa järjestyksessä kuin indeksikin. 
* Tiedosto pyritään pitämään järjestettynä tämän kentän mukaan (esim. riittävän tiheällä uudelleenjärjestelyllä).
* Hallintajärjestelmän tehtävänä on huolehtia siitä, että tämä järjestys myös säilyy. 
* Koska taulu voidaan järjestää vain yhdellä tavalla kerrallaan, voi sillä olla luonnollisesti vain yksi ryvästävä indeksi -> on tärkeää valita ryvästävä indeksi oikein.  


### Indeksoinnin periaatteita
Indeksiä kehitettäessä on tärkeää, että indeksiin liitetään **riittävästi sarakkeit**a ja sarakkeiden täytyy olla **oikeassa järjestyksessä**. Indeksejä täytyy lisätä myös riittävästi, niin että kaikilla hakulauseilla on riittävät indeksit.

Tietokannan indeksointiin liittyy harhaluuloja, jotka johtuvat aikaisemmista pienistä ja kalliista
kovalevyistä. Tietokannat ovat kasvaneet ja levytila halventunut. Nykyisin voidaan olettaa, että B-puun ylätasojen sivut pysyvät joko keskusmuistissa tai levypalvelimen välimuistissa. Vain indeksin lehtisivut joudutaan lukemaan kiintolevyltä.

1. usein päivittyviä sarakkeita ei pidä indeksoida.
Miksi ei saisi?

Käytännössä nelitasoisen indeksin kolme ylintä tasoa ovat keskusmuistissa ja hajaluku pyörivältä
kiintolevyltä vie keskimäärin 10 millisekuntia, on vasteaika noin 20 millisekuntia.
RAID 5 -levypalvelimilla yhden sivun hajaluku pitää yhden kiintolevyn varattuna noin 6 millisekuntia.
Lisäksi monisarakkeiset indeksit sisältävät sarakkeita, jotka tekevät indeksiavaimen yksilöiväksi. 
Kun volatile (= pysyvä) sarake lisätään tällaisen indeksin loppuun, ei tämän sarakkeen päivitys aiheuta indeksirivin siirtymistä toiselle lehtisivulle. 
Volatiilin sarakkeen päivitys lisää tällöin nykylevyillä vasteaikaa vain 10 millisekuntia, jos se on kopioitu yhteen indeksiin.
Lisäksi isoimmat indeksit voidaan hajauttaa kymmenille kiintolevyille, joten levykuormitus alkaa olla todellinen ongelma RAID 5 -levyillä vasta, kun indeksoitu sarake päivittyy yli 100 kertaa sekunnissa.

2. Indeksissä saa olla korkeintaan viisi tasoa
Miksi ei?
Kun yläsivut ovat keskusmuistissa, kuudes indeksitaso lisää indeksihaun kestoa nykyisin käytössä olevilla suorittimilla noin 10 mikrosekuntia.
3. Taululla saa olla korkeintaan kuusi indeksiä
Miksi ei saisi olla?
Indeksien määrää taulua kohti ei pidä rajoittaa mihinkään tiettyyn lukumäärään. On tauluja, jotka eivät siedä edes kahta indeksiä ja on tauluja, jotka sietävät 20 indeksiä.
Lajittelut ovat nykyservereillä varsin nopeita, indeksin luonti miljoonan rivin taululle vie tyypillisesti pari minuuttia. Ylimääräisten indeksien olemassaolo ei vahingoita kyselyn suoritusta, kunhan ei käytä vääränlaisia indeksejä.
Lisäykset eivät ole yleensä ongelma. Poistot sen sijaan ovat hankalampia, sillä B-puut eivät käyttäydy käänteisesti kun rivejä lisätään ja sitten poistetaan niitä. Suuria poistoja tehtäessä saatetaan toisinaan joutua rakentamaan indeksit uudelleen jotta saataisiin palautettua indeksien täysi teho.

### B-Puu

![](images/09_07_bpuu.png)

Esimerkki:  

![](images/09_08_indeksit_esim.png)

Ratkaisu:  

![](images/09_09_indeksit_esim_ratk.png)

Toteutus:  

![](images/09_10_indeksit_esim_tot.png)

### InnoDB tietokantamoottori
InnoDB-tallennusmoottori tukee  peruutusta
(rollback) ja  vikatilanteista toipumista (crash-recovery) tietojen suojelemiseksi. InnoDB tallentaa tiedon ryvästävään indeksiin (clustered index). 
Kaikki InnoDB:n indeksit ovat B-puu- tietorakenteeseen perustuvia, joissa osoittimet on tallennettu puun lehtisivuille.

Indeksisivu on oletuksena kooltaan 16 KB. Kun indeksiin lisätään uusia tietueita, tallennusmoottori pyrkii jättämään 1/16 lehden tilasta vapaaksi tulevia lisäyksiä ja päivityksiä varten. 
InnoDB on suunniteltu mahdollisimman tehokkaaksi käytettäessä suuria tietomääriä. Tieto ja indeksit tallennetaan ”taulualueeseen” (tablespace), joka voi koostua useista tiedostoista tai levyosioista. 
InnoDB käyttää BTREE-indeksejä järjestetyllä perusavaimella.
Tallennusmoottori osaa luoda automaattisesti myös hajautusindeksejä (hash index) keskusmuistiin, mikäli se tunnistaa yleisiä kyselyrakenteita. 


### Indeksit: miten indeksointi vaikuttaa suorituskykyyn?

Käytetään tässä harjoituksessa Dockeriin luotavaa tietokantaa.
Nimetään tietokanta nimellä indeksi_testi.

Käynnistetään ensin MariaDB
```
eero@Kamk-eero:~$ docker start mariadbtest
mariadbtest
```
Ja luodaan terminaaliyhteys palvelimeen
```
eero@Kamk-eero:~$ docker exec -it mariadbtest bash
root@24af408abc30:/# mysql -u root -p
Enter password: 
Welcome to the MariaDB monitor.  Commands end with ; or \g.
Your MariaDB connection id is 8
Server version: 10.3.14-MariaDB-1:10.3.14+maria~bionic mariadb.org binary distribution

Copyright (c) 2000, 2018, Oracle, MariaDB Corporation Ab and others.

Type 'help;' or '\h' for help. Type '\c' to clear the current input statement.

MariaDB [(none)]> 
```
Luodaan ensin tietokanta:
```
CREATE DATABASE indeksi_testi;

use indeksi_testi;

-- Luodaan taulu, lisätään dataa, katsotaan tulos
CREATE TABLE henkilot (
tunnus varchar(6) not null,
sukunimi varchar(128) not null,
etunimi varchar(128) not null,
osoite varchar(255) not null,
puhnro varchar(64) not null,
email varchar(128),
PRIMARY KEY (tunnus),
UNIQUE (email)
);

INSERT INTO henkilot VALUES
('havpen', 'Haverinen', 'Pentti', 'Poritie 4', '00001','pena@server.fi'),
('kanvis','Kanninen','Visa','Kumpiuja 2','11234','kane@abcde.fi'),
('polrau','Polkunen','Rauno','Umpikuja 1','01234','rane@abcde.fi');

SELECT * FROM henkilot;
```
Katsotaan indeksi:
```
MariaDB [indeksi_testi]> SHOW INDEX FROM henkilot;
+----------+------------+----------+--------------+-------------+-----------+-------------+----------+--------+------+------------+---------+---------------+
| Table    | Non_unique | Key_name | Seq_in_index | Column_name | Collation | Cardinality | Sub_part | Packed | Null | Index_type | Comment | Index_comment |
+----------+------------+----------+--------------+-------------+-----------+-------------+----------+--------+------+------------+---------+---------------+
| henkilot |          0 | PRIMARY  |            1 | tunnus      | A         |           3 |     NULL | NULL   |      | BTREE      |         |               |
| henkilot |          0 | email    |            1 | email       | A         |           3 |     NULL | NULL   | YES  | BTREE      |         |               |
+----------+------------+----------+--------------+-------------+-----------+-------------+----------+--------+------+------------+---------+---------------+
2 rows in set (0.001 sec)

```
**-- --> Indeksit PRIMARY ja email.
-- --> Cardinality ~ indeksin yksittäisten arvojen lkm ~ rivien lkm**

**-- Kaikki indeksit saadaan komennolla:**
```
SELECT DISTINCT TABLE_NAME, INDEX_NAME 
FROM INFORMATION_SCHEMA.STATISTICS;
```
**-- henkilot-taulun kaikki indeksit saadaan loitsulla:**
```
SELECT DISTINCT TABLE_NAME, INDEX_NAME 
FROM INFORMATION_SCHEMA.STATISTICS
WHERE TABLE_NAME = 'henkilot';
```
* Ladataan sitten alla oleva **file.sql** kannan kaikki 200 000 henkilöä kantaan. Avaa sql -file vaikka Geanyyn ja ota tylysti Copy-Paste komennolla kaikki Insertit.
Liitä (Paste) sitten kopioidut Insertit inseksi_testi kantaan. Aikaa menee jonkun verran, joten on aikaa vaikka jaloitella ;)

Testataan mitä saatiin aikaiseksi:
```
MariaDB [indeksi_testi]> SELECT COUNT(*) FROM henkilot;
+----------+
| COUNT(*) |
+----------+
|   200003 |
+----------+
1 row in set (0.087 sec)

MariaDB [indeksi_testi]> 
```
Kokeillaan muutamia hakuja:

1. Haetaan henkilön sukunimi tunnuksen perusteella.
```
MariaDB [indeksi_testi]> SELECT sukunimi FROM henkilot WHERE tunnus = 175175;
+------------+
| sukunimi   |
+------------+
| Suku175175 |
+------------+
1 row in set, 3 warnings (0.074 sec)

```
Huomattiin, että haku kestää noin 0.074 s. Haku yleensä nopeutuu, jos kysely tapahtuu pian edellisen kyselyn perään. Hakulauseke jää välimuistiin, mutta indeksien puuttumisen vuoksi tietokantaaan ei kohdistu uudelleen järjestelyä.
2. Tehdään kysely josssa haetaan sukunimi sukunimen perusteella.
```
MariaDB [indeksi_testi]> SELECT sukunimi FROM henkilot WHERE sukunimi = 'suku175175';
+------------+
| sukunimi   |
+------------+
| Suku175175 |
+------------+
1 row in set (0.049 sec)

MariaDB [indeksi_testi]> SELECT sukunimi FROM henkilot WHERE sukunimi = 'suku175175';
+------------+
| sukunimi   |
+------------+
| Suku175175 |
+------------+
1 row in set (0.000 sec)

MariaDB [indeksi_testi]> SELECT sukunimi FROM henkilot WHERE sukunimi = 'suku175175';
+------------+
| sukunimi   |
+------------+
| Suku175175 |
+------------+

```
Havaitaan, että kyselyn tulos jää muistiin, jolloin kyselyn viemä prosessoriaika on mitätön.
3. Luodaan indeksi
```
MariaDB [indeksi_testi]> CREATE INDEX i_sukunimi ON henkilot(sukunimi);
Query OK, 0 rows affected (1.405 sec)               
Records: 0  Duplicates: 0  Warnings: 0

MariaDB [indeksi_testi]> SHOW INDEX FROM henkilot;
+----------+------------+------------+--------------+-------------+-----------+-------------+----------+--------+------+------------+---------+---------------+
| Table    | Non_unique | Key_name   | Seq_in_index | Column_name | Collation | Cardinality | Sub_part | Packed | Null | Index_type | Comment | Index_comment |
+----------+------------+------------+--------------+-------------+-----------+-------------+----------+--------+------+------------+---------+---------------+
| henkilot |          0 | PRIMARY    |            1 | tunnus      | A         |      216685 |     NULL | NULL   |      | BTREE      |         |               |
| henkilot |          0 | email      |            1 | email       | A         |      216685 |     NULL | NULL   | YES  | BTREE      |         |               |
| henkilot |          1 | i_sukunimi |            1 | sukunimi    | A         |      216685 |     NULL | NULL   |      | BTREE      |         |               |
+----------+------------+------------+--------------+-------------+-----------+-------------+----------+--------+------+------------+---------+---------------+
3 rows in set (0.001 sec)

```
4. Uusitaan edelliset kyselyt

```
MariaDB [indeksi_testi]> SELECT sukunimi FROM henkilot WHERE sukunimi = 'suku176111';
+------------+
| sukunimi   |
+------------+
| Suku176111 |
+------------+
1 row in set (0.002 sec)
```
5. Testataan vielä indeksoimattoman kentän mukaan tehtävää hakua.
```
MariaDB [indeksi_testi]> SELECT sukunimi FROM henkilot WHERE etunimi = 'e175175';
+------------+
| sukunimi   |
+------------+
| Suku175175 |
+------------+
1 row in set (0.041 sec)

MariaDB [indeksi_testi]> SELECT sukunimi FROM henkilot WHERE etunimi = 'e175175';
+------------+
| sukunimi   |
+------------+
| Suku175175 |
+------------+
1 row in set (0.000 sec)
```

Johtopäätökset:
indeksillä sukunimihaku nopeutui merkittävästi, vaikka tämä aineisto on siinä mielessä huono, että tietueet lisätään jo valmiiksi "oikeassa järjestyksessä".

## Herättimet (triggers)


Proseduurit ovat ohjelmamoduuleita, joita voidaan tallentaa tietokannan systeemihakemistoon.

Herätin on proseduurien erikoistapaus.
Herätin käynnistyy automaattisesti DML-tietokantaoperaatioista (INSERT, UPDATE tai DELETE).
Eheyden valvontaan ja monimutkaisiin tarkistuksiin.
Muuttuneiden, poistuneiden ja uusien tietojen tallentamiseen toiseen tauluun => loki.
Tietojen toisteisuuden hallintaan, eli  (eheystarkistukset, joita ei ole tehty viite-eheyssäännöillä).
Herätintä ei tarvitse siis kutsua erikseen!


Check-rajoitteen toteuttaminen herättimellä.

CHECK-rajoitteen totetuksen puuttumisen voi toteuttaa herättimillä.

Esimerkki: Luodaan taulu, jossa on yksi kokonaislukukenttä "luku".
Luodaan herättimet, jotka salivat ainoastaan positiivisten kokonaislukujen lisäämisen ja päivittämisen ao kenttään.

Käytetaan samaa indeksi_testi tietokantaa

-- Luodaan taulu ja lisätään dataa
CREATE TABLE taulu (luku INT) ENGINE=InnoDB;
INSERT INTO taulu(luku) VALUES (1);
INSERT INTO taulu(luku) VALUES (2);
INSERT INTO taulu(luku) VALUES (3);

Esimerkki:

Katsotaan olemassa olevat triggerit:
```
MariaDB [indeksi_testi]> show triggers;
Empty set (0.002 sec)

```

Luodaan trigger 1 lisäyksiä varten
```
DELIMITER $$

CREATE TRIGGER trigger1 
  BEFORE INSERT ON taulu
  FOR EACH ROW 
BEGIN
  IF !(NEW.luku >=0) THEN
    CALL `Virhe: Virheellinen arvo sarakkeeseen luku Uusi tietue`;
  END IF;
END$$

DELIMITER ;
```
Luodaan trigger 2 päivitystä varten
```
DELIMITER $$

CREATE TRIGGER trigger2
  BEFORE UPDATE ON taulu
  FOR EACH ROW 
BEGIN
  IF !(NEW.luku >=0) THEN
    CALL `Virhe: Virheellinen arvo sarakkeeseen luku! Uusi tietue`; 
  END IF;
END$$

DELIMITER ;
```
Lisätään dataa tauluun:
```
MariaDB [indeksi_testi]> INSERT INTO taulu VALUES (4);
Query OK, 1 row affected (0.037 sec)
```
Yritetään lisätä virheellinen arvo tauluun:
```
MariaDB [indeksi_testi]> INSERT INTO taulu VALUES (-4);
ERROR 1305 (42000): PROCEDURE indeksi_testi.Virhe: Virheellinen arvo sarakkeeseen luku Uusi tietue does not exist
```
Yritetään päivittää taulun sisältöä:
```
MariaDB [indeksi_testi]> UPDATE taulu set luku = -4 WHERE luku = 4;
ERROR 1305 (42000): PROCEDURE indeksi_testi.Virhe: Virheellinen arvo sarakkeeseen luku! Uusi tietue does not exist
```
Triggereiden poistaminen:
```
ariaDB [indeksi_testi]> drop trigger trigger1;
Query OK, 0 rows affected (0.036 sec)
```


#### Tietokannan indeksointi

Ideaalissa tilanteessa ainoa suorituskustannus indeksien lisäämiseen tulisi vain siitä kun lisätään, poistetaan tai päivitetään rivejä. Ns. hiljaisessa taulussa, eli jossa ei ole juurikaan tapahtumia, indeksien suorituskustannus ei ole koskaan ongelma, mutta kiireellisessä, kasvavassa taulussa se voi olla suurikin kustannus. Lisäykset eivät ole yleensä ongelma. Poistot sen sijaan ovat hankalampia, sillä B-puut eivät käyttäydy käänteisesti kun rivejä lisätään ja sitten poistetaan niitä. 
Suuria poistoja tehtäessä saatetaan toisinaan joutua rakentamaan indeksit uudelleen, jotta saataisiin palautettua indeksien täysi teho.
Päivitykset ovat tyyriimpiä indeksioperaatioita, sillä kun päivitys muuttaa ainakin yhtä indeksoitua saraketta, tietokanta käsittelee päivitystä sekä uuden arvon lisäyksenä että vanhan arvon poistona.
Onneksi ensisijaisen avaimen indeksejä ei juuri koskaan päivitetä, mikäli tietokantasuunnittelu on tehty oikein. 
Indeksit, jotka ovat suurimmassa vaarassa tulla päivitetyiksi, ovat ei-avain –kentät, joilla on muuttuvaa tietoa, kuten tilasarakkeet entiteeteille, jotka muuttavat usein tilaansa. 

Täytyy huomioida se seikka, että on paljon helpompaa lisätä indeksi kuin poistaa se. 
Kun indeksi on kerran käytössä, välittämättä siitä, kuinka kauan se on ollut käytössä, on poistamisen aiheuttama riski suuri. On lähestulkoon mahdoton taata ennakkoon, että indeksi voidaan poistaa turvallisesti.

### Yleinen lähestymistapa indeksointiin

1) **Etsitään itsestään selvät indeksit**
Luotuun tauluun luodaan perusavain-indeksit ja muut duplikaattirivejä ehkäisevät indeksit sekä viiteavain-indeksit viite-eheystarkistuksien ja liitosten nopeuttamiseksi. 
Tässä vaiheessa voidaan lisätä indeksejä, joiden tarve on ilmeinen. 
Jos indeksiavain on yksilöivä, se määritellään
indeksimäärityksessä UNIQUE:ksi, joka auttaa optimointiohjelmaa valitsemaan parhaan saantipolun. 
Useimmat tietokannanhallintajärjestelmät sijoittavat INSERT-kutsun tuoman uuden rivin ryvästävän indeksin määräämälle kotisivulle, jos tällä sivulla on riittävästi tyhjää tilaa ja jos se ei ole lukittu. Jos sovelluksessa on massiivisia eräajoja, on isojen taulujen ryvästys yleensä yhdenmukaistettava hajalevylukujen määrän minimoimiseksi. 
Esimerkiksi Tyyppiä kuvaava numeroalkuinen ryvästävä indeksi on yleinen ja hyväksi todettu ratkaisu kaikissa tauluissa, joissa on tuon tyyppinen sarake.
Taulujen ryvästys ei siis ole ehdoton, vaikka laskentaesimerkeissä on tapana olettaa, että taulurivit ovat täsmälleen oikeassa järjest uudelleenjärjestelyajoissa ehkä jätettävä 50 % kustakin taulusivusta tyhjäksi. Tällöin kullekin taulusivulle mahtuu useimmiten kaksi uutta riviä. Jos taulusivut ovat suurempia kuin 4 kilotavua.

2. **Saantipolkujen katsaus**
Kun tuotantokannat on luotu ja optimointiohjelman käyttämät tilastotaulut päivitetty, tutkitaan ne
SQL-lauseet, joiden saantipolku on koko indeksin tai taulun läpiluku. 
Jos taulu ei ole todella pieni ja jos ohjelma ei tarvitse kaikkia rivejä, kyseiselle lauseelle ei todennäköisesti ole riittävän hyvää indeksiä. Joskus syynä taulun tai indeksin läpilukuun on optimointiohjelman tekemä väärä valinta.


3. **Indeksin laskeminen**
Hakulauseet koostuvat yhdestä tai useammasta hakuehdosta. Esimerkiksi lauseessa:
```
SELECT ETUNIMI, SUKUNIMI FROM HENKILO
WHERE SUKUPUOLI = ’M’
AND (PAINO > 90 OR PITUUS > 190);
```
where-ehto hakuehtoja eli predikaatteja ovat sukupuoli, paino ja pituus. 
Predikaatit ovat indeksien suunnittelun lähtökohtana. 
Kun indeksoinnin suunnittelussa on huomioitu kaikki hakulauseen lausekkeen predikaatit, tulostaulu rakentuu nopeasti.

4. **Perusindeksointi**

a. Taulukaavion ensimmäisen version valmistuttua luodaan indeksoinnin nollaversio: perusavain- ja viiteavain-indeksit.
b. Tauluratkaisun tehokkuus varmistetaan arvioimalla raskaiden tapahtumien ja eräajon kesto. 
https://dev.mysql.com/doc/refman/8.0/en/optimize-benchmarking.html

* Kullekin raskaalle ohjelmalle suunnitellaan tehokkaat indeksit. 
* Jos ennustettu suoritusaika ei ole hyvä edes parhailla mahdollisilla indekseillä, täytyy tehdä taulutason viritys. 
* Muutetaan taulurivien järjestystä, toistetaan tietoa taulutasolla, yhdistetään tauluja tai korvataan useasta lyhyestä rivistä koostuva taulu vähärivisemmällä pitkistä rivistä koostuvalla taululla.
* Tuotantoon siirtämisen yhteydessä poimitaan ne haut, joiden saantipolkuun sisältyy koko taulun tai indeksin läpiluku. Tämä voi paljastaa sekä indeksointipuutteita että optimointiongelmia.
* Kun arvioidaan indeksoinnin riittävyyttä käytetään pahimman tapauksen läpäisykertoimia. 
* Pahimman tapauksen läpäisykertoimet liittyvät niihin muuttuja-arvoihin, jotka johtavat pisimpään suoritusaikaan kyseisellä indeksillä. 
* Pahin tapaus tarkoittaa pitkää suoritusaikaa, ei pitkää jonotusaikaa.

### Parhaan indeksin johtamissäännöt
1. Poimitaan indeksin alkuun sarakkeet, joihin liittyy predikaatti SARAKE =. Huomioidaan ainoastaan predikaatit, jotka eivät ole liian vaikeita arvioida.
2. Valitaan se sarake, johon viitataan valikoivimmissa arvoväliehdoissa, eli pahimmassa tapauksessa pienin läpäisykerroin. 
3. Lisätään ORDER BY –määreen sarakkeet oikeassa järjestyksessä, kuitenkaan toistamatta edellisissä kohdissa lisättyjä sarakkeita. Valitaan indeksisarakekohtainen DESC-optio (descending, eli laskeva) ORDER BY –määreen mukaisesti.
4. Lisätään kaikki loput sarakkeet, joihin SELECT-lauseessa viitataan, myös SELECT-listan sarakkeet.

### Kolmen tähden indeksi ja kursorit yhden taulun tietokannassa

Kolmen tähden indeksi on paras mahdollinen indeksi annetulle SELECT-lauseelle. Siinä yhteen tauluun viittaava SELECT vaatii yleensä vain yhden hajalevyluvun, koska indeksistä luetaan yksi viipale ja taulurivejä ei lueta ollenkaan.

### Kursorit
Kursorin eli kohdistimen avulla SELECT-lauseen rivien tulosjoukko voidaan käsitellä rivi kerrallaan. 
Kursorin käyttö on välttämätön, jos haluttu tulos on monirivinen. 
Yksittäinen rivi luetaan suoraan SELECT-lauseella ja kursorilla osoitetaan kohdetauluun ja valitaan SELECT:issä olevan ehdon mukaiset tiedot käsittelyyn.
```
DECLARE CURSOR1 CURSOR FOR
SELECT ASNO, ETUNIMI
FROM ASIAKAS
WHERE SUKUNIMI = :SUKUNIMI
AND KUNTA = :KUNTA
ORDER BY ETUNIMI
```

Kolmen tähden indeksi kursorille CURSOR1  

![](images/09_11_kolmen_tahden_indeksi.png)

Kolmen tähden indeksillä esimerkin SELECT-lauseen suoritusaika on sekunnin murto-osa, vaikka tulostaulussa olisi useampi tuhat riviä, sillä sarakkeet SUKUNIMI ja KUNTA rajaavat tutkittavan indeksiviipaleen. 
Taulurivejä ei lueta, koska kaikki tarvittavat sarakkeet on kopioitu indeksiin. Huonosti sopivalla indeksillä arviot saman tapahtuman kestosta ovat minuutin ja kahden minuutin välillä.

Ensimmäinen tähti tulee, jos SELECT-lauseen tarvitsemat indeksirivit ovat vierekkäin -> minimoi läpikäytävän indeksiviipaleen paksuuden eli tutkittavien indeksirivien määrän.

Toinen tähti tulee, jos indeksi rivit ovat SELECT-lauseen kannalta oikeassa järjestyksessä -> poistaa lajittelutarpeen.

Kolmas tähti tulee, jos indeksirivit sisältävät kaikki SELECT-lauseen sarakkeet -> tulos rakennetaan indeksiriveistä eikä taulurivejä lueta ollenkaan. 
Kolmas tähti on usein tärkein, sillä se eliminoi taulurivien lukemisen, jolloin saantipolku on *index only*.

# Linkit
- Triggers: https://www.youtube.com/watch?v=HXV3zeQKqGY&t=12605s

[08: Transaktiot ja Näkymät](/08_transaktiot_ja_nakymat) <----------> [10: Palautettavat harjoitukset](/10_palautettavat_harjoitukset)
