Datalähteet ja tietokannat - MariaDB&Python harjoitus
===

![alt text](images/10_upotetut_sql_lauseet.png "SQL - upotetut SQL-lauseet")

Sisällysluettelo:

[[_TOC_]]

# Tehtävän kuvaus

Pääset suunnittelemaan Tuote-sovellusta suuren kauppaketjun
tuotekehitysosastolla. Tehtävänäsi on suunnitella luokka- ja tietokantarakenne, jolla voidaan hallinnoida yrityksen tuotteita. 
Kaikilla tuotteilla on samat yhteiset ominaisuudet: nimi, hinta, hyllypaikka sekä tuotekoodi.

Nämä esitellään Tuote-luokassa, jonka aliluokat perivät.
Valmis koodi Luokat.ipynb filessä.

Aliluokkia on kolme, joilla on omia ominaisuuksia seuraavasti:

A. Vaate: koko, materiaali
B. Ruoka: maa, paivays
C. Kodinkone: takuu, paino 

## Tehtävät:

Suunnittele tietokantarakenne mallintamalla tietokanta ensin ER-kaaviona. Suunnittele ja toteuta ER-kaavion tietokannan taulujen väliset yhteydet ja lopuksi luo tietokannan taulut.

Tee yksinkertainen ohjelma, jolla voit syöttää tuotteita tietokantaan sekä tulostaa tietokannan sisällön.
Luokkien jäsenmuuttujien tyyppejä ei ole määritelty eli saat päättää ne itse. 

Suunnittele ensin funktio, jolla lisätään tuotelistalla olevat tuotteet tietokantaan (INSERT).
Katso esimerkkejä: 
1. Python_Mariadb_code.ipynb filessä on esimerkki tietokantayhteyden luomisesta ja tietokannan luomisesta.

Aja ensin nämä komennot:
```
!pip install pymysql
!pip install ipython-sql
!pip3 install mysqlclient
!pip3 install mysql-connector-python
```
Seuraavaksi luodaan tietokanta:

```
CREATE DATABASE Python_lab;
```
Tietokannan taulun luominen:
```
use Python_lab;

-- luodaan tietokanta
CREATE TABLE asiakkaat (
    id INT AUTO_INCREMENT PRIMARY KEY,
    etunimi VARCHAR(30) NOT NULL,
    sukunimi VARCHAR(30) NOT NULL,
    ika INT
) 
ENGINE=INNODB;
--  talletetaan testi
INSERT INTO asiakkaat (etunimi, sukunimi, ika) VALUES ('Uolevi', 'Lehtinen', 60);
```


2. MariaDB_Python_lab.ipynb filessä on esimerkkejä tietokantayhteyden luomisesta ja runsaasti esimerkkejä kuinka tietokantaa voidaan käyttää Python-koodissa.





## Toteuta ohjelmassa:

1. Tuotteiden lisäys tietokantaan.
Ohjelmassa ensin valitaan minkä tyyppistä tuotetta ollaan syöttämässä, jonka jälkeen tiedot täytetään. Miten lopetat syötön on sinun päätettävissä. 
3. Kaikkien tuotetietojen tulostus.
4. Tuoteen poisto tietokannasta.
5. Tuotteen hintatiedon päivitys tietokantaan.
6. Varastossa olevien tuotteiden arvon tulostus.
8. Tuotteen tietojen tulostus tuotekoodin perusteella.
9. Vanhenemassa olevien tuotteiden tulostus, joiden parasta ennen päiväys on kyselyä seuraavassa kuussa.

Ohessa esimerkkiajo:

Mikä tuote lisätään listaan (1 = Ruoka, 2 = Vaate, 3 = Kodinkone, muu = Lopetus: 1
Anna tuotteen nimi: Sokeri
Anna hinta: 2.45
Anna hyllypaikka: Ruoka 11
Anna koodi: 111-222-333-22
Ruuan alkuperämaa: Tanska
Päiväys: 1.3.2024

Mikä tuote lisätään listaan (1 = Ruoka, 2 = Vaate, 3 = Kodinkone, muu = Lopetus: 2
Anna tuotteen nimi: Paita
Anna hinta: 22.10
Anna hyllypaikka: Vaate 3
Anna koodi: 222-122-232-11
Vaatteen koko: M
Vaatteen materiaali: Puuvilla

Mikä tuote lisätään listaan (1 = Ruoka, 2 = Vaate, 3 = Kodinkone, muu = Lopetus: 3
Anna tuotteen nimi: Pakastin
Anna hinta: 320.00
Anna hyllypaikka: Varasto 12
Anna koodi: 543-234-232-22
Kodinkoneen takuu: 1 vuosi
Kodinkoneen paino: 100kg

Mikä tuote lisätään listaan (1 = Ruoka, 2 = Vaate, 3 = Kodinkone, muu = Lopetus: l

Nimi:       Sokeri
Hinta:      2.45
Hylly:      Ruoka 11
Koodi:      111-222-333-22
Alkuperä:   Tanska
Päiväys:    1.3.2024

Nimi:       Paita
Hinta:      22.10
Hylly:      Vaate 3
Koodi:      222-122-232-11
Koko:       M
Materiaali: Puuvilla

Nimi:       Pakastin
Hinta:      320.00
Hylly:      Varasto 12
Koodi:      543-234-232-22
Takuu:      1 vuosi
Paino:      100kg

## Kyselyjen toimintaperiaate

![](https://gitlab.dclabra.fi/wiki/uploads/upload_fc242f02310f378ccb3b4bbe49ff5f98.png)

Kuvan lähde: https://pynative.com/python-mysql-database-connection/

### Linkkejä hyviin esimerkkeihin:

https://pynative.com/python-mysql-delete-data/

https://realpython.com/python-mysql/

https://subscription.packtpub.com/video/application-development/9781838984670/116944/116952/connect-to-database-in-python

https://www.datacamp.com/tutorial/mysql-python

https://www.geeksforgeeks.org/python-mariadb-where-clause-using-pymysql/?ref=rp

https://levelup.gitconnected.com/how-to-run-sql-queries-in-jupyter-lab-1cbb1e3b1c04

https://pynative.com/python-mysql-delete-data/


