Mysql Osa 13 - Mysql Workbench
====
Tehdään tietokannan suunnittelu ja taulujen luonti MySql Workbench ohjelmalla.
MySQL Workbench on hyvä ja laajalti käytetty työkalu tietokantojen hallintaan. Se tarjoaa visuaalisen työkalun tietokannan suunnittelun ja rakentamisen avuksi. Lisäksi sen avulla on mahdollista tehdä kaikki SQL-kyselyt hieman käyttäjäystävällisemmässä muodossa kuin Linuxin komentoriviltä.

Asennetaan ensin Mysql Workbench. Asentamisen voi tehdä lataamalla asennustiedosto osoitteesta https://dev.mysql.com/downloads/workbench/

Tai käyttämällä Linuxin paketinhallintaa.
```=
sudo apt-get update
sudo apt-get install mysql-workbench
```
Paketinhallinta asentaa Mysql workbencin Ohjelmointi (Programming) hakemistoon.

## Mysql workbench ja Docker
 Mysql Workbench on myös mahdollista asentaa ja käyttää docker-kontissa. 
 Oheisessa linkissä on 
 [asennusohjeet](https://hub.docker.com/r/linuxserver/mysql-workbench).

Muutoin käyttö on samanlaista kuin ns. natiivisti asennetun Mysql Workbenchin käyttö.

## Aloitus
Mustasta avausruudusta paina MySQL Connections(+) plus-merkkiä uuden yhteyden muodostamiseksi.

![alt text](images/13_open.png "open mysql workbench"){width=50% height=50%}



Avautuu Setup New Connection-ikkuna. Valitse yhteystavaksi “Standard TCP/IP over SSH”. Täytä Connection-välilehdelle ensin Dockerissa olevan tietokannan käyttäjätunnus ja salasana Password(Store in Keychain) ja sitten MariaDB:n vastaavat tiedot. MySQL hostname on localhost eli IP-osoite 127.0.0.1
Mikli et ole muuttanut salasanaa, niin se on "mypass" ja käyttäjä (username) on "root"


![alt text](images/13_connection.png "connection"){width=50% height=50%}



Kokeillaan saadaanko yhteys -> Paina Test Connection buttonia.
Mikäli saat alla olevan mukaisen vastauksen, voit sulkea Setup New Connection ikkunan.

![alt text](images/13_test.png "test conenction"){width=50% height=50%}



## Uusi yhteys ilmestyy päänäkymään.

Yhteyden saa auki kaksoisklikillä. Aukeaa Query-ikkuna, johon voi kirjoittaa 
SQL-komentoja kuten aikaisemmin komentorivillekin. Pelkkä ENTER vaihtaa rivin. 
CTRL-ENTER tai salamaikoni suorittaa lauseen.

Uuden ER-mallin luonti tapahtuu valitsemalla File → New Model,
jolloin aukeaa suunnitteluikkuna. Muuta Scheman (joka tarkoittaa tietokantaa) nimeksi mydb:n tilalle sensors.

Database-valikosta löytyvät seuraavat hyödylliset toiminnot:

Database → Reverse Engineer Tämän avulla on mahdollista importata palvelimelta 
tietokanta Workbenchiin. Workbench näyttää graafisesti kaikki tietokannasta
löytyvät taulut sekä niiden väliset yhteydet, jos ne on tauluihin määritelty viiteavaimilla.

Database → Forward Engineer Tämän avulla on mahdollista exportata 
Workbenchissä suunniteltu tietokanta palvelimelle.
Workbench generoi taulut automaattisesti itse, viiteavaimineen päivineen. HUOM ! Jotta Workbenchin saa siirtämään tauluihin syötetyt tietueet, täytyy toisella välilehdellä ”Set Options for Database to be Created” olla valittuna ”Generate Insert Statements for Tables”.

Database → Synchronize Model Tämän avulla voi päivittää palvelimella 
olevat taulut ja paikallisella koneella olevan kaavion vastaamaan toisiaan, jos jommassa kummassa päässä on tehty muutoksia rakenteeseen.

Tietokannassa olevat taulut voidaan hakea Workbenchiin Reverse Engineerillä.

## Hyödyllisiä linkkejä

MySQL Workbench Tutorial (2022): https://www.youtube.com/watch?v=2mbHyB2VLYY

https://dev.mysql.com/doc/workbench/en/wb-relationship-editor.html

https://www.youtube.com/watch?v=YkrtjGD9IHU


# MySQL workbench - Sensors ER-Model harjoitus 
===
----

### Toiminnalliset vaatimukst
Suunnittele MySQL tietokanta, johon voidaan tallentaa sensoridataa kolmesta eri lähteestä tai laitteesta (esim. laite1, laite2, laite3).

Käytettävät sensorit mittaavat lämpötilaa, ilman kosteutta, hiilidioksidi ja häkäpitoisuutta.

Suunnittele tietokantaratkaisu relaatiomallin mukaisesti.

Suunnitelmassa pitää huomioida se, että jokaisesta lukemasta pitää myös aikaleima tallentaa tietokantaan.

Pidä tietokannat yksinkertaisina, dublikaatit eivät vähäisessä määrin haittaa. Suunnittele tietokanta siten, että tiedon tallennus ja tietokantahaut ovat syntaksiltaan mahdollisimman yksinkertaisia.

Piirrä ER -notaation mukainen tietokantarakenne, määrittele taulujen väliset yhteydet sekä pää- ja viiteavaimet.

****Toteutettavat tietokantakyselyt:****

1. Listaa kaikki tietokannan sensoreiden arvot erikseen kustakin laitteesta. 
2. Listaa lämpötilalukemat laitteittain eriteltynä
3. Etsi laitteen1 lähettämä maksimikosteus haluttuna tarkastelujaksona
4. Etsi laitteen2 lähettämä minilämpötila haluttuna tarkastelujaksona
5. Tulosta laitteen3 hiilidioksidin keskiarvo päivittäin tarkasteltuna.
6. Listaa laitteittain häkäpitoisuus viimeisen tunnin mittausjaksolta.

Avataan MySQL Workbench ja luodaan oheisen kuvan mukainen Model yhdessä:
![](https://gitlab.dclabra.fi/wiki/uploads/upload_1f27662a94a8c2709224942c80924973.png)



Uuden Modelin (mallin) luomiseen on MySQL Workbench tutoriaalissa erittäin hyvä esimerkki.

https://dev.mysql.com/doc/workbench/en/wb-getting-started-tutorial-creating-a-model.html

Seurataan siis esimerkkiä, mutta ensin on syytä miettiä millainen rakenne tietokantaan tarvitaan, mitä tauluja tarvitaan, mitä kenttiä tauluissa on oltava, mitä vaatimuksia aikasarjaisen datan tallennus asettaa tietokannalle?
Miten relaatiot kannattaa toteuttaa, jotta hakuehdot olisi mahdollista toteuttaa nopeasti isosta datamassasta.

MySQL Workbench-ohjelma käyttää ER-mallin laajennettua versiota ”EER”-malli (Extended ER): ”The EER model includes all of the concepts introduced by the ER model. Additionally it includes the concepts of a subclass and superclass (Is-a), along with the concepts of specialization and generalization. Furthermore, it introduces the concept of a union type or category, which is used to represent a collection of objects that is the union of objects of different entity types.”


### ER mallin eri notaatiovaihtoehdot
![](https://gitlab.dclabra.fi/wiki/uploads/upload_635e79bf408e1c41cfd72c3c56b9e7d1.png)


### EER-diagrammi - MySQLWokrbench toiminnot

Taulujen yhteydet näkyvät värikoodattuna kun vie hiiren haluamansa taulun päälle. Kaksoisklikkaamalla taulua pääsee muokkaamaan kenttiä.
![](https://gitlab.dclabra.fi/wiki/uploads/upload_9e87da4c1b478e9afe6d38b562335bb6.png)


Columns: Kenttien muokkaus
o PK = PRIMARY KEY
o NN= NOT NULL
o UQ=UNIQUE
o BIN=BINARY
o UN=UNIQUE
o ZF=ZEROFILL
o AI=AUTO_INCREMENT

**Indexes**: Pääavaimet ja indeksikentät

**Foreign Keys**: Viiteavaimet:

Foreign Key Options-valinnoilla määritellään, mitä
tehdään kun isätaulua päivitetään (ON UPDATE) tai se
poistetaan (ON DELETE).

**Triggers**: Liipaisimet

Määritellään, mitä muissa tauluissa tapahtuu kun tätä taulua muutetaan

**Inserts**: Tietueiden syöttö

Syötetyt tietueet eivät automaattisesti siirry taulujen mukana palvelimelle (GENERATE INSERTS-valinta).
Tosin tietueet eivät siirry millään minun osaamalla konstilla palvelimelta Workbenchiin. ;)

**Privileges**: Taulujen käyttöoikeudet

Jos Workbenchillä suunnittelee uusia tauluja, kannattaa huomioida, että Workbench tekee itse viiteavaimet, kun taulut yhdistää relaatiolla. Siksi viiteavaimia ei kannata itse kirjoittaa tauluihin. Käytännössä clikataan päävaimia tauluissa, joiden välille halutaan luoda viiteavaimeen perustuva yhteys. **Clikkausjärjestys määrää yhteyssuunnan.**

Workbench piirtää kahdenlaisia yhteyksiä. **Katkoviivalla** esitetään non-identifying relationship. Käytännössä se tarkoittaa, että parentin voi poistaa vaikka olisi lapsia.

**Yhtenäisellä** viivalla esitetään identifying relastionship. Silloin parenttia ei voi poistaa, jos on lapsia. Tässä vielä aika hyvä kuvaus Stackoverflow:sta (http://stackoverflow.com/questions/762937/whats-the-difference-between-identifying-and-non-identifying-relationships)

Valitse **Edit → Preferencies → Modeling**. Vaihda avainten nimeämiskäytännöt oheisen mallin mukaisiksi. Nyt Workbench generoi avaimet muotoon id+taulun nimi. Tämä sen takia, että ei mennä näiden kanssa ihan sekaisin.

**ON UPDATE CASCADE ON DELETE CASCADE**
Foreign key/Relationship Defaults-kohdassa muuta **ON UPDATE CASCADE ja ON DELETE CASCADE.**
![](https://gitlab.dclabra.fi/wiki/uploads/upload_e51021fcd01094003ba7c4e56d5b7a9e.png)


**ON UPDATE ja ON DELETE** määrittelevät, mitä tehdään viiteavaimella yhdistetyille tietueille, jos juuritietueen sisältöä muutetaan tai se poistetaan.
**CASCADE:** Päivitys/poisto välittyy lapsitietueisiin.
**RESTRICT:** Ei anneta päivittää/poistaa juuritietuetta.

EER Diagram-välilehdellä voi suunnitella taulujen rakenneta, sisältöä ja niiden välisiä yhteyksiä. Taulut voi siirtää joko **Forward Engineer**- (jos niitä ei ole ennestään) tai **Sychronize Model**-toiminnolla palvelimelle.
Jos tauluihin on syötetty tietoja Inserts-välilehden kautta, ne saadaan siirtymään alla olevalla valinnalla.
![](https://gitlab.dclabra.fi/wiki/uploads/upload_dedd6399944e2f3bcd645dfeb4672df6.png)


### Tiedon siirtäminen Mysql palvelimelle
Workbench siirtää kaiken tiedon SQL-lauseina. Siirrettäviä lauseita pääsee vielä editoimaan ennen siirtoa.
Teksti-ikkunassa ei ole kuitenkaan editointiominaisuuksia, joten teksti on siirrettävä Copy to Clipboardin kautta Notepadiin tai vastaavaan tekstieditoriin, jos haluaa vaikkapa tehdä Find-Replace-operaation. Yleensä sille ei ole tarvetta.
Jos diagrammi on saatu joltain toiselta käyttäjältä, on tässä vaiheessa muutettava kaikki tunnukset.

Siirrä Sql-lauseet Docker containerissa olevaan tietokantaan. 