# Tietokantojen_perusteet_ja_tietokantaohjelmointi

![alt text](images/mysql_vs_mariadb_banner.png "Tietokantaohjelmointi")

## Kuvaus:

Opiskelija tuntee relaatiotietokantojen ja ei relaatioteitokantojen periaatteet, osaa suunnitella ja toteuttaa yksinkertaisen tietokannan, osaa käyttää tietokantaohjelmistoja ja valmista tietokantaa tietokannan edellyttämällä kyselykielellä.
Opintojakson jälkeen opiskelija ymmärtää tietokantojen keskeisen roolin tietojärjestelmissä. Opiskelija ymmärtää myös tietokantojen kasvavan merkityksen laitteistojen, ohjelmistojen ja tiedonsiirtokapasiteetin kasvun ja paranemisen myötä. Keskeisiä toimintoympäristöjä ovat WWW, elektroninen kaupankäynti, sensoriverkkojen tuottama data, Internet of Things ja mobiiliympäristöt.

## Toteutus:

Lähiopetus ja itsenäinen työskentely.  
Tunneilla läsnäolo pakollista.  
Itsenäinen työskentely kattaa harjoituksia pääosin Sakila-harjoitustietokannan parissa.  
Lisäksi pakollisia palautettavia harjoituksia  
Kurssin lopuksi Tentti.

## Läsnäolo

Kurssin tunneille osallistuminen on pakollista.  
Tunneilta voi olla pois kaksi (2) kertaa ilman lisätehtäviä.  

**Jos poissaoloja on enemmän kuin kaksi (2), tai suoritat kurssia itsenäisesti, niin kaikki palautettavat harjoitukset on tehtävä!**

## Sisältö:

Tietokantojen peruskäsitteitä  
(E)ER-mallinnus  
SQL:n perustoimintoja  
SQL käskyt  
SQL ja ohjelmointikieli  
Relaatiomallin perusteet  
Relaatioalgebran perusoperaatioita  
Relaatioharjoitukset  
MySQL harjoitukset, tietokannan luonti MySQL-serverille  
NoSql tietokannat, reaaliaikaiset tietokannat  

## Kurssimateriaali:

Tietokantojen_perusteet_ja_tietokantaohjelmointi git-repo.

Linkit harjoituksissa käytettäviin tietokantoihin:  
Sakila: https://dev.mysql.com/doc/sakila/en/  
Mysql Tutorials: https://www.mysqltutorial.org/mysql-sample-database.aspx  

### Kurssin harjoitusalusta

KAMK Jupyterlab -oppimisympäristö
- Pystyt ajamaan kurssilla tehtäviä harjoituksia Notebookkeina harjoitusympäristössä toimivaan tietokantaan
- Tentti toteutetaan Jupyterlab Notebookkina
- Jupyterhub-ympäristö löytyy osoitteesta: https://jupyterhub.dclabra.fi

Oma docker-ympäristö
- Oman dockerissa pyörivän MariaDB-tietokannan avulla pääsee käyttämään tietokantaa kuten täysin oikeaa tietokantaa
- Vaatii docker-ympäristön omalle koneelle

### Lähituntien aiheet ja materiaalit:

3op kurssilla pidetään 9 teorialähiopetuskertaa. Lähiopetuksessa tuntien sisällöt voivat vaihdella hieman, mutta pyrimme noudattamaan seuraavaa runkoa:
- [01: Jupyterhub ympäristön käyttöönotto](/01_jupyterhub_ympariston_kayttoonotto/)
- [02: MariaDB docker asennus (EXTRA)](/02_mariadb_docker/)
- [03: Johdantoa tietokantoihin](/03_johdantoa_tietokantoihin)
- [04: Normalisointi ja ER suunnittelu](/04_normalisointi_ja_er_suunnittelu)
- [05: Tietokannan hallinta](/05_tietokannan_hallinta)
  - MySQL - Osa 1 - Tietokannan hallinta
- [06: Relaatiotietokantojen perusteita](/06_relaatiotietokantojen_perusteita)
  - MySQL - Osa 2 - Relaatiotietokantojen perusteita
  - MySQL - Osa 3 - Tietokantakyselyt
  - MySQL - Osa 4 - Tietokantakyselyt
- [07: Vaativammat tietokantakyselyt](/07_vaativammat_tietokantakyselyt)
  - MySQL - Osa 5 - Vaativammat tietokantakyselyt
- [08: Transaktiot ja Näkymät](/08_transaktiot_ja_nakymat)
  - MySQL - Osa 6 - Indeksien aloitus ja Transaktiot
  - MySQL - Osa 7 - Näkymät - VIEWS
- [09: Indeksit ja Tietokannan optimointi](/09_indeksit_ja_tietokannan_optimointi)
- [10: Koodiin upotetut SQL-lauseet](/10_koodiin_upotetut_sql_lauseet)
- [11: Palautettavat harjoitukset (PAKOLLINEN)](/11_palautettavat_harjoitukset)
- [12: Tentti](/12_tentti)

# DISCORD 

https://discord.gg/n8kckSVeZS

## Deadlinet:
- Palautettavien harjoitustehtävien viimeinen palautuspäivä: 19.3.2024 klo 23:59 mennessä.

- Tenttipäivämäärä ja kellonaika 12.3.2024 klo 12:30 - 15:00

Tenttiaikaa on 2,0 h. Tentti tehdään Linux-luokassa.



## Arviointi:

**Arvosana 1-2**
Opiskelija osaa määritellä, mikä on relaatiotietokanta.
Opiskelija osaa nimetä valmiista ER-kaaviosta entiteetit, attribuutit ja käsitteet.
Opiskelija osaa piirtää yksinkertaisen ER-kaavion annetusta kohteesta ja määritellä kaaviosta taulut.
Opiskelija osaa antaa esimerkkejä taulujen avaimista ja viiteavaimista.
Opiskelija osaa kirjoittaa yksinkertaisia SQL-lauseita.
Opiskelija osaa ohjatusti muodostaa yksinkertaisen tietokannan jollakin tietokannan hallintaohjelmistolla.

**Arvosana 3-4**
Opiskelija osaa selittää relaatiotietokannan rakenteen, avaimet ja viiteavaimet.
Opiskelija osaa piirtää ER-kaavion annetusta kohteesta ja määrittää kaaviosta tietokannan taulut,taulujen attribuutit ja avaimet.
Opiskelija osaa selittää normalisoinnin tarkoituksen ja osaa alustavasti normalisoida tietokannan 3. normaalimuotoon.
Opiskelija osaa hakea annetusta tietokannasta tietoja SQL-lausein erilaisin ehdoin ja päivittää tietokantaa SQL-lausein.
Opiskelija osaa muodostaa yksinkertaisen tietokannan jollakin tietokannan hallintaohjelmistolla.

**Arvosana 5**
Opiskelija osaa suunnitella ja rakentaa 3. normaalimuodossa olevan relaatiotietokannan annetusta kohteesta ja noudattaa työssä annettuja teoreettisia sääntöjä.
Opiskelija osaa suorittaa vaativiakin hakuja tietokannasta sql-lausein.
Opiskelija hallitsee tietokannan päivittämisen sql-lausein.

----------> [01: Jupyterhub ympäristön käyttöönotto](/01_jupyterhub_ympariston_kayttoonotto/)
